(* ::Package:: *)
(* :Title: LieART`BranchingRules *)
(* :Author: Robert Feger *)
(* :Summary: *)
(* :Context:   LieART`BranchingRules` *)
(* :Package version:   1.1.5 *)
(* :Copyright:  Copyright 2012-2014, Robert Feger. *)

(*This file is part of LieART. See LieART.m for licensing information*) 

BeginPackage["LieART`"]

{U,A,B,C,D,F4,G2,E6,E7,E8,
Algebra,ProductAlgebra,
ProductIrrep,Irrep,
SpecialSubalgebra,
NonSemiSimpleSubalgebra,
NonMaximalSubalgebra,
SemiSimpleSubalgebra,
ReverseOrderSimpleRoots}

ProjectionMatrix::usage = "ProjectionMatrix  "

EndPackage[]


BeginPackage["LieART`BranchingRules`",{"LieART`"}]


Begin["`Private`"]

(* ::Section:: *)
(* Regular Subalgebras *)

(* ::Subsection:: *)
(* Semi-Simple Subalgebras *)

(* ::Subsubsection:: *)
(* A_n *)

(* ::Subsubsection:: *)
(* B_n *)
ProjectionMatrix[origin:Algebra[B][3] ,ProductAlgebra[Algebra[A][1],Algebra[A][1],Algebra[A][1]]]    := SemiSimpleSubalgebra[origin, 2]
ProjectionMatrix[origin:Algebra[B][3] ,ProductAlgebra[Algebra[A][3]]]                                := Permute[SemiSimpleSubalgebra[origin, 3],Cycles[{{2,3}}]]
ProjectionMatrix[origin:Algebra[B][4],ProductAlgebra[Algebra[A][3],Algebra[A][1]]]                   := Permute[SemiSimpleSubalgebra[origin, 3],Cycles[{{2,3}}]]
ProjectionMatrix[origin:Algebra[B][n_],ProductAlgebra[Algebra[A][3],Algebra[B][m_]]]                 := Permute[SemiSimpleSubalgebra[origin, 3],Cycles[{{2,3}}]] /; m==(n-3)&&n>=6
ProjectionMatrix[origin:Algebra[B][n_],ProductAlgebra[Algebra[D][n_]]]                               := ReverseOrderSimpleRoots[SemiSimpleSubalgebra[origin, -1],n] /; n>=4

(* ::Subsubsection:: *)
(* C_n *)

(* ::Subsubsection:: *)
(* D_n *)
ProjectionMatrix[origin:Algebra[D][5] ,ProductAlgebra[Algebra[A][1],Algebra[A][1],Algebra[A][3]]]   := Permute[SemiSimpleSubalgebra[origin, 2],Cycles[{{3,4}}]]
ProjectionMatrix[origin:Algebra[D][n_] ,ProductAlgebra[Algebra[A][1],Algebra[A][1],Algebra[D][m_]]] := SemiSimpleSubalgebra[origin, 2] /; m==(n-2)&&n>=3
ProjectionMatrix[origin:Algebra[D][n_] ,ProductAlgebra[Algebra[D][m_],Algebra[D][k_]]]              := ReverseOrderSimpleRoots[SemiSimpleSubalgebra[origin, m],m] /; m==(n-k)&&n>=6

(* ::Subsubsection:: *)
(* E_6 *)
ProjectionMatrix[origin:E6 ,ProductAlgebra[Algebra[A][2],Algebra[A][2],Algebra[A][2]]] := SemiSimpleSubalgebra[origin, 3]
ProjectionMatrix[origin:E6 ,ProductAlgebra[Algebra[A][5],Algebra[A][1]]]               := SemiSimpleSubalgebra[origin, 6]

(* ::Subsubsection:: *)
(* E_7 *)
ProjectionMatrix[origin:E7,ProductAlgebra[Algebra[A][7]]]    := SemiSimpleSubalgebra[origin,7]
ProjectionMatrix[origin:E7,ProductAlgebra[Algebra[D][6],Algebra[A][1]]]    := Permute[SemiSimpleSubalgebra[origin,5],Cycles[{{5,6,7}}]]
ProjectionMatrix[origin:E7,ProductAlgebra[Algebra[A][5],Algebra[A][2]]]    := Permute[SemiSimpleSubalgebra[origin,4],Cycles[{{5,6,7}}]]
(* ::Subsubsection:: *)
(* E_8 *)
ProjectionMatrix[origin:E8,ProductAlgebra[Algebra[A][8]]]    := SemiSimpleSubalgebra[origin,8]
ProjectionMatrix[origin:E8,ProductAlgebra[E7,Algebra[A][1]]] := Permute[SemiSimpleSubalgebra[origin,7],Cycles[{{7, 8}}]]
ProjectionMatrix[origin:E8,ProductAlgebra[E6,Algebra[A][2]]] := Permute[SemiSimpleSubalgebra[origin,6],Cycles[{{6, 8}}]]
ProjectionMatrix[origin:E8,ProductAlgebra[Algebra[A][4],Algebra[A][4]]] := Permute[SemiSimpleSubalgebra[origin,4],Cycles[{{4, 5, 6, 7, 8}}]]
ProjectionMatrix[origin:E8,ProductAlgebra[Algebra[D][8]]]    := Permute[ReverseOrderSimpleRoots[SemiSimpleSubalgebra[origin,1],7],Cycles[{{7,8}}]]

(* ::Subsubsection:: *)
(* F_4 *)

(* ::Subsubsection:: *)
(* G_2 *)
ProjectionMatrix[origin:G2,ProductAlgebra[Algebra[A][2]]] := SemiSimpleSubalgebra[origin,1]
ProjectionMatrix[origin:G2,ProductAlgebra[Algebra[A][1],Algebra[A][1]]] := SemiSimpleSubalgebra[origin,2]

(* ::Section:: *)
(* Non-Semi-Simple Subalgebras *)

(* ::Subsubsection:: *)
(* A_n *)
ProjectionMatrix[origin:Algebra[A][n_],ProductAlgebra[Algebra[A][m_],Algebra[A][k_],Algebra[U][1]]] := NonSemiSimpleSubalgebra[origin,-k-1] /; m==(n-k-1)
ProjectionMatrix[origin:Algebra[A][n_],ProductAlgebra[Algebra[A][m_],Algebra[U][1]]] := NonSemiSimpleSubalgebra[origin,-1] /; m==(n-1)&&n>=2
ProjectionMatrix[origin:Algebra[A][1], ProductAlgebra[Algebra[U][1]]] := NonSemiSimpleSubalgebra[origin,1]

(* ::Subsubsection:: *)
(* B_n *)
ProjectionMatrix[origin:Algebra[B][n_],ProductAlgebra[Algebra[B][m_],Algebra[U][1]]] := NonSemiSimpleSubalgebra[origin,-1] /; m==(n-1)&&n>=3

(* ::Subsubsection:: *)
(* C_n *)

(* ::Subsubsection:: *)
(* D_n *)
ProjectionMatrix[origin:Algebra[D][n_],ProductAlgebra[Algebra[D][m_],Algebra[U][1]]] := NonSemiSimpleSubalgebra[origin,-2] /; m==(n-1)&&n>=5
ProjectionMatrix[origin:Algebra[D][n_],ProductAlgebra[Algebra[A][m_],Algebra[U][1]]] := NonSemiSimpleSubalgebra[origin,-2] /; m==(n-1)&&n>=3

(* ::Subsubsection:: *)
(* E_6 *)
ProjectionMatrix[origin:E6,ProductAlgebra[Algebra[D][5],Algebra[U][1]]] := NonSemiSimpleSubalgebra[origin,5]

(* ::Subsubsection:: *)
(* E_7 *)
ProjectionMatrix[origin:E7,ProductAlgebra[E6,Algebra[U][1]]] := NonSemiSimpleSubalgebra[origin,6]


(* ::Subsection:: *)
(* Non-Maximal Subalgebras *)

(* ::Subsubsection:: *)
(* A_n *)
ProjectionMatrix[origin:Algebra[A][n_],ProductAlgebra[Algebra[A][m_],Algebra[A][k_]]] := NonMaximalSubalgebra[origin,{m+1}] /; m==(n-k-1)&&n>=3
ProjectionMatrix[origin:Algebra[A][n_],ProductAlgebra[Algebra[A][m_]]] := NonMaximalSubalgebra[origin,{m+1,n}] /; m<n&&n>=2

(* ::Subsubsection:: *)
(* B_n *)

(* ::Subsubsection:: *)
(* C_n *)

(* ::Subsubsection:: *)
(* D_n *)

(* ::Section:: *)
(* Special Subalgebras *)

(* ::Subsection:: *)
(* A_n *)
ProjectionMatrix[origin:Algebra[A][5],ProductAlgebra[Algebra[A][3]]] :=  SpecialSubalgebra[origin,{ProductIrrep[Irrep[A][0,1,0]]}]
ProjectionMatrix[origin:Algebra[A][6],ProductAlgebra[Algebra[B][3]]] :=  SpecialSubalgebra[origin,{ProductIrrep[Irrep[B][1,0,0]]}]

(* ::Subsection:: *)
(* B_n *)
ProjectionMatrix[origin:Algebra[B][3] ,ProductAlgebra[G2]] := SpecialSubalgebra[origin, {ProductIrrep[Irrep[G2][0,0]],ProductIrrep[Irrep[G2][1,0]]}]

(* ::Subsection:: *)
(* C_n *)

(* ::Subsection:: *)
(* D_n *)
ProjectionMatrix[origin:Algebra[D][5] ,ProductAlgebra[Algebra[A][1],Algebra[B][3]]] :=  SpecialSubalgebra[origin, {ProductIrrep[Irrep[A][1],Irrep[B][0,0,1]]}]
ProjectionMatrix[origin:Algebra[D][5] ,ProductAlgebra[Algebra[B][4]]] :=  SpecialSubalgebra[origin, {ProductIrrep[Irrep[B][0,0,0,1]]}]
ProjectionMatrix[origin:Algebra[D][4] ,ProductAlgebra[Algebra[B][3]]] :=  SpecialSubalgebra[origin, {ProductIrrep[Irrep[B][0,0,0]],ProductIrrep[Irrep[B][1,0,0]]}]

(* ::Subsubsection:: *)
(* G_2 *)
ProjectionMatrix[origin:G2,ProductAlgebra[Algebra[A][1]]] := SpecialSubalgebra[origin, {ProductIrrep[Irrep[A][6]]}]

End[]
EndPackage[]
