(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     19041,        671]
NotebookOptionsPosition[     14502,        526]
NotebookOutlinePosition[     16684,        583]
CellTagsIndexPosition[     16599,        578]
WindowTitle->Algebra - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["LIE A R T SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"LieART: Lie Algebras and Representation Theory\"\>":>
       Documentation`HelpLookup["paclet:LieART/guide/LieART"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"LieART/ref/Algebra\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["LieART/ref/Algebra"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/LieART/ref/Algebra.\
html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", "LieART/ref/Algebra",
              ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell["Algebra", "ObjectName",
 CellID->1224892054],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{
       RowBox[{"Algebra", "[", 
        StyleBox["algebraClass", "TI"], "]"}], "[", 
       StyleBox["n", "TI"], "]"}]], "InlineFormula"],
     " \[LineSeparator]represents a classical algebra of the type ",
     Cell[BoxData[
      StyleBox["algebraClass", "TI"]], "InlineFormula"],
     ", which can only be ",
     Cell[BoxData[
      ButtonBox["A",
       BaseStyle->"Link",
       ButtonData->"paclet:LieART/ref/A"]], "InlineFormula"],
     ", ",
     Cell[BoxData[
      ButtonBox["B",
       BaseStyle->"Link",
       ButtonData->"paclet:LieART/ref/B"]], "InlineFormula"],
     ", ",
     Cell[BoxData[
      ButtonBox["C",
       BaseStyle->"Link",
       ButtonData->"paclet:ref/C"]], "InlineFormula"],
     " or ",
     Cell[BoxData[
      ButtonBox["D",
       BaseStyle->"Link",
       ButtonData->"paclet:ref/D"]], "InlineFormula"],
     ", with rank ",
     Cell[BoxData[
      StyleBox["n", "TI"]], "InlineFormula"],
     "."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Algebra", "[", 
       StyleBox["expr", "TI"], "]"}]], "InlineFormula"],
     "\[LineSeparator]gives the algebra (classical or exceptional) of ",
     Cell[BoxData[
      StyleBox["expr", "TI"]], "InlineFormula"],
     ", which may be an irrep, a weight or a root in any basis."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1722758894],

Cell[TextData[{
 "The classical algebras can be entered by short forms like ",
 Cell[BoxData[
  ButtonBox["A5",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/A5"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["B3",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/B3"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["C4",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/C4"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["D6",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/D6"]], "InlineFormula"],
 " in Dynkin classification or by the according traditional names: ",
 Cell[BoxData[
  ButtonBox["SU6",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/SU6"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["SO7",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/SO7"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["Sp8",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/Sp8"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["SO12",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/SO12"]], "InlineFormula"],
 ". They are transformed to the internal form of ",
 Cell[BoxData["Algebra"], "InlineFormula"],
 "[",
 Cell[BoxData[
  StyleBox["algebraClass", "TI"]], "InlineFormula"],
 "][",
 Cell[BoxData[
  StyleBox["n", "TI"]], "InlineFormula"],
 "]."
}], "Notes",
 CellID->1067943069],

Cell[TextData[{
 "The exceptional algebras can be specified and are internally represented by \
",
 Cell[BoxData[
  ButtonBox["E6",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/E6"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["E7",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/E7"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["E8",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/E8"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["F4",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/F4"]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["G2",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/G2"]], "InlineFormula"],
 ". "
}], "Notes",
 CellID->188651248]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->1262406246],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1635070490],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<LieART`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->710848984],

Cell["\<\
Classical Lie algebras can be entered in three different ways, which all \
evaluate to their unique internal representation: by the traditional name, by \
their Dynkin classification or by the internal representation:\
\>", "ExampleText",
 CellID->1130625142],

Cell[CellGroupData[{

Cell["{SU5, A4, Algebra[A][4]}//InputForm", "Input",
 CellLabel->"In[2]:=",
 CellID->374209575],

Cell["\<\
{Algebra[A][4], Algebra[A][4], 
 Algebra[A][4]}\
\>", "Output",
 ImageSize->{196, 29},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]//InputForm=",
 CellID->1045371982]
}, Open  ]],

Cell[TextData[{
 "The traditional name is displayed in ",
 Cell[BoxData[
  ButtonBox["TraditionalForm",
   BaseStyle->"Link",
   ButtonData->"paclet:ref/TraditionalForm"]], "InlineFormula"],
 ":"
}], "ExampleText",
 CellID->1683945556],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"B4", "//", "TraditionalForm"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1102988212],

Cell[BoxData[
 FormBox["\<\"SO(9)\"\>", TraditionalForm]], "Output",
 ImageSize->{42, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]//TraditionalForm=",
 CellID->1358985342]
}, Open  ]],

Cell[TextData[{
 "The Dynkin classification is displayed in ",
 Cell[BoxData[
  ButtonBox["StandardForm",
   BaseStyle->"Link",
   ButtonData->"paclet:ref/StandardForm"]], "InlineFormula"],
 ":"
}], "ExampleText",
 CellID->1943478325],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SO10", "//", "StandardForm"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->946437725],

Cell[BoxData[
 SubscriptBox["D", "5"]], "Output",
 ImageSize->{22, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]//StandardForm=",
 CellID->403022685]
}, Open  ]],

Cell["\<\
The input and internal representation of exceptional algebras is the same and \
the display forms are nearly the same:\
\>", "ExampleText",
 CellID->592460448],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"InputForm", "[", "#", "]"}], ",", 
     RowBox[{"StandardForm", "[", "#", "]"}], ",", 
     RowBox[{"TraditionalForm", "[", "#", "]"}]}], "}"}], "&"}], "@", 
  RowBox[{"{", 
   RowBox[{
   "E6", ",", " ", "E7", ",", " ", "E8", ",", " ", "F4", ",", " ", "G2"}], 
   "}"}]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->1896998050],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{"{", 
       RowBox[{
       "E6", ",", " ", "E7", ",", " ", "E8", ",", " ", "F4", ",", " ", "G2"}],
        "}"}],
      ShowStringCharacters->True,
      NumberMarks->True],
     InputForm[{LieART`E6, LieART`E7, LieART`E8, LieART`F4, LieART`G2}],
     AutoDelete->True,
     Editable->True], ",", 
    TagBox[
     FormBox[
      RowBox[{"{", 
       RowBox[{
        SubscriptBox["\<\"E\"\>", "6"], ",", 
        SubscriptBox["\<\"E\"\>", "7"], ",", 
        SubscriptBox["\<\"E\"\>", "8"], ",", 
        SubscriptBox["\<\"F\"\>", "4"], ",", 
        SubscriptBox["\<\"G\"\>", "2"]}], "}"}],
      StandardForm],
     StandardForm,
     Editable->True], ",", 
    TagBox[
     FormBox[
      RowBox[{"{", 
       RowBox[{
        FormBox[
         SubscriptBox["\<\"E\"\>", "6"],
         TraditionalForm], ",", 
        FormBox[
         SubscriptBox["\<\"E\"\>", "7"],
         TraditionalForm], ",", 
        FormBox[
         SubscriptBox["\<\"E\"\>", "8"],
         TraditionalForm], ",", 
        FormBox[
         SubscriptBox["\<\"F\"\>", "4"],
         TraditionalForm], ",", 
        FormBox[
         SubscriptBox["\<\"G\"\>", "2"],
         TraditionalForm]}], "}"}],
      TraditionalForm],
     TraditionalForm,
     Editable->True]}], "}"}], TraditionalForm]], "Output",
 ImageSize->{47, 351},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->1765932285]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->1236776790],

Cell["Detrmining the algebra of irreps, weights or roots:", "ExampleText",
 CellID->594227912],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Algebra", "[", 
  RowBox[{
   RowBox[{"Irrep", "[", "A", "]"}], "[", 
   RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "]"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->548937018],

Cell[BoxData[
 FormBox["\<\"SU(5)\"\>", TraditionalForm]], "Output",
 ImageSize->{42, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->2137705729]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Algebra", "[", 
  RowBox[{
   RowBox[{"Weight", "[", "A", "]"}], "[", 
   RowBox[{"0", ",", "2", ",", "0", ",", 
    RowBox[{"-", "1"}]}], "]"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1137940052],

Cell[BoxData[
 FormBox["\<\"SU(5)\"\>", TraditionalForm]], "Output",
 ImageSize->{42, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1934014758]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Algebra", "[", 
  RowBox[{
   RowBox[{"RootOmega", "[", "B", "]"}], "[", 
   RowBox[{"2", ",", 
    RowBox[{"-", "1"}], ",", "0", ",", "0"}], "]"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->239500382],

Cell[BoxData[
 FormBox["\<\"SO(9)\"\>", TraditionalForm]], "Output",
 ImageSize->{42, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->634942584]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["LieART: Lie Algebras and Representation Theory",
 BaseStyle->"Link",
 ButtonData->"paclet:LieART/guide/LieART"]], "MoreAbout",
 CellID->288335744]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Algebra - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "LieART: Lie Algebras and Representation Theory", ButtonData -> 
         "paclet:LieART/guide/LieART", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "Metadata" -> {
   "built" -> "{2014, 8, 6, 10, 23, 18.520964}", 
    "history" -> {"0.9", "", "", ""}, "context" -> "LieART`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Lie A R T Symbol", "language" -> "en", "paclet" -> "LieART", "status" -> 
    "None", "summary" -> 
    "Algebra[algebraClass][n] represents a classical algebra of the type \
algebraClass, which can only be A, B, C or D, with rank n.Algebra[expr] gives \
the algebra (classical or exceptional) of expr, which may be an irrep, a \
weight or a root in any basis.", "synonyms" -> {}, "title" -> "Algebra", 
    "titlemodifier" -> "", "windowtitle" -> "Algebra", "type" -> "Symbol", 
    "uri" -> "LieART/ref/Algebra"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"9.0 for Linux x86 (64-bit) (February 7, 2013)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "9.0 for Linux x86 (64-bit) (February 7, 2013)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[7368, 243, 491, 14, 29, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->1262406246]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 16455, 571}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[600, 21, 2320, 54, 49, "AnchorBarGrid",
 CellID->1],
Cell[2923, 77, 50, 1, 42, "ObjectName",
 CellID->1224892054],
Cell[CellGroupData[{
Cell[2998, 82, 1556, 49, 165, "Usage",
 CellID->982511436],
Cell[CellGroupData[{
Cell[4579, 135, 610, 18, 42, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1722758894],
Cell[5192, 155, 1386, 51, 70, "Notes",
 CellID->1067943069],
Cell[6581, 208, 738, 29, 70, "Notes",
 CellID->188651248]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7368, 243, 491, 14, 29, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->1262406246],
Cell[CellGroupData[{
Cell[7884, 261, 196, 6, 25, "ExampleSection",
 CellID->1635070490],
Cell[8083, 269, 115, 3, 28, "Input",
 CellID->710848984],
Cell[8201, 274, 269, 5, 64, "ExampleText",
 CellID->1130625142],
Cell[CellGroupData[{
Cell[8495, 283, 95, 2, 26, "Input",
 CellID->374209575],
Cell[8593, 287, 216, 8, 63, "Output",
 CellID->1045371982]
}, Open  ]],
Cell[8824, 298, 235, 8, 35, "ExampleText",
 CellID->1683945556],
Cell[CellGroupData[{
Cell[9084, 310, 109, 3, 26, "Input",
 CellID->1102988212],
Cell[9196, 315, 216, 6, 50, "Output",
 CellID->1358985342]
}, Open  ]],
Cell[9427, 324, 234, 8, 35, "ExampleText",
 CellID->1943478325],
Cell[CellGroupData[{
Cell[9686, 336, 107, 3, 187, "Input",
 CellID->946437725],
Cell[9796, 341, 193, 6, 50, "Output",
 CellID->403022685]
}, Open  ]],
Cell[10004, 350, 169, 4, 394, "ExampleText",
 CellID->592460448],
Cell[CellGroupData[{
Cell[10198, 358, 406, 13, 693, "Input",
 CellID->1896998050],
Cell[10607, 373, 1524, 53, 372, "Output",
 CellID->1765932285]
}, Open  ]],
Cell[CellGroupData[{
Cell[12168, 431, 126, 3, 7, "ExampleDelimiter",
 CellID->1236776790],
Cell[12297, 436, 94, 1, 169, "ExampleText",
 CellID->594227912],
Cell[CellGroupData[{
Cell[12416, 441, 208, 6, 208, "Input",
 CellID->548937018],
Cell[12627, 449, 199, 6, 37, "Output",
 CellID->2137705729]
}, Open  ]],
Cell[CellGroupData[{
Cell[12863, 460, 230, 7, 241, "Input",
 CellID->1137940052],
Cell[13096, 469, 199, 6, 37, "Output",
 CellID->1934014758]
}, Open  ]],
Cell[CellGroupData[{
Cell[13332, 480, 232, 7, 305, "Input",
 CellID->239500382],
Cell[13567, 489, 198, 6, 37, "Output",
 CellID->634942584]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[13838, 503, 448, 13, 77, "MoreAboutSection",
 CellID->38303248],
Cell[14289, 518, 171, 3, 153, "MoreAbout",
 CellID->288335744]
}, Open  ]],
Cell[14475, 524, 23, 0, 44, "FooterCell"]
}
]
*)

(* End of internal cache information *)

