(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     25368,        865]
NotebookOptionsPosition[     20406,        709]
NotebookOutlinePosition[     22415,        764]
CellTagsIndexPosition[     22330,        759]
WindowTitle->CartanMatrix - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["LIE A R T SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"MetricTensor\"\>":>
       Documentation`HelpLookup[
       "paclet:LieART/ref/MetricTensor"], "\<\"Algebra\"\>":>
       Documentation`HelpLookup["paclet:LieART/ref/Algebra"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"LieART: Lie Algebras and Representation Theory\"\>":>
       Documentation`HelpLookup["paclet:LieART/guide/LieART"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"LieART/ref/CartanMatrix\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["LieART/ref/CartanMatrix"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/LieART/ref/\
CartanMatrix.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "LieART/ref/CartanMatrix", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell["CartanMatrix", "ObjectName",
 CellID->1224892054],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"CartanMatrix", "[", 
       StyleBox["algebra", "TI"], "]"}]], "InlineFormula"],
     " \[LineSeparator]gives the Cartan matrix of ",
     Cell[BoxData[
      StyleBox["algebra", "TI"]], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->281141794],

Cell[TextData[{
 "A classical ",
 Cell[BoxData[
  StyleBox["algebra", "TI"]], "InlineFormula"],
 " may be entered in Dynkin classification, e.g. ",
 Cell[BoxData[
  ButtonBox["A3",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/A3"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["C3",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/C3"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["D4",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/D4"]], "InlineFormula"],
 " or with traditional names, e.g. ",
 Cell[BoxData[
  ButtonBox["SU4",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/SU4"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["Sp6",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/Sp6"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["SO8",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/SO8"]], "InlineFormula"],
 ", or in the internal notation ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    ButtonBox["Algebra",
     BaseStyle->"Link",
     ButtonData->"paclet:LieART/ref/Algebra"], "[", 
    ButtonBox["A",
     BaseStyle->"Link",
     ButtonData->"paclet:LieART/ref/A"], "]"}], "[", "3", "]"}]], 
  "InlineFormula"],
 ", ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    ButtonBox["Algebra",
     BaseStyle->"Link",
     ButtonData->"paclet:LieART/ref/Algebra"], "[", 
    ButtonBox["C",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/C"], "]"}], "[", "3", "]"}]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    ButtonBox["Algebra",
     BaseStyle->"Link",
     ButtonData->"paclet:LieART/ref/Algebra"], "[", 
    ButtonBox["D",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/D"], "]"}], "[", "4", "]"}]], "InlineFormula"],
 ". An exceptional algebra can only be entered in one way, namely ",
 Cell[BoxData[
  ButtonBox["E6",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/E6"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["E7",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/E7"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["E8",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/E8"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["F4",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/F4"]], "InlineFormula"],
 " or ",
 Cell[BoxData[
  ButtonBox["G2",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/G2"]], "InlineFormula"],
 "."
}], "Notes",
 CellID->1067943069]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->1164344103],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1263200977],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<LieART`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->667351211],

Cell[CellGroupData[{

Cell["Cartan matrix of all rank 4 classical Lie algebras:", "ExampleText",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->432688663],

Cell[BoxData[
 RowBox[{"CartanMatrix", "[", "A4", "]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellLabel->"In[2]:=",
 CellID->1503630565],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"2", 
      RowBox[{"-", "1"}], "0", "0"},
     {
      RowBox[{"-", "1"}], "2", 
      RowBox[{"-", "1"}], "0"},
     {"0", 
      RowBox[{"-", "1"}], "2", 
      RowBox[{"-", "1"}]},
     {"0", "0", 
      RowBox[{"-", "1"}], "2"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 ImageSize->{116, 73},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->655922515],

Cell[BoxData[
 RowBox[{"CartanMatrix", "[", "B4", "]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellLabel->"In[3]:=",
 CellID->1000317780],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"2", 
      RowBox[{"-", "1"}], "0", "0"},
     {
      RowBox[{"-", "1"}], "2", 
      RowBox[{"-", "1"}], "0"},
     {"0", 
      RowBox[{"-", "1"}], "2", 
      RowBox[{"-", "2"}]},
     {"0", "0", 
      RowBox[{"-", "1"}], "2"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 ImageSize->{117, 73},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->2093013660],

Cell[BoxData[
 RowBox[{"CartanMatrix", "[", "C4", "]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellLabel->"In[4]:=",
 CellID->1089582623],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"2", 
      RowBox[{"-", "1"}], "0", "0"},
     {
      RowBox[{"-", "1"}], "2", 
      RowBox[{"-", "1"}], "0"},
     {"0", 
      RowBox[{"-", "1"}], "2", 
      RowBox[{"-", "1"}]},
     {"0", "0", 
      RowBox[{"-", "2"}], "2"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 ImageSize->{117, 73},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->685133867],

Cell[BoxData[
 RowBox[{"CartanMatrix", "[", "D4", "]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellLabel->"In[5]:=",
 CellID->326623444],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"2", 
      RowBox[{"-", "1"}], "0", "0"},
     {
      RowBox[{"-", "1"}], "2", 
      RowBox[{"-", "1"}], 
      RowBox[{"-", "1"}]},
     {"0", 
      RowBox[{"-", "1"}], "2", "0"},
     {"0", 
      RowBox[{"-", "1"}], "0", "2"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 ImageSize->{116, 73},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->1038915493]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->71220346],

Cell["Cartan matrix of all exceptional Lie algebras :", "ExampleText",
 CellID->1687553946],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CartanMatrix", "[", "E6", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1519463992],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"2", 
      RowBox[{"-", "1"}], "0", "0", "0", "0"},
     {
      RowBox[{"-", "1"}], "2", 
      RowBox[{"-", "1"}], "0", "0", "0"},
     {"0", 
      RowBox[{"-", "1"}], "2", 
      RowBox[{"-", "1"}], "0", 
      RowBox[{"-", "1"}]},
     {"0", "0", 
      RowBox[{"-", "1"}], "2", 
      RowBox[{"-", "1"}], "0"},
     {"0", "0", "0", 
      RowBox[{"-", "1"}], "2", "0"},
     {"0", "0", 
      RowBox[{"-", "1"}], "0", "0", "2"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "Output",
 ImageSize->{168, 111},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->1796238012]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CartanMatrix", "[", "E7", "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1034770548],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"2", 
      RowBox[{"-", "1"}], "0", "0", "0", "0", "0"},
     {
      RowBox[{"-", "1"}], "2", 
      RowBox[{"-", "1"}], "0", "0", "0", "0"},
     {"0", 
      RowBox[{"-", "1"}], "2", 
      RowBox[{"-", "1"}], "0", "0", 
      RowBox[{"-", "1"}]},
     {"0", "0", 
      RowBox[{"-", "1"}], "2", 
      RowBox[{"-", "1"}], "0", "0"},
     {"0", "0", "0", 
      RowBox[{"-", "1"}], "2", 
      RowBox[{"-", "1"}], "0"},
     {"0", "0", "0", "0", 
      RowBox[{"-", "1"}], "2", "0"},
     {"0", "0", 
      RowBox[{"-", "1"}], "0", "0", "0", "2"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "Output",
 ImageSize->{194, 130},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->953715512]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CartanMatrix", "[", "E8", "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->2111439842],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"2", 
      RowBox[{"-", "1"}], "0", "0", "0", "0", "0", "0"},
     {
      RowBox[{"-", "1"}], "2", 
      RowBox[{"-", "1"}], "0", "0", "0", "0", "0"},
     {"0", 
      RowBox[{"-", "1"}], "2", 
      RowBox[{"-", "1"}], "0", "0", "0", 
      RowBox[{"-", "1"}]},
     {"0", "0", 
      RowBox[{"-", "1"}], "2", 
      RowBox[{"-", "1"}], "0", "0", "0"},
     {"0", "0", "0", 
      RowBox[{"-", "1"}], "2", 
      RowBox[{"-", "1"}], "0", "0"},
     {"0", "0", "0", "0", 
      RowBox[{"-", "1"}], "2", 
      RowBox[{"-", "1"}], "0"},
     {"0", "0", "0", "0", "0", 
      RowBox[{"-", "1"}], "2", "0"},
     {"0", "0", 
      RowBox[{"-", "1"}], "0", "0", "0", "0", "2"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "Output",
 ImageSize->{220, 149},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->929331071]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CartanMatrix", "[", "F4", "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->1130387038],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"2", 
      RowBox[{"-", "1"}], "0", "0"},
     {
      RowBox[{"-", "1"}], "2", 
      RowBox[{"-", "2"}], "0"},
     {"0", 
      RowBox[{"-", "1"}], "2", 
      RowBox[{"-", "1"}]},
     {"0", "0", 
      RowBox[{"-", "1"}], "2"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "Output",
 ImageSize->{117, 73},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->1488437492]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CartanMatrix", "[", "G2", "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->667380572],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"2", 
      RowBox[{"-", "1"}]},
     {
      RowBox[{"-", "3"}], "2"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "Output",
 ImageSize->{64, 35},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->883817971]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  StyleBox[
   ButtonBox["MetricTensor",
    BaseStyle->"Link",
    ButtonData->"paclet:LieART/ref/MetricTensor"],
   FontFamily->"Verdana"]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["Algebra",
    BaseStyle->"Link",
    ButtonData->"paclet:LieART/ref/Algebra"],
   FontFamily->"Verdana"]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["LieART: Lie Algebras and Representation Theory",
 BaseStyle->"Link",
 ButtonData->"paclet:LieART/guide/LieART"]], "MoreAbout",
 CellID->61583932]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"CartanMatrix - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "LieART: Lie Algebras and Representation Theory", ButtonData -> 
         "paclet:LieART/guide/LieART", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "Metadata" -> {
   "built" -> "{2014, 8, 6, 10, 23, 25.903764}", 
    "history" -> {"0.9", "", "", ""}, "context" -> "LieART`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Lie A R T Symbol", "language" -> "en", "paclet" -> "LieART", "status" -> 
    "None", "summary" -> 
    "CartanMatrix[algebra] gives the Cartan matrix of algebra.", 
    "synonyms" -> {}, "title" -> "CartanMatrix", "titlemodifier" -> "", 
    "windowtitle" -> "CartanMatrix", "type" -> "Symbol", "uri" -> 
    "LieART/ref/CartanMatrix"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"9.0 for Linux x86 (64-bit) (February 7, 2013)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "9.0 for Linux x86 (64-bit) (February 7, 2013)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6966, 227, 491, 14, 29, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->1164344103]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 22186, 752}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[605, 21, 2666, 62, 49, "AnchorBarGrid",
 CellID->1],
Cell[3274, 85, 55, 1, 42, "ObjectName",
 CellID->1224892054],
Cell[CellGroupData[{
Cell[3354, 90, 476, 15, 86, "Usage",
 CellID->982511436],
Cell[CellGroupData[{
Cell[3855, 109, 609, 18, 42, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->281141794],
Cell[4467, 129, 2450, 92, 70, "Notes",
 CellID->1067943069]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6966, 227, 491, 14, 29, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->1164344103],
Cell[CellGroupData[{
Cell[7482, 245, 196, 6, 25, "ExampleSection",
 CellID->1263200977],
Cell[7681, 253, 115, 3, 28, "Input",
 CellID->667351211],
Cell[CellGroupData[{
Cell[7821, 260, 147, 2, 34, "ExampleText",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->432688663],
Cell[7971, 264, 163, 4, 28, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->1503630565],
Cell[8137, 270, 944, 30, 94, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->655922515],
Cell[9084, 302, 163, 4, 28, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->1000317780],
Cell[9250, 308, 945, 30, 94, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->2093013660],
Cell[10198, 340, 163, 4, 28, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->1089582623],
Cell[10364, 346, 944, 30, 94, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->685133867],
Cell[11311, 378, 162, 4, 45, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->326623444],
Cell[11476, 384, 945, 30, 94, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->1038915493]
}, Open  ]],
Cell[CellGroupData[{
Cell[12458, 419, 124, 3, 7, "ExampleDelimiter",
 CellID->71220346],
Cell[12585, 424, 91, 1, 64, "ExampleText",
 CellID->1687553946],
Cell[CellGroupData[{
Cell[12701, 429, 110, 3, 45, "Input",
 CellID->1519463992],
Cell[12814, 434, 1095, 35, 132, "Output",
 CellID->1796238012]
}, Open  ]],
Cell[CellGroupData[{
Cell[13946, 474, 110, 3, 45, "Input",
 CellID->1034770548],
Cell[14059, 479, 1210, 38, 151, "Output",
 CellID->953715512]
}, Open  ]],
Cell[CellGroupData[{
Cell[15306, 522, 110, 3, 45, "Input",
 CellID->2111439842],
Cell[15419, 527, 1336, 41, 170, "Output",
 CellID->929331071]
}, Open  ]],
Cell[CellGroupData[{
Cell[16792, 573, 110, 3, 45, "Input",
 CellID->1130387038],
Cell[16905, 578, 892, 29, 94, "Output",
 CellID->1488437492]
}, Open  ]],
Cell[CellGroupData[{
Cell[17834, 612, 109, 3, 45, "Input",
 CellID->667380572],
Cell[17946, 617, 728, 23, 56, "Output",
 CellID->883817971]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[18747, 648, 446, 13, 29, "SeeAlsoSection",
 CellID->1255426704],
Cell[19196, 663, 510, 18, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[19743, 686, 448, 13, 29, "MoreAboutSection",
 CellID->38303248],
Cell[20194, 701, 170, 3, 63, "MoreAbout",
 CellID->61583932]
}, Open  ]],
Cell[20379, 707, 23, 0, 44, "FooterCell"]
}
]
*)

(* End of internal cache information *)

