(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     35812,       1281]
NotebookOptionsPosition[     31179,       1133]
NotebookOutlinePosition[     33339,       1190]
CellTagsIndexPosition[     33253,       1185]
WindowTitle->DecomposeIrrep - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["LIE A R T PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Irrep\"\>":>Documentation`HelpLookup[
       "paclet:LieART/ref/Irrep"], "\<\"ProductAlgebra\"\>":>
       Documentation`HelpLookup[
       "paclet:LieART/ref/ProductAlgebra"], "\<\"IrrepPlus\"\>":>
       Documentation`HelpLookup[
       "paclet:LieART/ref/IrrepPlus"], "\<\"DecomposeProduct\"\>":>
       Documentation`HelpLookup["paclet:LieART/ref/DecomposeProduct"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"LieART: Lie Algebras and Representation Theory\"\>":>
       Documentation`HelpLookup["paclet:LieART/guide/LieART"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"LieART/ref/DecomposeIrrep\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["LieART/ref/DecomposeIrrep"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/LieART/ref/\
DecomposeIrrep.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "LieART/ref/DecomposeIrrep", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell["DecomposeIrrep", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"DecomposeIrrep", "[", 
       RowBox[{
        StyleBox["irrep", "TI"], ",", 
        StyleBox["subalgebra", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]Decomposes ",
     StyleBox["irrep", "TI"],
     " to the specified ",
     StyleBox["subalgebra.", "TI"]
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"DecomposeIrrep", "[", 
       RowBox[{
        StyleBox["pirrep", "TI"], ",", 
        StyleBox["subalgebra", "TI"], ",", 
        StyleBox["pos", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]Decompose irrep at position ",
     StyleBox["pos", "TI"],
     " of the product irrep ",
     StyleBox["pirrep.", "TI"]
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->1482990827],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1725599731],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<LieART`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1091779429],

Cell[TextData[{
 "Decompose the ",
 Cell[BoxData[
  OverscriptBox["10", "_"]], "InlineFormula",
  FontWeight->"Bold"],
 " of SU(5) to SU(3)\[CircleTimes]SU(2)\[CircleTimes]U(1):"
}], "ExampleText",
 CellID->442942768],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DecomposeIrrep", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Irrep", "[", "SU5", "]"}], "[", 
    RowBox[{"Bar", "[", "10", "]"}], "]"}], ",", 
   RowBox[{"ProductAlgebra", "[", 
    RowBox[{"SU3", ",", "SU2", ",", "U1"}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1927942982],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{"(", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ")", "\[InvisibleSpace]", 
    FormBox["\<\"(6)\"\>",
     TraditionalForm]}], "+", 
   RowBox[{"(", 
    FormBox[
     StyleBox["3",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ")", "\[InvisibleSpace]", 
    FormBox["\<\"(-4)\"\>",
     TraditionalForm]}], "+", 
   RowBox[{"(", 
    FormBox[
     StyleBox[
      OverscriptBox["3", "_"],
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["2",
      FontWeight->Bold],
     TraditionalForm], ")", "\[InvisibleSpace]", 
    FormBox["\<\"(1)\"\>",
     TraditionalForm]}]}], TraditionalForm]], "Output",
 ImageSize->{208, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->747841944]
}, Open  ]],

Cell[TextData[{
 "Decompose ",
 Cell[BoxData[
  StyleBox["10",
   FontWeight->"Bold"]], "InlineFormula"],
 " and  ",
 Cell[BoxData[
  StyleBox[
   OverscriptBox["5", "_"],
   FontWeight->"Bold"]], "InlineFormula"],
 " and  of SU(5) to SU(3)\[CircleTimes]SU(2)\[CircleTimes]U(1) (",
 Cell[BoxData["DecomposeIrrep"], "InlineFormula"],
 " is ",
 Cell[BoxData[
  ButtonBox["Listable",
   BaseStyle->"Link",
   ButtonData->"paclet:ref/Listable"]], "InlineFormula"],
 "):"
}], "ExampleText",
 CellID->455264099],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DecomposeIrrep", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"Irrep", "[", "SU5", "]"}], "[", "10", "]"}], ",", 
     RowBox[{
      RowBox[{"Irrep", "[", "SU5", "]"}], "[", 
      RowBox[{"Bar", "[", "5", "]"}], "]"}]}], "}"}], ",", 
   RowBox[{"ProductAlgebra", "[", 
    RowBox[{"SU3", ",", "SU2", ",", "U1"}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1949475988],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      FormBox[
       StyleBox[
        OverscriptBox["3", "_"],
        FontWeight->Bold],
       TraditionalForm], ",", 
      FormBox[
       StyleBox["1",
        FontWeight->Bold],
       TraditionalForm], ")", "\[InvisibleSpace]", 
      FormBox["\<\"(4)\"\>",
       TraditionalForm]}], "+", 
     RowBox[{"(", 
      FormBox[
       StyleBox["3",
        FontWeight->Bold],
       TraditionalForm], ",", 
      FormBox[
       StyleBox["2",
        FontWeight->Bold],
       TraditionalForm], ")", "\[InvisibleSpace]", 
      FormBox["\<\"(-1)\"\>",
       TraditionalForm]}], "+", 
     RowBox[{"(", 
      FormBox[
       StyleBox["1",
        FontWeight->Bold],
       TraditionalForm], ",", 
      FormBox[
       StyleBox["1",
        FontWeight->Bold],
       TraditionalForm], ")", "\[InvisibleSpace]", 
      FormBox["\<\"(-6)\"\>",
       TraditionalForm]}]}], ",", 
    RowBox[{
     RowBox[{"(", 
      FormBox[
       StyleBox[
        OverscriptBox["3", "_"],
        FontWeight->Bold],
       TraditionalForm], ",", 
      FormBox[
       StyleBox["1",
        FontWeight->Bold],
       TraditionalForm], ")", "\[InvisibleSpace]", 
      FormBox["\<\"(-2)\"\>",
       TraditionalForm]}], "+", 
     RowBox[{"(", 
      FormBox[
       StyleBox["1",
        FontWeight->Bold],
       TraditionalForm], ",", 
      FormBox[
       StyleBox["2",
        FontWeight->Bold],
       TraditionalForm], ")", "\[InvisibleSpace]", 
      FormBox["\<\"(3)\"\>",
       TraditionalForm]}]}]}], "}"}], TraditionalForm]], "Output",
 ImageSize->{371, 18},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->1121308380]
}, Open  ]],

Cell[TextData[{
 "Decompose ",
 StyleBox["315",
  FontWeight->"Bold"],
 " of SU(9) to SU(5):"
}], "ExampleText",
 CellID->951103915],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DecomposeIrrep", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Irrep", "[", "SU9", "]"}], "[", "315", "]"}], ",", "SU5"}], 
  "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->1447681144],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{"24", "(", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ")"}], "+", 
   RowBox[{"16", "(", 
    FormBox[
     StyleBox["5",
      FontWeight->Bold],
     TraditionalForm], ")"}], "+", 
   RowBox[{"6", "(", 
    FormBox[
     StyleBox[
      OverscriptBox["5", "_"],
      FontWeight->Bold],
     TraditionalForm], ")"}], "+", 
   RowBox[{"4", "(", 
    FormBox[
     StyleBox["10",
      FontWeight->Bold],
     TraditionalForm], ")"}], "+", 
   RowBox[{"4", "(", 
    FormBox[
     StyleBox["24",
      FontWeight->Bold],
     TraditionalForm], ")"}], "+", 
   FormBox[
    StyleBox["45",
     FontWeight->Bold],
    TraditionalForm]}], TraditionalForm]], "Output",
 ImageSize->{278, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->849173035]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->435816950],

Cell[TextData[{
 "Decompose the SU(3) irrep ",
 StyleBox["3",
  FontWeight->"Bold"],
 " of (",
 StyleBox["24",
  FontWeight->"Bold"],
 ",",
 StyleBox["3",
  FontWeight->"Bold"],
 ")(-3) of SU(5)\[CircleTimes]SU(3)\[CircleTimes]U(1) to \
SU(2)\[CircleTimes]U'(1), i.e. SU(5)\[CircleTimes]SU(3)\[CircleTimes]U(1)\
\[Rule]SU(5)\[CircleTimes]SU(2)\[CircleTimes]U'(1)\[CircleTimes]U(1):"
}], "ExampleText",
 CellID->1532918075],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DecomposeIrrep", "[", 
  RowBox[{
   RowBox[{"ProductIrrep", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Irrep", "[", "SU5", "]"}], "[", "24", "]"}], ",", 
     RowBox[{
      RowBox[{"Irrep", "[", "SU3", "]"}], "[", "3", "]"}], ",", 
     RowBox[{
      RowBox[{"Irrep", "[", "U1", "]"}], "[", 
      RowBox[{"-", "3"}], "]"}]}], "]"}], ",", 
   RowBox[{"ProductAlgebra", "[", 
    RowBox[{"SU2", ",", "U1"}], "]"}], ",", "2"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->14782091],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{"(", 
    FormBox[
     StyleBox["24",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ")", "\[InvisibleSpace]", 
    FormBox["\<\"(-2)\"\>",
     TraditionalForm], "\[InvisibleSpace]", 
    FormBox["\<\"(-3)\"\>",
     TraditionalForm]}], "+", 
   RowBox[{"(", 
    FormBox[
     StyleBox["24",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["2",
      FontWeight->Bold],
     TraditionalForm], ")", "\[InvisibleSpace]", 
    FormBox["\<\"(1)\"\>",
     TraditionalForm], "\[InvisibleSpace]", 
    FormBox["\<\"(-3)\"\>",
     TraditionalForm]}]}], TraditionalForm]], "Output",
 ImageSize->{218, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->327225520]
}, Open  ]],

Cell["The same decomposition as above displayed as branching rule:", \
"ExampleText",
 CellID->981618749],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Rule", "[", 
    RowBox[{"#", ",", 
     RowBox[{"DecomposeIrrep", "[", 
      RowBox[{"#", ",", 
       RowBox[{"ProductAlgebra", "[", 
        RowBox[{"SU2", ",", "U1"}], "]"}], ",", "2"}], "]"}]}], "]"}], "&"}], 
  "@", 
  RowBox[{"ProductIrrep", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Irrep", "[", "SU5", "]"}], "[", "24", "]"}], ",", 
    RowBox[{
     RowBox[{"Irrep", "[", "SU3", "]"}], "[", "3", "]"}], ",", 
    RowBox[{
     RowBox[{"Irrep", "[", "U1", "]"}], "[", 
     RowBox[{"-", "3"}], "]"}]}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1838959210],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{"(", 
    FormBox[
     StyleBox["24",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["3",
      FontWeight->Bold],
     TraditionalForm], ")", "\[InvisibleSpace]", 
    FormBox["\<\"(-3)\"\>",
     TraditionalForm]}], "\[Rule]", 
   RowBox[{
    RowBox[{"(", 
     FormBox[
      StyleBox["24",
       FontWeight->Bold],
      TraditionalForm], ",", 
     FormBox[
      StyleBox["2",
       FontWeight->Bold],
      TraditionalForm], ")", "\[InvisibleSpace]", 
     FormBox["\<\"(1)\"\>",
      TraditionalForm], "\[InvisibleSpace]", 
     FormBox["\<\"(-3)\"\>",
      TraditionalForm]}], "+", 
    RowBox[{"(", 
     FormBox[
      StyleBox["24",
       FontWeight->Bold],
      TraditionalForm], ",", 
     FormBox[
      StyleBox["1",
       FontWeight->Bold],
      TraditionalForm], ")", "\[InvisibleSpace]", 
     FormBox["\<\"(-2)\"\>",
      TraditionalForm], "\[InvisibleSpace]", 
     FormBox["\<\"(-3)\"\>",
      TraditionalForm]}]}]}], TraditionalForm]], "Output",
 ImageSize->{311, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1439480684]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Applications",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->258228157],

Cell["\<\
Branching rules for all totally antisymmetric irreps, the so-called basic \
irreps, of SU(9) to SU(5):\
\>", "ExampleText",
 CellID->714389018],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Rule", "[", 
     RowBox[{"#", ",", 
      RowBox[{"DecomposeIrrep", "[", 
       RowBox[{"#", ",", "SU5"}], "]"}]}], "]"}], "&"}], "/@", 
   RowBox[{"BasicIrreps", "[", "SU9", "]"}]}], "//", "TableForm"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1917660181],

Cell[BoxData[
 FormBox[
  TagBox[
   TagBox[GridBox[{
      {
       RowBox[{
        FormBox[
         StyleBox["9",
          FontWeight->Bold],
         TraditionalForm], "\[Rule]", 
        RowBox[{
         RowBox[{"4", "(", 
          FormBox[
           StyleBox["1",
            FontWeight->Bold],
           TraditionalForm], ")"}], "+", 
         FormBox[
          StyleBox["5",
           FontWeight->Bold],
          TraditionalForm]}]}]},
      {
       RowBox[{
        FormBox[
         StyleBox["36",
          FontWeight->Bold],
         TraditionalForm], "\[Rule]", 
        RowBox[{
         RowBox[{"6", "(", 
          FormBox[
           StyleBox["1",
            FontWeight->Bold],
           TraditionalForm], ")"}], "+", 
         RowBox[{"4", "(", 
          FormBox[
           StyleBox["5",
            FontWeight->Bold],
           TraditionalForm], ")"}], "+", 
         FormBox[
          StyleBox["10",
           FontWeight->Bold],
          TraditionalForm]}]}]},
      {
       RowBox[{
        FormBox[
         StyleBox["84",
          FontWeight->Bold],
         TraditionalForm], "\[Rule]", 
        RowBox[{
         FormBox[
          StyleBox[
           OverscriptBox["10", "_"],
           FontWeight->Bold],
          TraditionalForm], "+", 
         RowBox[{"4", "(", 
          FormBox[
           StyleBox["1",
            FontWeight->Bold],
           TraditionalForm], ")"}], "+", 
         RowBox[{"6", "(", 
          FormBox[
           StyleBox["5",
            FontWeight->Bold],
           TraditionalForm], ")"}], "+", 
         RowBox[{"4", "(", 
          FormBox[
           StyleBox["10",
            FontWeight->Bold],
           TraditionalForm], ")"}]}]}]},
      {
       RowBox[{
        FormBox[
         StyleBox["126",
          FontWeight->Bold],
         TraditionalForm], "\[Rule]", 
        RowBox[{
         FormBox[
          StyleBox[
           OverscriptBox["5", "_"],
           FontWeight->Bold],
          TraditionalForm], "+", 
         RowBox[{"4", "(", 
          FormBox[
           StyleBox[
            OverscriptBox["10", "_"],
            FontWeight->Bold],
           TraditionalForm], ")"}], "+", 
         FormBox[
          StyleBox["1",
           FontWeight->Bold],
          TraditionalForm], "+", 
         RowBox[{"4", "(", 
          FormBox[
           StyleBox["5",
            FontWeight->Bold],
           TraditionalForm], ")"}], "+", 
         RowBox[{"6", "(", 
          FormBox[
           StyleBox["10",
            FontWeight->Bold],
           TraditionalForm], ")"}]}]}]},
      {
       RowBox[{
        FormBox[
         StyleBox[
          OverscriptBox["126", "_"],
          FontWeight->Bold],
         TraditionalForm], "\[Rule]", 
        RowBox[{
         RowBox[{"4", "(", 
          FormBox[
           StyleBox[
            OverscriptBox["5", "_"],
            FontWeight->Bold],
           TraditionalForm], ")"}], "+", 
         RowBox[{"6", "(", 
          FormBox[
           StyleBox[
            OverscriptBox["10", "_"],
            FontWeight->Bold],
           TraditionalForm], ")"}], "+", 
         FormBox[
          StyleBox["1",
           FontWeight->Bold],
          TraditionalForm], "+", 
         FormBox[
          StyleBox["5",
           FontWeight->Bold],
          TraditionalForm], "+", 
         RowBox[{"4", "(", 
          FormBox[
           StyleBox["10",
            FontWeight->Bold],
           TraditionalForm], ")"}]}]}]},
      {
       RowBox[{
        FormBox[
         StyleBox[
          OverscriptBox["84", "_"],
          FontWeight->Bold],
         TraditionalForm], "\[Rule]", 
        RowBox[{
         RowBox[{"6", "(", 
          FormBox[
           StyleBox[
            OverscriptBox["5", "_"],
            FontWeight->Bold],
           TraditionalForm], ")"}], "+", 
         RowBox[{"4", "(", 
          FormBox[
           StyleBox[
            OverscriptBox["10", "_"],
            FontWeight->Bold],
           TraditionalForm], ")"}], "+", 
         RowBox[{"4", "(", 
          FormBox[
           StyleBox["1",
            FontWeight->Bold],
           TraditionalForm], ")"}], "+", 
         FormBox[
          StyleBox["10",
           FontWeight->Bold],
          TraditionalForm]}]}]},
      {
       RowBox[{
        FormBox[
         StyleBox[
          OverscriptBox["36", "_"],
          FontWeight->Bold],
         TraditionalForm], "\[Rule]", 
        RowBox[{
         RowBox[{"4", "(", 
          FormBox[
           StyleBox[
            OverscriptBox["5", "_"],
            FontWeight->Bold],
           TraditionalForm], ")"}], "+", 
         FormBox[
          StyleBox[
           OverscriptBox["10", "_"],
           FontWeight->Bold],
          TraditionalForm], "+", 
         RowBox[{"6", "(", 
          FormBox[
           StyleBox["1",
            FontWeight->Bold],
           TraditionalForm], ")"}]}]}]},
      {
       RowBox[{
        FormBox[
         StyleBox[
          OverscriptBox["9", "_"],
          FontWeight->Bold],
         TraditionalForm], "\[Rule]", 
        RowBox[{
         FormBox[
          StyleBox[
           OverscriptBox["5", "_"],
           FontWeight->Bold],
          TraditionalForm], "+", 
         RowBox[{"4", "(", 
          FormBox[
           StyleBox["1",
            FontWeight->Bold],
           TraditionalForm], ")"}]}]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column],
   Function[BoxForm`e$, 
    TableForm[BoxForm`e$]]], TraditionalForm]], "Output",
 ImageSize->{229, 155},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]//TableForm=",
 CellID->887381254]
}, Open  ]],

Cell["\<\
Branching rules for all totally antisymmetric irreps of SU(6) to SU(3)\
\[CircleTimes]SU(3)\[CircleTimes]U(1):\
\>", "ExampleText",
 CellID->1987934892],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Rule", "[", 
     RowBox[{"#", ",", 
      RowBox[{"DecomposeIrrep", "[", 
       RowBox[{"#", ",", 
        RowBox[{"ProductAlgebra", "[", 
         RowBox[{"SU3", ",", "SU3", ",", "U1"}], "]"}]}], "]"}]}], "]"}], 
    "&"}], "/@", 
   RowBox[{"BasicIrreps", "[", "SU6", "]"}]}], "//", "TableForm"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1815917357],

Cell[BoxData[
 FormBox[
  TagBox[
   TagBox[GridBox[{
      {
       RowBox[{
        FormBox[
         StyleBox["6",
          FontWeight->Bold],
         TraditionalForm], "\[Rule]", 
        RowBox[{
         RowBox[{"(", 
          FormBox[
           StyleBox["1",
            FontWeight->Bold],
           TraditionalForm], ",", 
          FormBox[
           StyleBox["3",
            FontWeight->Bold],
           TraditionalForm], ")", "\[InvisibleSpace]", 
          FormBox["\<\"(-1)\"\>",
           TraditionalForm]}], "+", 
         RowBox[{"(", 
          FormBox[
           StyleBox["3",
            FontWeight->Bold],
           TraditionalForm], ",", 
          FormBox[
           StyleBox["1",
            FontWeight->Bold],
           TraditionalForm], ")", "\[InvisibleSpace]", 
          FormBox["\<\"(1)\"\>",
           TraditionalForm]}]}]}]},
      {
       RowBox[{
        FormBox[
         StyleBox["15",
          FontWeight->Bold],
         TraditionalForm], "\[Rule]", 
        RowBox[{
         RowBox[{"(", 
          FormBox[
           StyleBox["1",
            FontWeight->Bold],
           TraditionalForm], ",", 
          FormBox[
           StyleBox[
            OverscriptBox["3", "_"],
            FontWeight->Bold],
           TraditionalForm], ")", "\[InvisibleSpace]", 
          FormBox["\<\"(-2)\"\>",
           TraditionalForm]}], "+", 
         RowBox[{"(", 
          FormBox[
           StyleBox[
            OverscriptBox["3", "_"],
            FontWeight->Bold],
           TraditionalForm], ",", 
          FormBox[
           StyleBox["1",
            FontWeight->Bold],
           TraditionalForm], ")", "\[InvisibleSpace]", 
          FormBox["\<\"(2)\"\>",
           TraditionalForm]}], "+", 
         RowBox[{"(", 
          FormBox[
           StyleBox["3",
            FontWeight->Bold],
           TraditionalForm], ",", 
          FormBox[
           StyleBox["3",
            FontWeight->Bold],
           TraditionalForm], ")", "\[InvisibleSpace]", 
          FormBox["\<\"(0)\"\>",
           TraditionalForm]}]}]}]},
      {
       RowBox[{
        FormBox[
         StyleBox["20",
          FontWeight->Bold],
         TraditionalForm], "\[Rule]", 
        RowBox[{
         RowBox[{"(", 
          FormBox[
           StyleBox["3",
            FontWeight->Bold],
           TraditionalForm], ",", 
          FormBox[
           StyleBox[
            OverscriptBox["3", "_"],
            FontWeight->Bold],
           TraditionalForm], ")", "\[InvisibleSpace]", 
          FormBox["\<\"(-1)\"\>",
           TraditionalForm]}], "+", 
         RowBox[{"(", 
          FormBox[
           StyleBox[
            OverscriptBox["3", "_"],
            FontWeight->Bold],
           TraditionalForm], ",", 
          FormBox[
           StyleBox["3",
            FontWeight->Bold],
           TraditionalForm], ")", "\[InvisibleSpace]", 
          FormBox["\<\"(1)\"\>",
           TraditionalForm]}], "+", 
         RowBox[{"(", 
          FormBox[
           StyleBox["1",
            FontWeight->Bold],
           TraditionalForm], ",", 
          FormBox[
           StyleBox["1",
            FontWeight->Bold],
           TraditionalForm], ")", "\[InvisibleSpace]", 
          FormBox["\<\"(-3)\"\>",
           TraditionalForm]}], "+", 
         RowBox[{"(", 
          FormBox[
           StyleBox["1",
            FontWeight->Bold],
           TraditionalForm], ",", 
          FormBox[
           StyleBox["1",
            FontWeight->Bold],
           TraditionalForm], ")", "\[InvisibleSpace]", 
          FormBox["\<\"(3)\"\>",
           TraditionalForm]}]}]}]},
      {
       RowBox[{
        FormBox[
         StyleBox[
          OverscriptBox["15", "_"],
          FontWeight->Bold],
         TraditionalForm], "\[Rule]", 
        RowBox[{
         RowBox[{"(", 
          FormBox[
           StyleBox[
            OverscriptBox["3", "_"],
            FontWeight->Bold],
           TraditionalForm], ",", 
          FormBox[
           StyleBox[
            OverscriptBox["3", "_"],
            FontWeight->Bold],
           TraditionalForm], ")", "\[InvisibleSpace]", 
          FormBox["\<\"(0)\"\>",
           TraditionalForm]}], "+", 
         RowBox[{"(", 
          FormBox[
           StyleBox["3",
            FontWeight->Bold],
           TraditionalForm], ",", 
          FormBox[
           StyleBox["1",
            FontWeight->Bold],
           TraditionalForm], ")", "\[InvisibleSpace]", 
          FormBox["\<\"(-2)\"\>",
           TraditionalForm]}], "+", 
         RowBox[{"(", 
          FormBox[
           StyleBox["1",
            FontWeight->Bold],
           TraditionalForm], ",", 
          FormBox[
           StyleBox["3",
            FontWeight->Bold],
           TraditionalForm], ")", "\[InvisibleSpace]", 
          FormBox["\<\"(2)\"\>",
           TraditionalForm]}]}]}]},
      {
       RowBox[{
        FormBox[
         StyleBox[
          OverscriptBox["6", "_"],
          FontWeight->Bold],
         TraditionalForm], "\[Rule]", 
        RowBox[{
         RowBox[{"(", 
          FormBox[
           StyleBox[
            OverscriptBox["3", "_"],
            FontWeight->Bold],
           TraditionalForm], ",", 
          FormBox[
           StyleBox["1",
            FontWeight->Bold],
           TraditionalForm], ")", "\[InvisibleSpace]", 
          FormBox["\<\"(-1)\"\>",
           TraditionalForm]}], "+", 
         RowBox[{"(", 
          FormBox[
           StyleBox["1",
            FontWeight->Bold],
           TraditionalForm], ",", 
          FormBox[
           StyleBox[
            OverscriptBox["3", "_"],
            FontWeight->Bold],
           TraditionalForm], ")", "\[InvisibleSpace]", 
          FormBox["\<\"(1)\"\>",
           TraditionalForm]}]}]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column],
   Function[BoxForm`e$, 
    TableForm[BoxForm`e$]]], TraditionalForm]], "Output",
 ImageSize->{321, 96},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]//TableForm=",
 CellID->2076437856]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  StyleBox[
   ButtonBox["Irrep",
    BaseStyle->"Link",
    ButtonData->"paclet:LieART/ref/Irrep"],
   FontFamily->"Verdana"]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["ProductAlgebra",
    BaseStyle->"Link",
    ButtonData->"paclet:LieART/ref/ProductAlgebra"],
   FontFamily->"Verdana"]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["IrrepPlus",
    BaseStyle->"Link",
    ButtonData->"paclet:LieART/ref/IrrepPlus"],
   FontFamily->"Verdana"]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["DecomposeProduct",
    BaseStyle->"Link",
    ButtonData->"paclet:LieART/ref/DecomposeProduct"],
   FontFamily->"Verdana"]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["LieART: Lie Algebras and Representation Theory",
 BaseStyle->"Link",
 ButtonData->"paclet:LieART/guide/LieART"]], "MoreAbout",
 CellID->326369969]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"DecomposeIrrep - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "LieART: Lie Algebras and Representation Theory", ButtonData -> 
         "paclet:LieART/guide/LieART", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "Metadata" -> {
   "built" -> "{2014, 8, 6, 10, 23, 28.624908}", 
    "history" -> {"0.9", "", "", ""}, "context" -> "LieART`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Lie A R T Package Symbol", "language" -> "en", "paclet" -> 
    "LieART Package", "status" -> "None", "summary" -> 
    "DecomposeIrrep[irrep, subalgebra] Decomposes irrep to the specified \
subalgebra.DecomposeIrrep[pirrep, subalgebra, pos] Decompose irrep at \
position pos of the product irrep pirrep.", "synonyms" -> {}, "title" -> 
    "DecomposeIrrep", "titlemodifier" -> "", "windowtitle" -> 
    "DecomposeIrrep", "type" -> "Symbol", "uri" -> 
    "LieART/ref/DecomposeIrrep"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"9.0 for Linux x86 (64-bit) (February 7, 2013)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "9.0 for Linux x86 (64-bit) (February 7, 2013)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4504, 124, 491, 14, 29, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->1482990827]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 33109, 1178}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[607, 21, 2876, 65, 49, "AnchorBarGrid",
 CellID->1],
Cell[3486, 88, 57, 1, 42, "ObjectName",
 CellID->1224892054],
Cell[3546, 91, 933, 29, 148, "Usage",
 CellID->982511436],
Cell[CellGroupData[{
Cell[4504, 124, 491, 14, 29, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->1482990827],
Cell[CellGroupData[{
Cell[5020, 142, 196, 6, 25, "ExampleSection",
 CellID->1725599731],
Cell[5219, 150, 116, 3, 28, "Input",
 CellID->1091779429],
Cell[5338, 155, 217, 7, 35, "ExampleText",
 CellID->442942768],
Cell[CellGroupData[{
Cell[5580, 166, 314, 9, 28, "Input",
 CellID->1927942982],
Cell[5897, 177, 1022, 41, 37, "Output",
 CellID->747841944]
}, Open  ]],
Cell[6934, 221, 505, 19, 51, "ExampleText",
 CellID->455264099],
Cell[CellGroupData[{
Cell[7464, 244, 438, 13, 45, "Input",
 CellID->1949475988],
Cell[7905, 259, 1756, 67, 39, "Output",
 CellID->1121308380]
}, Open  ]],
Cell[9676, 329, 132, 6, 34, "ExampleText",
 CellID->951103915],
Cell[CellGroupData[{
Cell[9833, 339, 206, 7, 28, "Input",
 CellID->1447681144],
Cell[10042, 348, 879, 37, 37, "Output",
 CellID->849173035]
}, Open  ]],
Cell[CellGroupData[{
Cell[10958, 390, 125, 3, 7, "ExampleDelimiter",
 CellID->435816950],
Cell[11086, 395, 422, 14, 64, "ExampleText",
 CellID->1532918075],
Cell[CellGroupData[{
Cell[11533, 413, 516, 15, 62, "Input",
 CellID->14782091],
Cell[12052, 430, 875, 33, 37, "Output",
 CellID->327225520]
}, Open  ]],
Cell[12942, 466, 105, 2, 49, "ExampleText",
 CellID->981618749],
Cell[CellGroupData[{
Cell[13072, 472, 625, 20, 79, "Input",
 CellID->1838959210],
Cell[13700, 494, 1192, 45, 37, "Output",
 CellID->1439480684]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[14953, 546, 274, 8, 26, "ExampleSection",
 CellID->258228157],
Cell[15230, 556, 153, 4, 70, "ExampleText",
 CellID->714389018],
Cell[CellGroupData[{
Cell[15408, 564, 320, 10, 70, "Input",
 CellID->1917660181],
Cell[15731, 576, 6043, 222, 189, "Output",
 CellID->887381254]
}, Open  ]],
Cell[21789, 801, 162, 4, 70, "ExampleText",
 CellID->1987934892],
Cell[CellGroupData[{
Cell[21976, 809, 415, 13, 70, "Input",
 CellID->1815917357],
Cell[22394, 824, 6472, 221, 130, "Output",
 CellID->2076437856]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[28927, 1052, 446, 13, 29, "SeeAlsoSection",
 CellID->1255426704],
Cell[29376, 1067, 1102, 38, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[30515, 1110, 448, 13, 29, "MoreAboutSection",
 CellID->38303248],
Cell[30966, 1125, 171, 3, 18, "MoreAbout",
 CellID->326369969]
}, Open  ]],
Cell[31152, 1131, 23, 0, 44, "FooterCell"]
}
]
*)

(* End of internal cache information *)

