(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     41570,       1625]
NotebookOptionsPosition[     32785,       1336]
NotebookOutlinePosition[     34843,       1391]
CellTagsIndexPosition[     34757,       1386]
WindowTitle->DecomposeProduct - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["LIE A R T PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Irrep\"\>":>Documentation`HelpLookup[
       "paclet:LieART/ref/Irrep"], "\<\"DecomposeIrrep\"\>":>
       Documentation`HelpLookup["paclet:LieART/ref/DecomposeIrrep"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"LieART: Lie Algebras and Representation Theory\"\>":>
       Documentation`HelpLookup["paclet:LieART/guide/LieART"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"LieART/ref/DecomposeProduct\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["LieART/ref/DecomposeProduct"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/LieART/ref/\
DecomposeProduct.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "LieART/ref/DecomposeProduct", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell["DecomposeProduct", "ObjectName",
 CellID->1224892054],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"DecomposeProduct", "[", 
       StyleBox["irreps", "TI"], "]"}]], "InlineFormula"],
     " \[LineSeparator]decomposes the tensor product of two or more ",
     Cell[BoxData[
      StyleBox["irreps", "TI"]], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->406809379],

Cell["The argument can be two or more irreps, separated by commas.", "Notes",
 CellID->1067943069],

Cell[TextData[{
 Cell[BoxData["DecomposeProduct"], "InlineFormula"],
 " is ",
 Cell[BoxData[
  ButtonBox["Listable",
   BaseStyle->"Link",
   ButtonData->"paclet:ref/Listable"]], "InlineFormula"],
 "."
}], "Notes",
 CellID->1128921434]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->537433043],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(4)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->241512502],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<LieART`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->438439806],

Cell[TextData[{
 "Decompose the tensor product",
 StyleBox[" ",
  FontWeight->"Bold"],
 Cell[BoxData[
  OverscriptBox[
   StyleBox["3",
    FontWeight->"Bold"], "_"]], "InlineFormula",
  FontWeight->"Bold"],
 Cell[BoxData[
  RowBox[{"\[CircleTimes]", 
   StyleBox["8",
    FontWeight->"Bold"]}]], "InlineFormula"],
 " of SU(3):"
}], "ExampleText",
 CellID->1430555461],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DecomposeProduct", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Irrep", "[", "SU3", "]"}], "[", "8", "]"}], ",", 
   RowBox[{
    RowBox[{"Irrep", "[", "SU3", "]"}], "[", "8", "]"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->73793984],

Cell[BoxData[
 FormBox[
  RowBox[{
   FormBox[
    StyleBox["1",
     FontWeight->Bold],
    TraditionalForm], "+", 
   RowBox[{"2", "(", 
    FormBox[
     StyleBox["8",
      FontWeight->Bold],
     TraditionalForm], ")"}], "+", 
   FormBox[
    StyleBox["10",
     FontWeight->Bold],
    TraditionalForm], "+", 
   FormBox[
    StyleBox[
     OverscriptBox["10", "_"],
     FontWeight->Bold],
    TraditionalForm], "+", 
   FormBox[
    StyleBox["27",
     FontWeight->Bold],
    TraditionalForm]}], TraditionalForm]], "Output",
 ImageSize->{152, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->824803634]
}, Open  ]],

Cell[TextData[{
 "Internally a sum of irreps is represented by ",
 Cell[BoxData[
  ButtonBox["IrrepPlus",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/IrrepPlus"]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["IrrepTimes",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/IrrepTimes"]], "InlineFormula"],
 ", an analog of the built-in functions ",
 Cell[BoxData[
  ButtonBox["Plus",
   BaseStyle->"Link",
   ButtonData->"paclet:ref/Plus"]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["Times",
   BaseStyle->"Link",
   ButtonData->"paclet:ref/Times"]], "InlineFormula"],
 ":"
}], "ExampleText",
 CellID->1424086680],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", "InputForm"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1351943198],

Cell["\<\
IrrepPlus[Irrep[A][0, 0], IrrepTimes[2, 
  Irrep[A][1, 1]], Irrep[A][3, 0], Irrep[A][0, 3], 
 Irrep[A][2, 2]]\
\>", "Output",
 ImageSize->{283, 44},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]//InputForm=",
 CellID->216568887]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->1717888069],

Cell[TextData[{
 "Decompose more than two irreps, e.g. ",
 Cell[BoxData[
  RowBox[{
   StyleBox["10",
    FontWeight->"Bold"], "\[CircleTimes]", 
   StyleBox["10",
    FontWeight->"Bold"], "\[CircleTimes]", 
   StyleBox["5",
    FontWeight->"Bold"]}]], "InlineFormula"],
 " of SU(5):"
}], "ExampleText",
 CellID->606219231],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DecomposeProduct", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Irrep", "[", "SU5", "]"}], "[", "10", "]"}], ",", 
   RowBox[{
    RowBox[{"Irrep", "[", "SU5", "]"}], "[", "10", "]"}], ",", 
   RowBox[{
    RowBox[{"Irrep", "[", "SU5", "]"}], "[", "5", "]"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->690871647],

Cell[BoxData[
 FormBox[
  RowBox[{
   FormBox[
    StyleBox["1",
     FontWeight->Bold],
    TraditionalForm], "+", 
   RowBox[{"2", "(", 
    FormBox[
     StyleBox["24",
      FontWeight->Bold],
     TraditionalForm], ")"}], "+", 
   RowBox[{"2", "(", 
    FormBox[
     StyleBox["75",
      FontWeight->Bold],
     TraditionalForm], ")"}], "+", 
   FormBox[
    StyleBox["126",
     FontWeight->Bold],
    TraditionalForm], "+", 
   FormBox[
    SuperscriptBox[
     StyleBox["175",
      FontWeight->Bold], "\[Prime]"],
    TraditionalForm]}], TraditionalForm]], "Output",
 ImageSize->{208, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->96363306]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->523532067],

Cell[TextData[{
 "Decomposition of ",
 Cell[BoxData[
  RowBox[{
   StyleBox["27",
    FontWeight->"Bold"], "\[CircleTimes]", 
   StyleBox[
    OverscriptBox["27", "_"],
    FontWeight->"Bold"]}]], "InlineFormula"],
 " of ",
 Cell[BoxData[
  SubscriptBox["E", "6"]], "InlineFormula"],
 ":"
}], "ExampleText",
 CellID->2050807912],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DecomposeProduct", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Irrep", "[", "E6", "]"}], "[", "27", "]"}], ",", 
   RowBox[{
    RowBox[{"Irrep", "[", "E6", "]"}], "[", 
    RowBox[{"Bar", "[", "27", "]"}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1471373309],

Cell[BoxData[
 FormBox[
  RowBox[{
   FormBox[
    StyleBox["1",
     FontWeight->Bold],
    TraditionalForm], "+", 
   FormBox[
    StyleBox["78",
     FontWeight->Bold],
    TraditionalForm], "+", 
   FormBox[
    StyleBox["650",
     FontWeight->Bold],
    TraditionalForm]}], TraditionalForm]], "Output",
 ImageSize->{84, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->152041252]
}, Open  ]],

Cell["Displaying the results with Dynkin labels:", "ExampleText",
 CellID->1330642609],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", "StandardForm"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1042206772],

Cell[BoxData[
 TagBox[
  RowBox[{"\<\"(000000)\"\>", "+", "\<\"(000001)\"\>", 
   "+", "\<\"(100010)\"\>"}],
  DisplayForm]], "Output",
 ImageSize->{207, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]//StandardForm=",
 CellID->736236249]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->1121391907],

Cell[TextData[{
 "Decomposition of irreps of product algebras, e.g. for \
SU(3)\[CircleTimes]SU(2): the decomposition of (",
 Cell[BoxData[
  StyleBox[
   OverscriptBox["3", "_"],
   FontWeight->"Bold"]], "InlineFormula"],
 ",",
 Cell[BoxData[
  StyleBox[
   OverscriptBox["2", "_"],
   FontWeight->"Bold"]], "InlineFormula"],
 ")\[CircleTimes](",
 StyleBox["3",
  FontWeight->"Bold"],
 ",",
 StyleBox["1",
  FontWeight->"Bold"],
 ")\[CircleTimes](",
 StyleBox["1",
  FontWeight->"Bold"],
 ",",
 StyleBox["2",
  FontWeight->"Bold"],
 "):"
}], "ExampleText",
 CellID->1054859714],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DecomposeProduct", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"ProductIrrep", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Irrep", "[", "SU3", "]"}], "[", 
      RowBox[{"Bar", "[", "3", "]"}], "]"}], ",", 
     RowBox[{
      RowBox[{"Irrep", "[", "SU2", "]"}], "[", "2", "]"}]}], "]"}], ",", 
   RowBox[{"ProductIrrep", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Irrep", "[", "SU3", "]"}], "[", "3", "]"}], ",", 
     RowBox[{
      RowBox[{"Irrep", "[", "SU2", "]"}], "[", "1", "]"}]}], "]"}], ",", 
   RowBox[{"ProductIrrep", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Irrep", "[", "SU3", "]"}], "[", "1", "]"}], ",", 
     RowBox[{
      RowBox[{"Irrep", "[", "SU2", "]"}], "[", "2", "]"}]}], "]"}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1640404981],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{"(", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ")"}], "+", 
   RowBox[{"(", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["3",
      FontWeight->Bold],
     TraditionalForm], ")"}], "+", 
   RowBox[{"(", 
    FormBox[
     StyleBox["8",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ")"}], "+", 
   RowBox[{"(", 
    FormBox[
     StyleBox["8",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["3",
      FontWeight->Bold],
     TraditionalForm], ")"}]}], TraditionalForm]], "Output",
 ImageSize->{191, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->857030797]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Yukawa Interaction in ",
   Cell[BoxData[
    FormBox[
     RowBox[{
      SubscriptBox[
       RowBox[{"SU", "(", "3", ")"}], "C"], "\[CircleTimes]", 
      SubscriptBox[
       RowBox[{"SU", "(", "2", ")"}], "L"]}], TraditionalForm]], 
    "InlineFormula"],
   " of the Standard Model",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1004038509],

Cell["Left-handed quark weak doublet:", "ExampleText",
 CellID->1411652314],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"QL", "=", 
  RowBox[{"ProductIrrep", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Irrep", "[", "SU3", "]"}], "[", "3", "]"}], ",", 
    RowBox[{
     RowBox[{"Irrep", "[", "SU2", "]"}], "[", "2", "]"}]}], "]"}]}]], "Input",\

 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellLabel->"In[1]:=",
 CellID->1049088312],

Cell[BoxData[
 FormBox[
  RowBox[{"(", 
   FormBox[
    StyleBox["3",
     FontWeight->Bold],
    TraditionalForm], ",", 
   FormBox[
    StyleBox["2",
     FontWeight->Bold],
    TraditionalForm], ")"}], TraditionalForm]], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 ImageSize->{42, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->751192477]
}, Open  ]],

Cell["Right-handed up-type quark weak singlet:", "ExampleText",
 CellID->1317632675],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UR", "=", 
  RowBox[{"ProductIrrep", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Irrep", "[", "SU3", "]"}], "[", "3", "]"}], ",", 
    RowBox[{
     RowBox[{"Irrep", "[", "SU2", "]"}], "[", "1", "]"}]}], "]"}]}]], "Input",\

 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellLabel->"In[2]:=",
 CellID->2104125260],

Cell[BoxData[
 FormBox[
  RowBox[{"(", 
   FormBox[
    StyleBox["3",
     FontWeight->Bold],
    TraditionalForm], ",", 
   FormBox[
    StyleBox["1",
     FontWeight->Bold],
    TraditionalForm], ")"}], TraditionalForm]], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 ImageSize->{41, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->2106403245]
}, Open  ]],

Cell["Right-handed down-type quark weak singlet:", "ExampleText",
 CellID->54376685],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DR", "=", 
  RowBox[{"ProductIrrep", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Irrep", "[", "SU3", "]"}], "[", "3", "]"}], ",", 
    RowBox[{
     RowBox[{"Irrep", "[", "SU2", "]"}], "[", "1", "]"}]}], "]"}]}]], "Input",\

 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellLabel->"In[3]:=",
 CellID->1105609081],

Cell[BoxData[
 FormBox[
  RowBox[{"(", 
   FormBox[
    StyleBox["3",
     FontWeight->Bold],
    TraditionalForm], ",", 
   FormBox[
    StyleBox["1",
     FontWeight->Bold],
    TraditionalForm], ")"}], TraditionalForm]], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 ImageSize->{41, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->552679576]
}, Open  ]],

Cell["Higgs field as weak doublet:", "ExampleText",
 CellID->591596381],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"H", "=", 
  RowBox[{"ProductIrrep", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Irrep", "[", "SU3", "]"}], "[", "1", "]"}], ",", 
    RowBox[{
     RowBox[{"Irrep", "[", "SU2", "]"}], "[", "2", "]"}]}], "]"}]}]], "Input",\

 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellLabel->"In[4]:=",
 CellID->1235966998],

Cell[BoxData[
 FormBox[
  RowBox[{"(", 
   FormBox[
    StyleBox["1",
     FontWeight->Bold],
    TraditionalForm], ",", 
   FormBox[
    StyleBox["2",
     FontWeight->Bold],
    TraditionalForm], ")"}], TraditionalForm]], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 ImageSize->{42, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->67348726]
}, Open  ]],

Cell["Up-type quark Yukawa interaction:", "ExampleText",
 CellID->981283747],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DecomposeProduct", "[", 
  RowBox[{
   RowBox[{"Bar", "[", "QL", "]"}], ",", "H", ",", "UR"}], "]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellLabel->"In[5]:=",
 CellID->683456920],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{"(", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ")"}], "+", 
   RowBox[{"(", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["3",
      FontWeight->Bold],
     TraditionalForm], ")"}], "+", 
   RowBox[{"(", 
    FormBox[
     StyleBox["8",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ")"}], "+", 
   RowBox[{"(", 
    FormBox[
     StyleBox["8",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["3",
      FontWeight->Bold],
     TraditionalForm], ")"}]}], TraditionalForm]], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 ImageSize->{191, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->1938615868]
}, Open  ]],

Cell["Down-type quark Yukawa interaction:", "ExampleText",
 CellID->1288923307],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DecomposeProduct", "[", 
  RowBox[{
   RowBox[{"Bar", "[", "QL", "]"}], ",", "H", ",", "DR"}], "]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellLabel->"In[6]:=",
 CellID->1520941697],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{"(", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ")"}], "+", 
   RowBox[{"(", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["3",
      FontWeight->Bold],
     TraditionalForm], ")"}], "+", 
   RowBox[{"(", 
    FormBox[
     StyleBox["8",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ")"}], "+", 
   RowBox[{"(", 
    FormBox[
     StyleBox["8",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["3",
      FontWeight->Bold],
     TraditionalForm], ")"}]}], TraditionalForm]], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 ImageSize->{191, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->361290290]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   Cell[BoxData[
    RowBox[{
     InterpretationBox[Cell[TextData[{
       "Yukawa Interaction in Minimal Flavor Violation",
       "\[NonBreakingSpace]\[NonBreakingSpace]",
       Cell["(1)", "ExampleCount"]
      }], "ExampleSection"],
      $Line = 0; Null], " ", 
     RowBox[{"(", "MFV", ")"}]}]]],
   " "
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->167729289],

Cell[TextData[{
 "Fields in MFV flavor group: ",
 Cell[BoxData[
  RowBox[{"SU", 
   RowBox[{
    SubscriptBox[
     RowBox[{"(", "3", ")"}], 
     SubscriptBox["Q", "L"]], "\[CircleTimes]", "SU"}], 
   RowBox[{
    SubscriptBox[
     RowBox[{"(", "3", ")"}], 
     SubscriptBox["U", "R"]], "\[CircleTimes]", "SU"}], 
   SubscriptBox[
    RowBox[{"(", "3", ")"}], 
    SubscriptBox["D", "R"]]}]], "InlineFormula"]
}], "ExampleText",
 CellID->2043795413],

Cell["Left-handed quark weak doublet:", "ExampleText",
 CellID->7079973],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"QL", "=", 
  RowBox[{"ProductIrrep", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Irrep", "[", "SU3", "]"}], "[", "3", "]"}], ",", 
    RowBox[{
     RowBox[{"Irrep", "[", "SU3", "]"}], "[", "1", "]"}], ",", 
    RowBox[{
     RowBox[{"Irrep", "[", "SU3", "]"}], "[", "1", "]"}]}], "]"}]}]], "Input",\

 CellLabel->"In[1]:=",
 CellID->1568770351],

Cell[BoxData[
 FormBox[
  RowBox[{"(", 
   FormBox[
    StyleBox["3",
     FontWeight->Bold],
    TraditionalForm], ",", 
   FormBox[
    StyleBox["1",
     FontWeight->Bold],
    TraditionalForm], ",", 
   FormBox[
    StyleBox["1",
     FontWeight->Bold],
    TraditionalForm], ")"}], TraditionalForm]], "Output",
 ImageSize->{58, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->1565282134]
}, Open  ]],

Cell["Right-handed up-type quark weak singlet:", "ExampleText",
 CellID->1047576380],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UR", "=", 
  RowBox[{"ProductIrrep", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Irrep", "[", "SU3", "]"}], "[", "1", "]"}], ",", 
    RowBox[{
     RowBox[{"Irrep", "[", "SU3", "]"}], "[", "3", "]"}], ",", 
    RowBox[{
     RowBox[{"Irrep", "[", "SU3", "]"}], "[", "1", "]"}]}], "]"}]}]], "Input",\

 CellLabel->"In[2]:=",
 CellID->428292399],

Cell[BoxData[
 FormBox[
  RowBox[{"(", 
   FormBox[
    StyleBox["1",
     FontWeight->Bold],
    TraditionalForm], ",", 
   FormBox[
    StyleBox["3",
     FontWeight->Bold],
    TraditionalForm], ",", 
   FormBox[
    StyleBox["1",
     FontWeight->Bold],
    TraditionalForm], ")"}], TraditionalForm]], "Output",
 ImageSize->{58, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1579145331]
}, Open  ]],

Cell["Right-handed down-type quark weak singlet:", "ExampleText",
 CellID->242744450],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DR", "=", 
  RowBox[{"ProductIrrep", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Irrep", "[", "SU3", "]"}], "[", "1", "]"}], ",", 
    RowBox[{
     RowBox[{"Irrep", "[", "SU3", "]"}], "[", "1", "]"}], ",", 
    RowBox[{
     RowBox[{"Irrep", "[", "SU3", "]"}], "[", "3", "]"}]}], "]"}]}]], "Input",\

 CellLabel->"In[3]:=",
 CellID->177249752],

Cell[BoxData[
 FormBox[
  RowBox[{"(", 
   FormBox[
    StyleBox["1",
     FontWeight->Bold],
    TraditionalForm], ",", 
   FormBox[
    StyleBox["1",
     FontWeight->Bold],
    TraditionalForm], ",", 
   FormBox[
    StyleBox["3",
     FontWeight->Bold],
    TraditionalForm], ")"}], TraditionalForm]], "Output",
 ImageSize->{58, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->185443149]
}, Open  ]],

Cell["Up-Type spurion field:", "ExampleText",
 CellID->1673825721],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Yu", "=", 
  RowBox[{"ProductIrrep", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Irrep", "[", "SU3", "]"}], "[", "3", "]"}], ",", 
    RowBox[{
     RowBox[{"Irrep", "[", "SU3", "]"}], "[", 
     RowBox[{"Bar", "[", "3", "]"}], "]"}], ",", 
    RowBox[{
     RowBox[{"Irrep", "[", "SU3", "]"}], "[", "1", "]"}]}], "]"}]}]], "Input",\

 CellLabel->"In[4]:=",
 CellID->663367950],

Cell[BoxData[
 FormBox[
  RowBox[{"(", 
   FormBox[
    StyleBox["3",
     FontWeight->Bold],
    TraditionalForm], ",", 
   FormBox[
    StyleBox[
     OverscriptBox["3", "_"],
     FontWeight->Bold],
    TraditionalForm], ",", 
   FormBox[
    StyleBox["1",
     FontWeight->Bold],
    TraditionalForm], ")"}], TraditionalForm]], "Output",
 ImageSize->{58, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->480944843]
}, Open  ]],

Cell["Down-Type spurion field:", "ExampleText",
 CellID->694488909],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Yd", "=", 
  RowBox[{"ProductIrrep", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Irrep", "[", "SU3", "]"}], "[", "3", "]"}], ",", 
    RowBox[{
     RowBox[{"Irrep", "[", "SU3", "]"}], "[", "1", "]"}], ",", 
    RowBox[{
     RowBox[{"Irrep", "[", "SU3", "]"}], "[", 
     RowBox[{"Bar", "[", "3", "]"}], "]"}]}], "]"}]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->1196304916],

Cell[BoxData[
 FormBox[
  RowBox[{"(", 
   FormBox[
    StyleBox["3",
     FontWeight->Bold],
    TraditionalForm], ",", 
   FormBox[
    StyleBox["1",
     FontWeight->Bold],
    TraditionalForm], ",", 
   FormBox[
    StyleBox[
     OverscriptBox["3", "_"],
     FontWeight->Bold],
    TraditionalForm], ")"}], TraditionalForm]], "Output",
 ImageSize->{58, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->1921833088]
}, Open  ]],

Cell["Higgs field as flavor singlet:", "ExampleText",
 CellID->1746057026],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"H", "=", 
  RowBox[{"ProductIrrep", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Irrep", "[", "SU3", "]"}], "[", "1", "]"}], ",", 
    RowBox[{
     RowBox[{"Irrep", "[", "SU3", "]"}], "[", "1", "]"}], ",", 
    RowBox[{
     RowBox[{"Irrep", "[", "SU3", "]"}], "[", "1", "]"}]}], "]"}]}]], "Input",\

 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellLabel->"In[6]:=",
 CellID->140260517],

Cell[BoxData[
 FormBox[
  RowBox[{"(", 
   FormBox[
    StyleBox["1",
     FontWeight->Bold],
    TraditionalForm], ",", 
   FormBox[
    StyleBox["1",
     FontWeight->Bold],
    TraditionalForm], ",", 
   FormBox[
    StyleBox["1",
     FontWeight->Bold],
    TraditionalForm], ")"}], TraditionalForm]], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 ImageSize->{58, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->1932507608]
}, Open  ]],

Cell["Up-type quark Yukawa interaction containing a singlet:", "ExampleText",
 CellID->76838759],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DecomposeProduct", "[", 
  RowBox[{
   RowBox[{"Bar", "[", "QL", "]"}], ",", "H", ",", "Yd", ",", "DR"}], 
  "]"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->118988388],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{"(", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ")"}], "+", 
   RowBox[{"(", 
    FormBox[
     StyleBox["8",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ")"}], "+", 
   RowBox[{"(", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["8",
      FontWeight->Bold],
     TraditionalForm], ")"}], "+", 
   RowBox[{"(", 
    FormBox[
     StyleBox["8",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["8",
      FontWeight->Bold],
     TraditionalForm], ")"}]}], TraditionalForm]], "Output",
 ImageSize->{259, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]=",
 CellID->1063066766]
}, Open  ]],

Cell["Down-type quark Yukawa interaction containing a singlet:", "ExampleText",
 CellID->250038003],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DecomposeProduct", "[", 
  RowBox[{
   RowBox[{"Bar", "[", "QL", "]"}], ",", "H", ",", "Yu", ",", "UR"}], 
  "]"}]], "Input",
 CellLabel->"In[8]:=",
 CellID->1439936744],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{"(", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ")"}], "+", 
   RowBox[{"(", 
    FormBox[
     StyleBox["8",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ")"}], "+", 
   RowBox[{"(", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["8",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ")"}], "+", 
   RowBox[{"(", 
    FormBox[
     StyleBox["8",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["8",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ")"}]}], TraditionalForm]], "Output",
 ImageSize->{259, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[8]=",
 CellID->1966293041]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  StyleBox[
   ButtonBox["Irrep",
    BaseStyle->"Link",
    ButtonData->"paclet:LieART/ref/Irrep"],
   FontFamily->"Verdana"]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["DecomposeIrrep",
    BaseStyle->"Link",
    ButtonData->"paclet:LieART/ref/DecomposeIrrep"],
   FontFamily->"Verdana"]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["LieART: Lie Algebras and Representation Theory",
 BaseStyle->"Link",
 ButtonData->"paclet:LieART/guide/LieART"]], "MoreAbout",
 CellID->993359368]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"DecomposeProduct - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "LieART: Lie Algebras and Representation Theory", ButtonData -> 
         "paclet:LieART/guide/LieART", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "Metadata" -> {
   "built" -> "{2014, 8, 6, 10, 23, 31.777329}", 
    "history" -> {"0.9", "", "", ""}, "context" -> "LieART`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Lie A R T Package Symbol", "language" -> "en", "paclet" -> 
    "LieART Package", "status" -> "None", "summary" -> 
    "DecomposeProduct[irreps] decomposes the tensor product of two or more \
irreps.", "synonyms" -> {}, "title" -> "DecomposeProduct", "titlemodifier" -> 
    "", "windowtitle" -> "DecomposeProduct", "type" -> "Symbol", "uri" -> 
    "LieART/ref/DecomposeProduct"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"9.0 for Linux x86 (64-bit) (February 7, 2013)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "9.0 for Linux x86 (64-bit) (February 7, 2013)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4896, 146, 490, 14, 29, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->537433043]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 34614, 1379}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[609, 21, 2682, 61, 49, "AnchorBarGrid",
 CellID->1],
Cell[3294, 84, 59, 1, 42, "ObjectName",
 CellID->1224892054],
Cell[CellGroupData[{
Cell[3378, 89, 496, 15, 86, "Usage",
 CellID->982511436],
Cell[CellGroupData[{
Cell[3899, 108, 609, 18, 42, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->406809379],
Cell[4511, 128, 98, 1, 70, "Notes",
 CellID->1067943069],
Cell[4612, 131, 235, 9, 70, "Notes",
 CellID->1128921434]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[4896, 146, 490, 14, 29, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->537433043],
Cell[CellGroupData[{
Cell[5411, 164, 195, 6, 25, "ExampleSection",
 CellID->241512502],
Cell[5609, 172, 115, 3, 28, "Input",
 CellID->438439806],
Cell[5727, 177, 368, 15, 35, "ExampleText",
 CellID->1430555461],
Cell[CellGroupData[{
Cell[6120, 196, 264, 8, 28, "Input",
 CellID->73793984],
Cell[6387, 206, 662, 29, 37, "Output",
 CellID->824803634]
}, Open  ]],
Cell[7064, 238, 655, 23, 51, "ExampleText",
 CellID->1424086680],
Cell[CellGroupData[{
Cell[7744, 265, 102, 3, 28, "Input",
 CellID->1351943198],
Cell[7849, 270, 277, 9, 78, "Output",
 CellID->216568887]
}, Open  ]],
Cell[CellGroupData[{
Cell[8163, 284, 126, 3, 7, "ExampleDelimiter",
 CellID->1717888069],
Cell[8292, 289, 323, 12, 35, "ExampleText",
 CellID->606219231],
Cell[CellGroupData[{
Cell[8640, 305, 342, 10, 28, "Input",
 CellID->690871647],
Cell[8985, 317, 706, 30, 37, "Output",
 CellID->96363306]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9740, 353, 125, 3, 7, "ExampleDelimiter",
 CellID->523532067],
Cell[9868, 358, 328, 14, 35, "ExampleText",
 CellID->2050807912],
Cell[CellGroupData[{
Cell[10221, 376, 298, 9, 62, "Input",
 CellID->1471373309],
Cell[10522, 387, 438, 19, 35, "Output",
 CellID->152041252]
}, Open  ]],
Cell[10975, 409, 86, 1, 49, "ExampleText",
 CellID->1330642609],
Cell[CellGroupData[{
Cell[11086, 414, 105, 3, 26, "Input",
 CellID->1042206772],
Cell[11194, 419, 280, 9, 50, "Output",
 CellID->736236249]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[11523, 434, 126, 3, 7, "ExampleDelimiter",
 CellID->1121391907],
Cell[11652, 439, 578, 26, 95, "ExampleText",
 CellID->1054859714],
Cell[CellGroupData[{
Cell[12255, 469, 838, 24, 198, "Input",
 CellID->1640404981],
Cell[13096, 495, 974, 43, 37, "Output",
 CellID->857030797]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[14131, 545, 549, 17, 59, "ExampleSection",
 CellID->1004038509],
Cell[14683, 564, 75, 1, 70, "ExampleText",
 CellID->1411652314],
Cell[CellGroupData[{
Cell[14783, 569, 346, 11, 70, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->1049088312],
Cell[15132, 582, 416, 16, 37, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->751192477]
}, Open  ]],
Cell[15563, 601, 84, 1, 70, "ExampleText",
 CellID->1317632675],
Cell[CellGroupData[{
Cell[15672, 606, 346, 11, 70, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->2104125260],
Cell[16021, 619, 417, 16, 37, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->2106403245]
}, Open  ]],
Cell[16453, 638, 84, 1, 70, "ExampleText",
 CellID->54376685],
Cell[CellGroupData[{
Cell[16562, 643, 346, 11, 70, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->1105609081],
Cell[16911, 656, 416, 16, 37, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->552679576]
}, Open  ]],
Cell[17342, 675, 71, 1, 70, "ExampleText",
 CellID->591596381],
Cell[CellGroupData[{
Cell[17438, 680, 345, 11, 70, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->1235966998],
Cell[17786, 693, 415, 16, 37, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->67348726]
}, Open  ]],
Cell[18216, 712, 76, 1, 70, "ExampleText",
 CellID->981283747],
Cell[CellGroupData[{
Cell[18317, 717, 231, 6, 70, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->683456920],
Cell[18551, 725, 1028, 44, 37, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->1938615868]
}, Open  ]],
Cell[19594, 772, 79, 1, 70, "ExampleText",
 CellID->1288923307],
Cell[CellGroupData[{
Cell[19698, 777, 232, 6, 70, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->1520941697],
Cell[19933, 785, 1027, 44, 37, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->361290290]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[21009, 835, 491, 15, 53, "ExampleSection",
 CellID->167729289],
Cell[21503, 852, 452, 16, 70, "ExampleText",
 CellID->2043795413],
Cell[21958, 870, 72, 1, 70, "ExampleText",
 CellID->7079973],
Cell[CellGroupData[{
Cell[22055, 875, 370, 12, 70, "Input",
 CellID->1568770351],
Cell[22428, 889, 446, 19, 37, "Output",
 CellID->1565282134]
}, Open  ]],
Cell[22889, 911, 84, 1, 70, "ExampleText",
 CellID->1047576380],
Cell[CellGroupData[{
Cell[22998, 916, 369, 12, 70, "Input",
 CellID->428292399],
Cell[23370, 930, 446, 19, 37, "Output",
 CellID->1579145331]
}, Open  ]],
Cell[23831, 952, 85, 1, 70, "ExampleText",
 CellID->242744450],
Cell[CellGroupData[{
Cell[23941, 957, 369, 12, 70, "Input",
 CellID->177249752],
Cell[24313, 971, 445, 19, 37, "Output",
 CellID->185443149]
}, Open  ]],
Cell[24773, 993, 66, 1, 70, "ExampleText",
 CellID->1673825721],
Cell[CellGroupData[{
Cell[24864, 998, 402, 13, 70, "Input",
 CellID->663367950],
Cell[25269, 1013, 471, 20, 37, "Output",
 CellID->480944843]
}, Open  ]],
Cell[25755, 1036, 67, 1, 70, "ExampleText",
 CellID->694488909],
Cell[CellGroupData[{
Cell[25847, 1041, 401, 12, 70, "Input",
 CellID->1196304916],
Cell[26251, 1055, 472, 20, 37, "Output",
 CellID->1921833088]
}, Open  ]],
Cell[26738, 1078, 74, 1, 70, "ExampleText",
 CellID->1746057026],
Cell[CellGroupData[{
Cell[26837, 1083, 421, 13, 70, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->140260517],
Cell[27261, 1098, 499, 20, 37, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->1932507608]
}, Open  ]],
Cell[27775, 1121, 96, 1, 70, "ExampleText",
 CellID->76838759],
Cell[CellGroupData[{
Cell[27896, 1126, 192, 6, 70, "Input",
 CellID->118988388],
Cell[28091, 1134, 1319, 59, 37, "Output",
 CellID->1063066766]
}, Open  ]],
Cell[29425, 1196, 99, 1, 70, "ExampleText",
 CellID->250038003],
Cell[CellGroupData[{
Cell[29549, 1201, 193, 6, 70, "Input",
 CellID->1439936744],
Cell[29745, 1209, 1319, 59, 37, "Output",
 CellID->1966293041]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[31125, 1275, 446, 13, 29, "SeeAlsoSection",
 CellID->1255426704],
Cell[31574, 1290, 510, 18, 56, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[32121, 1313, 448, 13, 29, "MoreAboutSection",
 CellID->38303248],
Cell[32572, 1328, 171, 3, 33, "MoreAbout",
 CellID->993359368]
}, Open  ]],
Cell[32758, 1334, 23, 0, 44, "FooterCell"]
}
]
*)

(* End of internal cache information *)

