(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     15795,        538]
NotebookOptionsPosition[     11371,        401]
NotebookOutlinePosition[     13350,        455]
CellTagsIndexPosition[     13265,        450]
WindowTitle->Dim - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["LIE A R T PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"DimName\"\>":>Documentation`HelpLookup[
       "paclet:LieART/ref/DimName"], "\<\"Index\"\>":>
       Documentation`HelpLookup["paclet:LieART/ref/Index"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"LieART: Lie Algebras and Representation Theory\"\>":>
       Documentation`HelpLookup["paclet:LieART/guide/LieART"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"LieART/ref/Dim\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["LieART/ref/Dim"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/LieART/ref/Dim.\
html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, Visible -> 
            False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", "LieART/ref/Dim", 
             ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell["Dim", "ObjectName",
 CellID->1224892054],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Dim", "[", 
       StyleBox["irrep", "TI"], "]"}]], "InlineFormula"],
     " \[LineSeparator]computes the numerical dimension of ",
     Cell[BoxData[
      StyleBox["irrep", "TI"]], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->578987836],

Cell[TextData[{
 Cell[BoxData[
  RowBox[{"Dim", "[", 
   StyleBox["irrep", "TI"], "]"}]], "InlineFormula"],
 " computes the dimension via the Weyl formula."
}], "Notes",
 CellID->1067943069]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->446001340],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1806064551],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<LieART`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->215697746],

Cell["Dimension of the fundamental representation of SU(3):", "ExampleText",
 CellID->1080383830],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dim", "[", 
  RowBox[{
   RowBox[{"Irrep", "[", "A", "]"}], "[", 
   RowBox[{"1", ",", "0"}], "]"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->2094170807],

Cell[BoxData[
 FormBox["3", TraditionalForm]], "Output",
 ImageSize->{12, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1135947014]
}, Open  ]],

Cell[TextData[{
 "Dimension of the spinor representation of SO(10), i.e., ",
 Cell[BoxData[
  SubscriptBox["D", "5"]], "InlineFormula"],
 " in Dynkin classification:"
}], "ExampleText",
 CellID->1121455410],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dim", "[", 
  RowBox[{
   RowBox[{"Irrep", "[", "D", "]"}], "[", 
   RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1"}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->322760841],

Cell[BoxData[
 FormBox["16", TraditionalForm]], "Output",
 ImageSize->{20, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->1722090209]
}, Open  ]],

Cell[TextData[{
 "The adjoint representation of SU(N) is of dimension ",
 Cell[BoxData[
  RowBox[{
   SuperscriptBox["N", "2"], "-", "1"}]], "InlineFormula"],
 ". Example for SU(5):"
}], "ExampleText",
 CellID->666046139],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dim", "[", 
  RowBox[{
   RowBox[{"Irrep", "[", "A", "]"}], "[", 
   RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "]"}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->284957929],

Cell[BoxData[
 FormBox["24", TraditionalForm]], "Output",
 ImageSize->{20, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->1138565868]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["Scope", "ExampleSection",
   WholeCellGroupOpener->True],
  $Line = 0; Null]], "ExampleText",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->1293636265],

Cell["\<\
The irrep does not need to be explicit. Using variables in the Dynkin label \
exhibits the Weyl dimension formula for the associated algebra, e.g., for \
SU(3):\
\>", "ExampleText",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->984115482],

Cell[BoxData[
 RowBox[{"Dim", "[", 
  RowBox[{
   RowBox[{"Irrep", "[", "A", "]"}], "[", 
   RowBox[{"a", ",", "b"}], "]"}], "]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellLabel->"In[5]:=",
 CellID->554780177],

Cell[BoxData[
 FormBox[
  RowBox[{
   FractionBox["1", "2"], " ", 
   RowBox[{"(", 
    RowBox[{"a", "+", "1"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{"b", "+", "1"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{"a", "+", "b", "+", "2"}], ")"}]}], TraditionalForm]], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 ImageSize->{20, 277},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->765457383],

Cell[TextData[{
 "or for SO(6), i.e., ",
 Cell[BoxData[
  SubscriptBox["D", "3"]], "InlineFormula"],
 " in Dynkin classification:"
}], "ExampleText",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->1971770716],

Cell[BoxData[
 RowBox[{
  RowBox[{"Dim", "[", 
   RowBox[{
    RowBox[{"Irrep", "[", "D", "]"}], "[", 
    RowBox[{"a", ",", "b", ",", "c"}], "]"}], "]"}], " "}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellLabel->"In[6]:=",
 CellID->1609349227],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{"1", "/", "12"}], " ", 
   RowBox[{"(", 
    RowBox[{"a", "+", "1"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{"b", "+", "1"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{"c", "+", "1"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{"a", "+", "b", "+", "2"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{"a", "+", "c", "+", "2"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{"a", "+", "b", "+", "c", "+", "3"}], ")"}]}], 
  TraditionalForm]], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 ImageSize->{19, 640},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->1819933808]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  StyleBox[
   ButtonBox["DimName",
    BaseStyle->"Link",
    ButtonData->"paclet:LieART/ref/DimName"],
   FontFamily->"Verdana"]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["Index",
    BaseStyle->"Link",
    ButtonData->"paclet:LieART/ref/Index"],
   FontFamily->"Verdana"]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["LieART: Lie Algebras and Representation Theory",
 BaseStyle->"Link",
 ButtonData->"paclet:LieART/guide/LieART"]], "MoreAbout",
 CellID->1973519727]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Dim - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "LieART: Lie Algebras and Representation Theory", ButtonData -> 
         "paclet:LieART/guide/LieART", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "Metadata" -> {
   "built" -> "{2014, 8, 6, 10, 23, 41.600797}", 
    "history" -> {"0.9", "", "", ""}, "context" -> "LieART`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Lie A R T Package Symbol", "language" -> "en", "paclet" -> 
    "LieART Package", "status" -> "None", "summary" -> 
    "Dim[irrep] computes the numerical dimension of irrep.", "synonyms" -> {},
     "title" -> "Dim", "titlemodifier" -> "", "windowtitle" -> "Dim", "type" -> 
    "Symbol", "uri" -> "LieART/ref/Dim"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"9.0 for Linux x86 (64-bit) (February 7, 2013)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "9.0 for Linux x86 (64-bit) (February 7, 2013)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4632, 140, 490, 14, 29, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->446001340]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 13122, 443}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[596, 21, 2614, 61, 49, "AnchorBarGrid",
 CellID->1],
Cell[3213, 84, 46, 1, 42, "ObjectName",
 CellID->1224892054],
Cell[CellGroupData[{
Cell[3284, 89, 472, 15, 86, "Usage",
 CellID->982511436],
Cell[CellGroupData[{
Cell[3781, 108, 609, 18, 42, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->578987836],
Cell[4393, 128, 190, 6, 70, "Notes",
 CellID->1067943069]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[4632, 140, 490, 14, 29, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->446001340],
Cell[CellGroupData[{
Cell[5147, 158, 196, 6, 25, "ExampleSection",
 CellID->1806064551],
Cell[5346, 166, 115, 3, 28, "Input",
 CellID->215697746],
Cell[5464, 171, 97, 1, 34, "ExampleText",
 CellID->1080383830],
Cell[CellGroupData[{
Cell[5586, 176, 185, 6, 28, "Input",
 CellID->2094170807],
Cell[5774, 184, 187, 6, 35, "Output",
 CellID->1135947014]
}, Open  ]],
Cell[5976, 193, 206, 6, 35, "ExampleText",
 CellID->1121455410],
Cell[CellGroupData[{
Cell[6207, 203, 217, 7, 28, "Input",
 CellID->322760841],
Cell[6427, 212, 188, 6, 35, "Output",
 CellID->1722090209]
}, Open  ]],
Cell[6630, 221, 221, 7, 35, "ExampleText",
 CellID->666046139],
Cell[CellGroupData[{
Cell[6876, 232, 204, 6, 28, "Input",
 CellID->284957929],
Cell[7083, 240, 188, 6, 35, "Output",
 CellID->1138565868]
}, Open  ]],
Cell[CellGroupData[{
Cell[7308, 251, 206, 5, 34, "ExampleText",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->1293636265],
Cell[7517, 258, 264, 6, 49, "ExampleText",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->984115482],
Cell[7784, 266, 237, 7, 240, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->554780177],
Cell[8024, 275, 462, 15, 298, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->765457383],
Cell[8489, 292, 223, 7, 335, "ExampleText",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->1971770716],
Cell[8715, 301, 269, 8, 257, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->1609349227],
Cell[8987, 311, 676, 22, 661, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->1819933808]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9724, 340, 446, 13, 125, "SeeAlsoSection",
 CellID->1255426704],
Cell[10173, 355, 496, 18, 245, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[10706, 378, 448, 13, 157, "MoreAboutSection",
 CellID->38303248],
Cell[11157, 393, 172, 3, 333, "MoreAbout",
 CellID->1973519727]
}, Open  ]],
Cell[11344, 399, 23, 0, 44, "FooterCell"]
}
]
*)

(* End of internal cache information *)

