(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     14747,        508]
NotebookOptionsPosition[     10892,        385]
NotebookOutlinePosition[     12923,        440]
CellTagsIndexPosition[     12838,        435]
WindowTitle->DimName - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["LIE A R T PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Dim\"\>":>Documentation`HelpLookup[
       "paclet:LieART/ref/Dim"], "\<\"Index\"\>":>Documentation`HelpLookup[
       "paclet:LieART/ref/Index"], "\<\"Irrep\"\>":>Documentation`HelpLookup[
       "paclet:LieART/ref/Irrep"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"LieART: Lie Algebras and Representation Theory\"\>":>
       Documentation`HelpLookup["paclet:LieART/guide/LieART"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"LieART/ref/DimName\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["LieART/ref/DimName"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/LieART/ref/DimName.\
html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", "LieART/ref/DimName",
              ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell["DimName", "ObjectName",
 CellID->1224892054],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"DimName", "[", 
       StyleBox["irrep", "TI"], "]"}]], "InlineFormula"],
     " \[LineSeparator]gives the dimensional name of ",
     Cell[BoxData[
      StyleBox["irrep", "TI"]], "InlineFormula"],
     ", which includes overbars and primes."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->2116037914],

Cell[TextData[{
 Cell[BoxData["DimName"], "InlineFormula"],
 " is internally used to find the Dynkin label of an irrep which is entered \
by its dimensional name via ",
 Cell[BoxData[
  ButtonBox["Irrep",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/Irrep"]], "InlineFormula"],
 "."
}], "Notes",
 CellID->1067943069]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->222181995],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1898721665],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<LieART`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->215697746],

Cell["\<\
Dimensional name of the anti-fundamental representation of SU(3):\
\>", "ExampleText",
 CellID->1080383830],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DimName", "[", 
  RowBox[{
   RowBox[{"Irrep", "[", "A", "]"}], "[", 
   RowBox[{"0", ",", "1"}], "]"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->2094170807],

Cell[BoxData[
 FormBox[
  StyleBox[
   OverscriptBox["3", "_"],
   FontWeight->Bold], TraditionalForm]], "Output",
 ImageSize->{13, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->961152127]
}, Open  ]],

Cell[TextData[{
 "Dimensional name of the conjugated spinor representation of SO(10), i.e., \
",
 Cell[BoxData[
  SubscriptBox["D", "5"]], "InlineFormula"],
 " in Dynkin classification:"
}], "ExampleText",
 CellID->1121455410],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DimName", "[", 
  RowBox[{
   RowBox[{"Irrep", "[", "D", "]"}], "[", 
   RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "0"}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->322760841],

Cell[BoxData[
 FormBox[
  StyleBox[
   OverscriptBox["16", "_"],
   FontWeight->Bold], TraditionalForm]], "Output",
 ImageSize->{22, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->2143609196]
}, Open  ]],

Cell["\<\
Dimensional name of the conjugated third 175-dimensional irrep of SU(5). The \
number of \"primes\" of an irrep is determined by its position when ordering \
the same-dimension irreps by their indices:\
\>", "ExampleText",
 CellID->452706987],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DimName", "[", 
  RowBox[{
   RowBox[{"Irrep", "[", "A", "]"}], "[", 
   RowBox[{"0", ",", "0", ",", "3", ",", "0"}], "]"}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->330699972],

Cell[BoxData[
 FormBox[
  SuperscriptBox[
   StyleBox[
    OverscriptBox["175", "_"],
    FontWeight->Bold], "\[Prime]\[Prime]"], TraditionalForm]], "Output",
 ImageSize->{39, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->1736242283]
}, Open  ]],

Cell[TextData[{
 Cell[BoxData["DimName"], "InlineFormula"],
 " is ",
 Cell[BoxData[
  ButtonBox["Listable",
   BaseStyle->"Link",
   ButtonData->"paclet:ref/Listable"]], "InlineFormula"],
 ". Example with all basic irreps (totally antisymmetric irreps) of SU(7):"
}], "ExampleText",
 CellID->1780475431],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DimName", "[", 
  RowBox[{"BasicIrreps", "[", "SU7", "]"}], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->1953683531],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    StyleBox["7",
     FontWeight->Bold], ",", 
    StyleBox["21",
     FontWeight->Bold], ",", 
    StyleBox["35",
     FontWeight->Bold], ",", 
    StyleBox[
     OverscriptBox["35", "_"],
     FontWeight->Bold], ",", 
    StyleBox[
     OverscriptBox["21", "_"],
     FontWeight->Bold], ",", 
    StyleBox[
     OverscriptBox["7", "_"],
     FontWeight->Bold]}], "}"}], TraditionalForm]], "Output",
 ImageSize->{23, 183},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->1040354754]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  StyleBox[
   ButtonBox["Dim",
    BaseStyle->"Link",
    ButtonData->"paclet:LieART/ref/Dim"],
   FontFamily->"Verdana"]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["Index",
    BaseStyle->"Link",
    ButtonData->"paclet:LieART/ref/Index"],
   FontFamily->"Verdana"]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["Irrep",
    BaseStyle->"Link",
    ButtonData->"paclet:LieART/ref/Irrep"],
   FontFamily->"Verdana"]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["LieART: Lie Algebras and Representation Theory",
 BaseStyle->"Link",
 ButtonData->"paclet:LieART/guide/LieART"]], "MoreAbout",
 CellID->194167885]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"DimName - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "LieART: Lie Algebras and Representation Theory", ButtonData -> 
         "paclet:LieART/guide/LieART", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "Metadata" -> {
   "built" -> "{2014, 8, 6, 10, 23, 40.190983}", 
    "history" -> {"0.9", "", "", ""}, "context" -> "LieART`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Lie A R T Package Symbol", "language" -> "en", "paclet" -> 
    "LieART Package", "status" -> "None", "summary" -> 
    "DimName[irrep] gives the dimensional name of irrep, which includes \
overbars and primes.", "synonyms" -> {}, "title" -> "DimName", 
    "titlemodifier" -> "", "windowtitle" -> "DimName", "type" -> "Symbol", 
    "uri" -> "LieART/ref/DimName"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"9.0 for Linux x86 (64-bit) (February 7, 2013)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "9.0 for Linux x86 (64-bit) (February 7, 2013)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4899, 145, 490, 14, 29, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->222181995]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 12695, 428}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[600, 21, 2701, 62, 49, "AnchorBarGrid",
 CellID->1],
Cell[3304, 85, 50, 1, 42, "ObjectName",
 CellID->1224892054],
Cell[CellGroupData[{
Cell[3379, 90, 506, 15, 86, "Usage",
 CellID->982511436],
Cell[CellGroupData[{
Cell[3910, 109, 610, 18, 42, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->2116037914],
Cell[4523, 129, 327, 10, 70, "Notes",
 CellID->1067943069]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[4899, 145, 490, 14, 29, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->222181995],
Cell[CellGroupData[{
Cell[5414, 163, 196, 6, 25, "ExampleSection",
 CellID->1898721665],
Cell[5613, 171, 115, 3, 28, "Input",
 CellID->215697746],
Cell[5731, 176, 117, 3, 34, "ExampleText",
 CellID->1080383830],
Cell[CellGroupData[{
Cell[5873, 183, 189, 6, 28, "Input",
 CellID->2094170807],
Cell[6065, 191, 244, 9, 35, "Output",
 CellID->961152127]
}, Open  ]],
Cell[6324, 203, 226, 7, 50, "ExampleText",
 CellID->1121455410],
Cell[CellGroupData[{
Cell[6575, 214, 221, 7, 28, "Input",
 CellID->322760841],
Cell[6799, 223, 246, 9, 35, "Output",
 CellID->2143609196]
}, Open  ]],
Cell[7060, 235, 252, 5, 64, "ExampleText",
 CellID->452706987],
Cell[CellGroupData[{
Cell[7337, 244, 208, 6, 28, "Input",
 CellID->330699972],
Cell[7548, 252, 289, 10, 35, "Output",
 CellID->1736242283]
}, Open  ]],
Cell[7852, 265, 303, 9, 50, "ExampleText",
 CellID->1780475431],
Cell[CellGroupData[{
Cell[8180, 278, 144, 4, 352, "Input",
 CellID->1953683531],
Cell[8327, 284, 585, 23, 204, "Output",
 CellID->1040354754]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[8973, 314, 446, 13, 93, "SeeAlsoSection",
 CellID->1255426704],
Cell[9422, 329, 769, 28, 274, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[10228, 362, 448, 13, 141, "MoreAboutSection",
 CellID->38303248],
Cell[10679, 377, 171, 3, 303, "MoreAbout",
 CellID->194167885]
}, Open  ]],
Cell[10865, 383, 23, 0, 44, "FooterCell"]
}
]
*)

(* End of internal cache information *)

