(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     28195,        871]
NotebookOptionsPosition[     22626,        678]
NotebookOutlinePosition[     24644,        733]
CellTagsIndexPosition[     24559,        728]
WindowTitle->HighestRoot - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["LIE A R T SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"RootLevel\"\>":>Documentation`HelpLookup[
       "paclet:LieART/ref/RootLevel"], "\<\"RootSystem\"\>":>
       Documentation`HelpLookup["paclet:LieART/ref/RootSystem"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"LieART/ref/HighestRoot\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["LieART/ref/HighestRoot"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/LieART/ref/\
HighestRoot.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "LieART/ref/HighestRoot", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell["HighestRoot", "ObjectName",
 CellID->1224892054],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"HighestRoot", "[", 
       StyleBox["algebra", "TI"], "]"}]], "InlineFormula"],
     " \[LineSeparator]gives the highest root of the root system of ",
     Cell[BoxData[
      StyleBox["algebra", "TI"]], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->92225566],

Cell[TextData[{
 "The highest root has the highest ",
 Cell[BoxData[
  ButtonBox["RootLevel",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/RootLevel"]], "InlineFormula"],
 "."
}], "Notes",
 CellID->1067943069]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->241090464],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(6)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->457378178],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<LieART`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1336855728],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox["\<\"LieART 1.0.0\"\>", TraditionalForm]], "Print",
 CellLabel->"During evaluation of In[1]:=",
 CellID->1873051591],

Cell[BoxData[
 FormBox["\<\"last revised 27 June 12\"\>", TraditionalForm]], "Print",
 CellLabel->"During evaluation of In[1]:=",
 CellID->958412188]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->1869447714],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"HighestRoot", "[", "SU5", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1056860479],

Cell[BoxData[
 FormBox[
  TagBox[GridBox[{
     {"1", "0", "0", "1"}
    },
    AutoDelete->False,
    GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"], TraditionalForm]], "Output",
 ImageSize->{71, 23},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->57359459]
}, Open  ]],

Cell["\<\
The highest root is given in the \[Omega]-basis:\
\>", "ExampleText",
 CellID->2071188305],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", "InputForm"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->948403920],

Cell["RootOmega[A][1, 0, 0, 1]", "Output",
 ImageSize->{161, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]//InputForm=",
 CellID->106916822]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->2124825577],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"HighestRoot", "[", "SO10", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->758000015],

Cell[BoxData[
 FormBox[
  TagBox[GridBox[{
     {"0", "1", "0", "0", "0"}
    },
    AutoDelete->False,
    GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"], TraditionalForm]], "Output",
 ImageSize->{87, 23},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->1407590488]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->160790262],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"HighestRoot", "[", "C5", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->2078027128],

Cell[BoxData[
 FormBox[
  TagBox[GridBox[{
     {"2", "0", "0", "0", "0"}
    },
    AutoDelete->False,
    GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"], TraditionalForm]], "Output",
 ImageSize->{88, 23},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->125975987]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->1585610551],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"HighestRoot", "[", "E6", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->2088817982],

Cell[BoxData[
 FormBox[
  TagBox[GridBox[{
     {"0", "0", "0", "0", "0", "1"}
    },
    AutoDelete->False,
    GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"], TraditionalForm]], "Output",
 ImageSize->{187, 23},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->1011636047]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->1193726371],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"HighestRoot", "[", "E8", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->484073175],

Cell[BoxData[
 FormBox[
  TagBox[GridBox[{
     {"0", "0", "0", "0", "0", "0", "1", "0"}
    },
    AutoDelete->False,
    GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"], TraditionalForm]], "Output",
 ImageSize->{247, 23},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->117789869]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Scope",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1293636265],

Cell["The highest root has the highest root level:", "ExampleText",
 CellID->1475576934],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RootLevel", "[", 
  RowBox[{"HighestRoot", "[", "SU5", "]"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->44174402],

Cell[BoxData[
 FormBox["4", TraditionalForm]], "Output",
 ImageSize->{12, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->1403060192]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"#", ",", 
       RowBox[{"RootLevel", "[", "#", "]"}]}], "}"}], "&"}], "/@", 
    RowBox[{"RootSystem", "[", "SU5", "]"}]}], ",", 
   RowBox[{"TableHeadings", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"None", ",", 
      RowBox[{"{", 
       RowBox[{"\"\<Root\>\"", ",", "\"\<Level\>\""}], "}"}]}], "}"}]}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"TableAlignments", "\[Rule]", "Center"}]}], "\[IndentingNewLine]", 
  "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1040703749],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnX+QldV5x5dEQLbWoEyKmRFc1rKsLjNSbBEksPyQrBSSMjY1Y0arUhqF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    "], {{0, 641}, {146, 0}}, {0, 
    255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{146, 641},
  PlotRange->{{0, 146}, {0, 641}}]], "Output",
 ImageSize->{150, 641},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]//TableForm=",
 CellID->290495992]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Applications",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->258228157],

Cell["\<\
Transform the higest roots to the \[Alpha]-basis:\
\>", "ExampleText",
 CellID->177978674],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AlphaBasis", "[", 
  RowBox[{"HighestRoot", "[", "SU5", "]"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->940184733],

Cell[BoxData[
 FormBox["\<\"(1, 1, 1, 1)\"\>", TraditionalForm]], "Output",
 ImageSize->{74, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->1291699345]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AlphaBasis", "[", 
  RowBox[{"HighestRoot", "[", "SO10", "]"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->35872552],

Cell[BoxData[
 FormBox["\<\"(1, 2, 2, 1, 1)\"\>", TraditionalForm]], "Output",
 ImageSize->{93, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1257116298]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AlphaBasis", "[", 
  RowBox[{"HighestRoot", "[", "E8", "]"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->114958654],

Cell[BoxData[
 FormBox["\<\"(2, 4, 6, 5, 4, 3, 2, 3)\"\>", TraditionalForm]], "Output",
 ImageSize->{144, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->2006138318]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  StyleBox[
   ButtonBox["RootLevel",
    BaseStyle->"Link",
    ButtonData->"paclet:LieART/ref/RootLevel"],
   FontFamily->"Verdana"]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["RootSystem",
    BaseStyle->"Link",
    ButtonData->"paclet:LieART/ref/RootSystem"],
   FontFamily->"Verdana"]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"HighestRoot - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "LieART: Lie Algebras and Representation Theory", ButtonData -> 
         "paclet:LieART/guide/LieART", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "Metadata" -> {
   "built" -> "{2014, 8, 6, 10, 23, 43.747302}", 
    "history" -> {"0.9", "", "", ""}, "context" -> "LieART`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Lie A R T Symbol", "language" -> "en", "paclet" -> "LieART", "status" -> 
    "None", "summary" -> 
    "HighestRoot[algebra] gives the highest root of the root system of \
algebra.", "synonyms" -> {}, "title" -> "HighestRoot", "titlemodifier" -> "", 
    "windowtitle" -> "HighestRoot", "type" -> "Symbol", "uri" -> 
    "LieART/ref/HighestRoot"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"9.0 for Linux x86 (64-bit) (February 7, 2013)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "9.0 for Linux x86 (64-bit) (February 7, 2013)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4461, 135, 490, 14, 29, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->241090464]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 24416, 721}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[604, 21, 2377, 54, 49, "AnchorBarGrid",
 CellID->1],
Cell[2984, 77, 54, 1, 42, "ObjectName",
 CellID->1224892054],
Cell[CellGroupData[{
Cell[3063, 82, 493, 15, 86, "Usage",
 CellID->982511436],
Cell[CellGroupData[{
Cell[3581, 101, 608, 18, 42, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->92225566],
Cell[4192, 121, 220, 8, 70, "Notes",
 CellID->1067943069]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[4461, 135, 490, 14, 29, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->241090464],
Cell[CellGroupData[{
Cell[4976, 153, 195, 6, 25, "ExampleSection",
 CellID->457378178],
Cell[CellGroupData[{
Cell[5196, 163, 116, 3, 28, "Input",
 CellID->1336855728],
Cell[CellGroupData[{
Cell[5337, 170, 139, 3, 22, "Print",
 CellID->1873051591],
Cell[5479, 175, 149, 3, 24, "Print",
 CellID->958412188]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5677, 184, 126, 3, 7, "ExampleDelimiter",
 CellID->1869447714],
Cell[CellGroupData[{
Cell[5828, 191, 110, 3, 28, "Input",
 CellID->1056860479],
Cell[5941, 196, 415, 13, 44, "Output",
 CellID->57359459]
}, Open  ]],
Cell[6371, 212, 100, 3, 34, "ExampleText",
 CellID->2071188305],
Cell[CellGroupData[{
Cell[6496, 219, 101, 3, 28, "Input",
 CellID->948403920],
Cell[6600, 224, 184, 5, 48, "Output",
 CellID->106916822]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6833, 235, 126, 3, 7, "ExampleDelimiter",
 CellID->2124825577],
Cell[CellGroupData[{
Cell[6984, 242, 110, 3, 28, "Input",
 CellID->758000015],
Cell[7097, 247, 422, 13, 44, "Output",
 CellID->1407590488]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7568, 266, 125, 3, 7, "ExampleDelimiter",
 CellID->160790262],
Cell[CellGroupData[{
Cell[7718, 273, 109, 3, 28, "Input",
 CellID->2078027128],
Cell[7830, 278, 421, 13, 44, "Output",
 CellID->125975987]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[8300, 297, 126, 3, 7, "ExampleDelimiter",
 CellID->1585610551],
Cell[CellGroupData[{
Cell[8451, 304, 109, 3, 45, "Input",
 CellID->2088817982],
Cell[8563, 309, 428, 13, 44, "Output",
 CellID->1011636047]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9040, 328, 126, 3, 7, "ExampleDelimiter",
 CellID->1193726371],
Cell[CellGroupData[{
Cell[9191, 335, 108, 3, 45, "Input",
 CellID->484073175],
Cell[9302, 340, 437, 13, 44, "Output",
 CellID->117789869]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9800, 360, 268, 8, 26, "ExampleSection",
 CellID->1293636265],
Cell[10071, 370, 88, 1, 70, "ExampleText",
 CellID->1475576934],
Cell[CellGroupData[{
Cell[10184, 375, 144, 4, 70, "Input",
 CellID->44174402],
Cell[10331, 381, 187, 6, 35, "Output",
 CellID->1403060192]
}, Open  ]],
Cell[CellGroupData[{
Cell[10555, 392, 618, 18, 70, "Input",
 CellID->1040703749],
Cell[11176, 412, 8783, 152, 70, "Output",
 CellID->290495992]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[20008, 570, 274, 8, 33, "ExampleSection",
 CellID->258228157],
Cell[20285, 580, 100, 3, 70, "ExampleText",
 CellID->177978674],
Cell[CellGroupData[{
Cell[20410, 587, 146, 4, 70, "Input",
 CellID->940184733],
Cell[20559, 593, 206, 6, 37, "Output",
 CellID->1291699345]
}, Open  ]],
Cell[CellGroupData[{
Cell[20802, 604, 146, 4, 70, "Input",
 CellID->35872552],
Cell[20951, 610, 209, 6, 37, "Output",
 CellID->1257116298]
}, Open  ]],
Cell[CellGroupData[{
Cell[21197, 621, 145, 4, 70, "Input",
 CellID->114958654],
Cell[21345, 627, 219, 6, 37, "Output",
 CellID->2006138318]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[21625, 640, 446, 13, 29, "SeeAlsoSection",
 CellID->1255426704],
Cell[22074, 655, 510, 18, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[22599, 676, 23, 0, 44, "FooterCell"]
}
]
*)

(* End of internal cache information *)

