(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     31510,       1032]
NotebookOptionsPosition[     25889,        842]
NotebookOutlinePosition[     27912,        897]
CellTagsIndexPosition[     27827,        892]
WindowTitle->LaTeXForm - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["LIE A R T SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Irrep\"\>":>Documentation`HelpLookup[
       "paclet:LieART/ref/Irrep"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"LieART: Lie Algebras and Representation Theory\"\>":>
       Documentation`HelpLookup["paclet:LieART/guide/LieART"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"LieART/ref/LaTeXForm\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["LieART/ref/LaTeXForm"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/LieART/ref/\
LaTeXForm.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]},
             Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "LieART/ref/LaTeXForm", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell["LaTeXForm", "ObjectName",
 CellID->1224892054],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"LaTeXForm", "[", "expr", "]"}]], "InlineFormula"],
     " \[LineSeparator]gives expr in a form suitable for copy&paste into a ",
     Cell[BoxData[
      FormBox[
       StyleBox[
        RowBox[{"L", 
         StyleBox[
          AdjustmentBox["A",
           BoxBaselineShift->-0.4,
           BoxMargins->{{-0.5, -0.3}, {0, 0}}],
          FontSize->Smaller], "T", 
         AdjustmentBox["E",
          BoxBaselineShift->0.5,
          BoxMargins->{{-0.3, 0}, {0, 0}}], "X"}], "TR",
        SingleLetterItalics->False], TraditionalForm]]],
     " document."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1696253544],

Cell[TextData[{
 "The LieART package comes with a ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"L", 
     StyleBox[
      AdjustmentBox["A",
       BoxBaselineShift->-0.4,
       BoxMargins->{{-0.5, -0.3}, {0, 0}}],
      FontSize->Smaller], "T", 
     AdjustmentBox["E",
      BoxBaselineShift->0.5,
      BoxMargins->{{-0.3, 0}, {0, 0}}], "X"}], "TR",
    SingleLetterItalics->False], TraditionalForm]]],
 " package (",
 StyleBox["lieart.sty", "InlineCode"],
 " in the subdirectory ",
 StyleBox["latex/", "InlineCode"],
 ") that defines commands to display irreps, roots and weights properly."
}], "Notes",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 CellID->943514760],

Cell[TextData[{
 "LaTeXForm is different from the usual TeXForm of ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " and involves special ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"L", 
     StyleBox[
      AdjustmentBox["A",
       BoxBaselineShift->-0.4,
       BoxMargins->{{-0.5, -0.3}, {0, 0}}],
      FontSize->Smaller], "T", 
     AdjustmentBox["E",
      BoxBaselineShift->0.5,
      BoxMargins->{{-0.3, 0}, {0, 0}}], "X"}], "TR",
    SingleLetterItalics->False], TraditionalForm]]],
 " commands defined by LieART."
}], "Notes",
 CellID->1067943069]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->571707933],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(5)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->480000138],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<LieART`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1117783260],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->1410905628],

Cell[TextData[{
 Cell[BoxData["LaTeXForm"], "InlineFormula"],
 " of single irreps:"
}], "ExampleText",
 CellID->1664564679],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Irrep", "[", "SU5", "]"}], "[", "5", "]"}], "//", 
  "LaTeXForm"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1746324646],

Cell[BoxData[
 FormBox[
  FormBox["\<\"\\\\irrep{5}\"\>",
   LieART`LaTeXForm], LieART`LaTeXForm]], "Output",
 ImageSize->{57, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]//LaTeXForm=",
 CellID->1810150771]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Irrep", "[", "SU5", "]"}], "[", 
   RowBox[{"Bar", "[", "5", "]"}], "]"}], "//", "LaTeXForm"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1665587629],

Cell[BoxData[
 FormBox[
  FormBox["\<\"\\\\irrepbar{5}\"\>",
   LieART`LaTeXForm], LieART`LaTeXForm]], "Output",
 ImageSize->{79, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]//LaTeXForm=",
 CellID->1017814156]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->696942979],

Cell[TextData[{
 "Product algebra irreps in ",
 Cell[BoxData["LaTeXForm"], "InlineFormula"],
 ":"
}], "ExampleText",
 CellID->845384239],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ProductIrrep", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Irrep", "[", "SU3", "]"}], "[", 
    RowBox[{"Bar", "[", "3", "]"}], "]"}], ",", 
   RowBox[{
    RowBox[{"Irrep", "[", "SU2", "]"}], "[", "1", "]"}], ",", 
   RowBox[{
    RowBox[{"Irrep", "[", "U", "]"}], "[", 
    RowBox[{"-", "2"}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1419563361],

Cell[BoxData[
 FormBox[
  RowBox[{"(", 
   FormBox[
    StyleBox[
     OverscriptBox["3", "_"],
     FontWeight->Bold],
    TraditionalForm], ",", 
   FormBox[
    StyleBox["1",
     FontWeight->Bold],
    TraditionalForm], ")", "\[InvisibleSpace]", 
   FormBox["\<\"(-2)\"\>",
    TraditionalForm]}], TraditionalForm]], "Output",
 ImageSize->{70, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->173120186]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", "LaTeXForm"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1110852232],

Cell[BoxData[
 FormBox["\<\"(\\\\irrepbar{3},\\\\irrep{1})(-2)\"\>", 
  LieART`LaTeXForm]], "Output",
 ImageSize->{176, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]//LaTeXForm=",
 CellID->629386606]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->1055923623],

Cell[TextData[{
 "Results of tensor product decompositions in ",
 Cell[BoxData["LaTeXForm"], "InlineFormula"],
 ":"
}], "ExampleText",
 CellID->782088783],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DecomposeProduct", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Irrep", "[", "SU3", "]"}], "[", "8", "]"}], ",", 
   RowBox[{
    RowBox[{"Irrep", "[", "SU3", "]"}], "[", "8", "]"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1705397838],

Cell[BoxData[
 FormBox[
  RowBox[{
   FormBox[
    StyleBox["1",
     FontWeight->Bold],
    TraditionalForm], "+", 
   RowBox[{"2", "(", 
    FormBox[
     StyleBox["8",
      FontWeight->Bold],
     TraditionalForm], ")"}], "+", 
   FormBox[
    StyleBox["10",
     FontWeight->Bold],
    TraditionalForm], "+", 
   FormBox[
    StyleBox[
     OverscriptBox["10", "_"],
     FontWeight->Bold],
    TraditionalForm], "+", 
   FormBox[
    StyleBox["27",
     FontWeight->Bold],
    TraditionalForm]}], TraditionalForm]], "Output",
 ImageSize->{69, 52},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->75615732]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", "LaTeXForm"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1574330511],

Cell[BoxData[
 FormBox["\<\"$\\\\irrep{1}+2(\\\\irrep{8})+\\\\irrep{10}+\\\\irrepbar{10}+\\\
\\irrep{27}$\"\>", LieART`LaTeXForm]], "Output",
 ImageSize->{80, 160},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]//LaTeXForm=",
 CellID->474188684]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->916822581],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"L", 
     StyleBox[
      AdjustmentBox["A",
       BoxBaselineShift->-0.4,
       BoxMargins->{{-0.5, -0.3}, {0, 0}}],
      FontSize->Smaller], "T", 
     AdjustmentBox["E",
      BoxBaselineShift->0.5,
      BoxMargins->{{-0.3, 0}, {0, 0}}], "X"}], "TR",
    SingleLetterItalics->False], TraditionalForm]]],
 " output of decompositions to subalgebras:"
}], "ExampleText",
 CellID->2026962322],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DecomposeIrrep", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Irrep", "[", "SU5", "]"}], "[", "24", "]"}], ",", 
   RowBox[{"ProductAlgebra", "[", 
    RowBox[{"SU3", ",", "SU2", ",", "U1"}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->988770776],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{"(", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ")", "\[InvisibleSpace]", 
    FormBox["\<\"(0)\"\>",
     TraditionalForm]}], "+", 
   RowBox[{"(", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["3",
      FontWeight->Bold],
     TraditionalForm], ")", "\[InvisibleSpace]", 
    FormBox["\<\"(0)\"\>",
     TraditionalForm]}], "+", 
   RowBox[{"(", 
    FormBox[
     StyleBox["3",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["2",
      FontWeight->Bold],
     TraditionalForm], ")", "\[InvisibleSpace]", 
    FormBox["\<\"(5)\"\>",
     TraditionalForm]}], "+", 
   RowBox[{"(", 
    FormBox[
     StyleBox[
      OverscriptBox["3", "_"],
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["2",
      FontWeight->Bold],
     TraditionalForm], ")", "\[InvisibleSpace]", 
    FormBox["\<\"(-5)\"\>",
     TraditionalForm]}], "+", 
   RowBox[{"(", 
    FormBox[
     StyleBox["8",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["1",
      FontWeight->Bold],
     TraditionalForm], ")", "\[InvisibleSpace]", 
    FormBox["\<\"(0)\"\>",
     TraditionalForm]}]}], TraditionalForm]], "Output",
 ImageSize->{74, 149},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->1037359763]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", "LaTeXForm"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1066956727],

Cell[BoxData[
 FormBox["\<\"$(\\\\irrep{1},\\\\irrep{1})(0)+(\\\\irrep{1},\\\\irrep{3})(0)+(\
\\\\irrep{3},\\\\irrep{2})(5)+(\\\\irrepbar{3},\\\\irrep{2})(-5)+(\\\\irrep{8}\
,\\\\irrep{1})(0)$\"\>", LieART`LaTeXForm]], "Output",
 ImageSize->{79, 288},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]//LaTeXForm=",
 CellID->918517680]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Applications",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->258228157],

Cell[TextData[{
 "Display tensor products of low dimensional ",
 Cell[BoxData[
  SubscriptBox["E", "6"]], "InlineFormula"],
 " irreps in ",
 Cell[BoxData["LaTeXForm"], "InlineFormula"],
 " using ",
 Cell[BoxData[
  ButtonBox["IrrepProduct",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/IrrepProduct"]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["IrrepRule",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/IrrepRule"]], "InlineFormula"],
 ":"
}], "ExampleText",
 CellID->1853323654],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"irreps", "=", 
  RowBox[{"SortIrreps", "[", 
   RowBox[{"Rest", "[", 
    RowBox[{"Select", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Irrep", "[", "E6", "]"}], "@@@", 
       RowBox[{"Tuples", "[", 
        RowBox[{
         RowBox[{"Range", "[", 
          RowBox[{"0", ",", "1"}], "]"}], ",", "6"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Dim", "[", "#", "]"}], "\[LessEqual]", "350"}], "&"}]}], 
     "]"}], "]"}], "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1400116257],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    FormBox[
     StyleBox["27",
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox[
      OverscriptBox["27", "_"],
      FontWeight->Bold],
     TraditionalForm], ",", 
    FormBox[
     StyleBox["78",
      FontWeight->Bold],
     TraditionalForm]}], "}"}], TraditionalForm]], "Output",
 ImageSize->{86, 18},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->443104088]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Flatten", "[", 
   RowBox[{
    RowBox[{"Outer", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"IrrepRule", "[", 
        RowBox[{
         RowBox[{"IrrepProduct", "[", "##", "]"}], ",", 
         RowBox[{"DecomposeProduct", "[", "##", "]"}]}], "]"}], "&"}], ",", 
      "irreps", ",", "irreps", ",", "1"}], "]"}], ",", "1"}], "]"}], "//", 
  "TableForm"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1835971161],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnQtYVGUax+fOIDdlEFEDLwi6tmblDRXBFMw0SRGLNEVRN9318oC7lalt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    "], {{0, 174}, {248, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{248, 174},
  PlotRange->{{0, 248}, {0, 174}}]], "Output",
 ImageSize->{252, 174},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]//TableForm=",
 CellID->1937013867]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", "LaTeXForm"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->76225109],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    FormBox["\<\"$\\\\irrep{27}\\\\times\\\\irrep{27}$\\\\rightarrow$\\\\\
irrepbar{27}+\\\\irrepbar{351}+\\\\irrepbar[1]{351}$\"\>",
     LieART`LaTeXForm], ",", 
    FormBox["\<\"$\\\\irrep{27}\\\\times\\\\irrepbar{27}$\\\\rightarrow$\\\\\
irrep{1}+\\\\irrep{78}+\\\\irrep{650}$\"\>",
     LieART`LaTeXForm], ",", 
    FormBox["\<\"$\\\\irrep{27}\\\\times\\\\irrep{78}$\\\\rightarrow$\\\\\
irrep{27}+\\\\irrep{351}+\\\\irrep{1728}$\"\>",
     LieART`LaTeXForm], ",", 
    FormBox["\<\"$\\\\irrepbar{27}\\\\times\\\\irrep{27}$\\\\rightarrow$\\\\\
irrep{1}+\\\\irrep{78}+\\\\irrep{650}$\"\>",
     LieART`LaTeXForm], ",", 
    FormBox["\<\"$\\\\irrepbar{27}\\\\times\\\\irrepbar{27}$\\\\rightarrow$\\\
\\irrep{27}+\\\\irrep{351}+\\\\irrep[1]{351}$\"\>",
     LieART`LaTeXForm], ",", 
    FormBox["\<\"$\\\\irrepbar{27}\\\\times\\\\irrep{78}$\\\\rightarrow$\\\\\
irrepbar{27}+\\\\irrepbar{351}+\\\\irrepbar{1728}$\"\>",
     LieART`LaTeXForm], ",", 
    FormBox["\<\"$\\\\irrep{78}\\\\times\\\\irrep{27}$\\\\rightarrow$\\\\\
irrep{27}+\\\\irrep{351}+\\\\irrep{1728}$\"\>",
     LieART`LaTeXForm], ",", 
    FormBox["\<\"$\\\\irrep{78}\\\\times\\\\irrepbar{27}$\\\\rightarrow$\\\\\
irrepbar{27}+\\\\irrepbar{351}+\\\\irrepbar{1728}$\"\>",
     LieART`LaTeXForm], ",", 
    FormBox["\<\"$\\\\irrep{78}\\\\times\\\\irrep{78}$\\\\rightarrow$\\\\\
irrep{1}+\\\\irrep{78}+\\\\irrep{650}+\\\\irrep{2430}+\\\\irrep{2925}$\"\>",
     LieART`LaTeXForm]}], "}"}], LieART`LaTeXForm]], "Output",
 ImageSize->{577, 207},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]//LaTeXForm=",
 CellID->1804671760]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[Cell[BoxData[
 StyleBox[
  ButtonBox["Irrep",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/Irrep"],
  FontFamily->"Verdana"]], "InlineFormula"]], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["LieART: Lie Algebras and Representation Theory",
 BaseStyle->"Link",
 ButtonData->"paclet:LieART/guide/LieART"]], "MoreAbout",
 CellID->1667457569]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"LaTeXForm - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "LieART: Lie Algebras and Representation Theory", ButtonData -> 
         "paclet:LieART/guide/LieART", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "Metadata" -> {
   "built" -> "{2014, 8, 6, 10, 23, 51.042876}", 
    "history" -> {"0.9", "", "", ""}, "context" -> "LieART`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Lie A R T Symbol", "language" -> "en", "paclet" -> "LieART", "status" -> 
    "None", "summary" -> 
    "LaTeXForm[expr] gives expr in a form suitable for copy&paste into a L A \
T E X document.", "synonyms" -> {}, "title" -> "LaTeXForm", "titlemodifier" -> 
    "", "windowtitle" -> "LaTeXForm", "type" -> "Symbol", "uri" -> 
    "LieART/ref/LaTeXForm"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"9.0 for Linux x86 (64-bit) (February 7, 2013)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "9.0 for Linux x86 (64-bit) (February 7, 2013)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6008, 187, 490, 14, 29, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->571707933]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 27684, 885}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[602, 21, 2548, 60, 49, "AnchorBarGrid",
 CellID->1],
Cell[3153, 83, 52, 1, 42, "ObjectName",
 CellID->1224892054],
Cell[CellGroupData[{
Cell[3230, 88, 824, 25, 84, "Usage",
 CellID->982511436],
Cell[CellGroupData[{
Cell[4079, 117, 610, 18, 42, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1696253544],
Cell[4692, 137, 690, 22, 70, "Notes",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 CellID->943514760],
Cell[5385, 161, 574, 20, 70, "Notes",
 CellID->1067943069]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6008, 187, 490, 14, 29, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->571707933],
Cell[CellGroupData[{
Cell[6523, 205, 195, 6, 25, "ExampleSection",
 CellID->480000138],
Cell[6721, 213, 116, 3, 28, "Input",
 CellID->1117783260],
Cell[CellGroupData[{
Cell[6862, 220, 126, 3, 7, "ExampleDelimiter",
 CellID->1410905628],
Cell[6991, 225, 123, 4, 35, "ExampleText",
 CellID->1664564679],
Cell[CellGroupData[{
Cell[7139, 233, 168, 6, 28, "Input",
 CellID->1746324646],
Cell[7310, 241, 251, 8, 50, "Output",
 CellID->1810150771]
}, Open  ]],
Cell[CellGroupData[{
Cell[7598, 254, 196, 6, 28, "Input",
 CellID->1665587629],
Cell[7797, 262, 254, 8, 50, "Output",
 CellID->1017814156]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[8100, 276, 125, 3, 7, "ExampleDelimiter",
 CellID->696942979],
Cell[8228, 281, 136, 5, 35, "ExampleText",
 CellID->845384239],
Cell[CellGroupData[{
Cell[8389, 290, 387, 12, 28, "Input",
 CellID->1419563361],
Cell[8779, 304, 460, 18, 37, "Output",
 CellID->173120186]
}, Open  ]],
Cell[CellGroupData[{
Cell[9276, 327, 102, 3, 26, "Input",
 CellID->1110852232],
Cell[9381, 332, 243, 7, 50, "Output",
 CellID->629386606]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9673, 345, 126, 3, 7, "ExampleDelimiter",
 CellID->1055923623],
Cell[9802, 350, 154, 5, 143, "ExampleText",
 CellID->782088783],
Cell[CellGroupData[{
Cell[9981, 359, 266, 8, 163, "Input",
 CellID->1705397838],
Cell[10250, 369, 660, 29, 73, "Output",
 CellID->75615732]
}, Open  ]],
Cell[CellGroupData[{
Cell[10947, 403, 102, 3, 59, "Input",
 CellID->1574330511],
Cell[11052, 408, 283, 7, 194, "Output",
 CellID->474188684]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[11384, 421, 125, 3, 7, "ExampleDelimiter",
 CellID->916822581],
Cell[11512, 426, 463, 16, 111, "ExampleText",
 CellID->2026962322],
Cell[CellGroupData[{
Cell[12000, 446, 281, 8, 194, "Input",
 CellID->988770776],
Cell[12284, 456, 1559, 63, 170, "Output",
 CellID->1037359763]
}, Open  ]],
Cell[CellGroupData[{
Cell[13880, 524, 102, 3, 59, "Input",
 CellID->1066956727],
Cell[13985, 529, 370, 8, 322, "Output",
 CellID->918517680]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[14416, 544, 274, 8, 42, "ExampleSection",
 CellID->258228157],
Cell[14693, 554, 514, 18, 70, "ExampleText",
 CellID->1853323654],
Cell[CellGroupData[{
Cell[15232, 576, 537, 17, 70, "Input",
 CellID->1400116257],
Cell[15772, 595, 501, 21, 39, "Output",
 CellID->443104088]
}, Open  ]],
Cell[CellGroupData[{
Cell[16310, 621, 450, 14, 70, "Input",
 CellID->1835971161],
Cell[16763, 637, 5896, 104, 70, "Output",
 CellID->1937013867]
}, Open  ]],
Cell[CellGroupData[{
Cell[22696, 746, 100, 3, 70, "Input",
 CellID->76225109],
Cell[22799, 751, 1677, 35, 241, "Output",
 CellID->1804671760]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[24537, 793, 446, 13, 29, "SeeAlsoSection",
 CellID->1255426704],
Cell[24986, 808, 201, 6, 56, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[25224, 819, 448, 13, 45, "MoreAboutSection",
 CellID->38303248],
Cell[25675, 834, 172, 3, 78, "MoreAbout",
 CellID->1667457569]
}, Open  ]],
Cell[25862, 840, 23, 0, 44, "FooterCell"]
}
]
*)

(* End of internal cache information *)

