(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     25782,        869]
NotebookOptionsPosition[     20742,        711]
NotebookOutlinePosition[     22765,        766]
CellTagsIndexPosition[     22680,        761]
WindowTitle->MetricTensor - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["LIE A R T PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"CartanMatrix\"\>":>
       Documentation`HelpLookup[
       "paclet:LieART/ref/CartanMatrix"], "\<\"Algebra\"\>":>
       Documentation`HelpLookup["paclet:LieART/ref/Algebra"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"LieART: Lie Algebras and Representation Theory\"\>":>
       Documentation`HelpLookup["paclet:LieART/guide/LieART"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"LieART/ref/MetricTensor\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["LieART/ref/MetricTensor"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/LieART/ref/\
MetricTensor.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "LieART/ref/MetricTensor", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell["MetricTensor", "ObjectName",
 CellID->1224892054],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"MetricTensor", "[", 
       StyleBox["algebra", "TI"], "]"}]], "InlineFormula"],
     " \[LineSeparator]gives the metric tensor of ",
     Cell[BoxData[
      StyleBox["algebra", "TI"]], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->956674854],

Cell[TextData[{
 "A classical ",
 Cell[BoxData[
  StyleBox["algebra", "TI"]], "InlineFormula"],
 " may be entered in Dynkin classification, e.g. ",
 Cell[BoxData[
  ButtonBox["A3",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/A3"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["C3",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/C3"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["D4",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/D4"]], "InlineFormula"],
 " or with traditional names, e.g. ",
 Cell[BoxData[
  ButtonBox["SU4",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/SU4"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["Sp6",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/Sp6"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["SO8",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/SO8"]], "InlineFormula"],
 ", or in the internal notation ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    ButtonBox["Algebra",
     BaseStyle->"Link",
     ButtonData->"paclet:LieART/ref/Algebra"], "[", 
    ButtonBox["A",
     BaseStyle->"Link",
     ButtonData->"paclet:LieART/ref/A"], "]"}], "[", "3", "]"}]], 
  "InlineFormula"],
 ", ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    ButtonBox["Algebra",
     BaseStyle->"Link",
     ButtonData->"paclet:LieART/ref/Algebra"], "[", 
    ButtonBox["C",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/C"], "]"}], "[", "3", "]"}]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    ButtonBox["Algebra",
     BaseStyle->"Link",
     ButtonData->"paclet:LieART/ref/Algebra"], "[", 
    ButtonBox["D",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/D"], "]"}], "[", "4", "]"}]], "InlineFormula"],
 ". An exceptional algebra can only be entered in one way, namely ",
 Cell[BoxData[
  ButtonBox["E6",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/E6"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["E7",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/E7"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["E8",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/E8"]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["F4",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/F4"]], "InlineFormula"],
 " or ",
 Cell[BoxData[
  ButtonBox["G2",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/G2"]], "InlineFormula"],
 "."
}], "Notes",
 CellID->147230154],

Cell["\<\
The metric tensor is also known as the \"quadratic form matrix\". It is \
needed for the computation of the scalar product in the \[Omega]-basis.\
\>", "Notes",
 CellID->1067943069]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->42001010],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1011987723],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<LieART`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->2055110077],

Cell[CellGroupData[{

Cell["Metric tensors of all rank 4 classical Lie algebras:", "ExampleText",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->432688663],

Cell[BoxData[
 RowBox[{"MetricTensor", "[", "A4", "]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellLabel->"In[2]:=",
 CellID->1503630565],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["4", "5"], 
      FractionBox["3", "5"], 
      FractionBox["2", "5"], 
      FractionBox["1", "5"]},
     {
      FractionBox["3", "5"], 
      FractionBox["6", "5"], 
      FractionBox["4", "5"], 
      FractionBox["2", "5"]},
     {
      FractionBox["2", "5"], 
      FractionBox["4", "5"], 
      FractionBox["6", "5"], 
      FractionBox["3", "5"]},
     {
      FractionBox["1", "5"], 
      FractionBox["2", "5"], 
      FractionBox["3", "5"], 
      FractionBox["4", "5"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 ImageSize->{92, 109},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->870628912],

Cell[BoxData[
 RowBox[{"MetricTensor", "[", "B4", "]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellLabel->"In[3]:=",
 CellID->1000317780],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "1", "1", 
      FractionBox["1", "2"]},
     {"1", "2", "2", "1"},
     {"1", "2", "3", 
      FractionBox["3", "2"]},
     {
      FractionBox["1", "2"], "1", 
      FractionBox["3", "2"], "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 ImageSize->{89, 100},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->1003762492],

Cell[BoxData[
 RowBox[{"MetricTensor", "[", "C4", "]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellLabel->"In[4]:=",
 CellID->1089582623],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], 
      FractionBox["1", "2"], 
      FractionBox["1", "2"], 
      FractionBox["1", "2"]},
     {
      FractionBox["1", "2"], "1", "1", "1"},
     {
      FractionBox["1", "2"], "1", 
      FractionBox["3", "2"], 
      FractionBox["3", "2"]},
     {
      FractionBox["1", "2"], "1", 
      FractionBox["3", "2"], "2"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 ImageSize->{92, 109},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->1192682335],

Cell[BoxData[
 RowBox[{"MetricTensor", "[", "D4", "]"}]], "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellLabel->"In[5]:=",
 CellID->326623444],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "1", 
      FractionBox["1", "2"], 
      FractionBox["1", "2"]},
     {"1", "2", "1", "1"},
     {
      FractionBox["1", "2"], "1", "1", 
      FractionBox["1", "2"]},
     {
      FractionBox["1", "2"], "1", 
      FractionBox["1", "2"], "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 ImageSize->{89, 100},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->1432622501]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->71220346],

Cell["Metric tensors of all exceptional Lie algebras :", "ExampleText",
 CellID->1687553946],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MetricTensor", "[", "E6", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1519463992],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["4", "3"], 
      FractionBox["5", "3"], "2", 
      FractionBox["4", "3"], 
      FractionBox["2", "3"], "1"},
     {
      FractionBox["5", "3"], 
      FractionBox["10", "3"], "4", 
      FractionBox["8", "3"], 
      FractionBox["4", "3"], "2"},
     {"2", "4", "6", "4", "2", "3"},
     {
      FractionBox["4", "3"], 
      FractionBox["8", "3"], "4", 
      FractionBox["10", "3"], 
      FractionBox["5", "3"], "2"},
     {
      FractionBox["2", "3"], 
      FractionBox["4", "3"], "2", 
      FractionBox["5", "3"], 
      FractionBox["4", "3"], "1"},
     {"1", "2", "3", "2", "1", "2"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "Output",
 ImageSize->{136, 147},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->1009599976]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MetricTensor", "[", "E7", "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1034770548],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"2", "3", "4", "3", "2", "1", "2"},
     {"3", "6", "8", "6", "4", "2", "4"},
     {"4", "8", "12", "9", "6", "3", "6"},
     {"3", "6", "9", 
      FractionBox["15", "2"], "5", 
      FractionBox["5", "2"], 
      FractionBox["9", "2"]},
     {"2", "4", "6", "5", "4", "2", "3"},
     {"1", "2", "3", 
      FractionBox["5", "2"], "2", 
      FractionBox["3", "2"], 
      FractionBox["3", "2"]},
     {"2", "4", "6", 
      FractionBox["9", "2"], "3", 
      FractionBox["3", "2"], 
      FractionBox["7", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "Output",
 ImageSize->{153, 157},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->37822032]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MetricTensor", "[", "E8", "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->2111439842],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"4", "7", "10", "8", "6", "4", "2", "5"},
     {"7", "14", "20", "16", "12", "8", "4", "10"},
     {"10", "20", "30", "24", "18", "12", "6", "15"},
     {"8", "16", "24", "20", "15", "10", "5", "12"},
     {"6", "12", "18", "15", "12", "8", "4", "9"},
     {"4", "8", "12", "10", "8", "6", "3", "6"},
     {"2", "4", "6", "5", "4", "3", "2", "3"},
     {"5", "10", "15", "12", "9", "6", "3", "8"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "Output",
 ImageSize->{203, 149},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->472246187]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MetricTensor", "[", "F4", "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->1130387038],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"2", "3", "2", "1"},
     {"3", "6", "4", "2"},
     {"2", "4", "3", 
      FractionBox["3", "2"]},
     {"1", "2", 
      FractionBox["3", "2"], "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "Output",
 ImageSize->{86, 91},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->16934771]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MetricTensor", "[", "G2", "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->667380572],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["2", "3"], "1"},
     {"1", "2"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "Output",
 ImageSize->{49, 45},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->681306039]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  StyleBox[
   ButtonBox["CartanMatrix",
    BaseStyle->"Link",
    ButtonData->"paclet:LieART/ref/CartanMatrix"],
   FontFamily->"Verdana"]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["Algebra",
    BaseStyle->"Link",
    ButtonData->"paclet:LieART/ref/Algebra"],
   FontFamily->"Verdana"]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["LieART: Lie Algebras and Representation Theory",
 BaseStyle->"Link",
 ButtonData->"paclet:LieART/guide/LieART"]], "MoreAbout",
 CellID->495028952]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"MetricTensor - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "LieART: Lie Algebras and Representation Theory", ButtonData -> 
         "paclet:LieART/guide/LieART", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "Metadata" -> {
   "built" -> "{2014, 8, 6, 10, 23, 52.935821}", 
    "history" -> {"0.9", "", "", ""}, "context" -> "LieART`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Lie A R T Package Symbol", "language" -> "en", "paclet" -> 
    "LieART Package", "status" -> "None", "summary" -> 
    "MetricTensor[algebra] gives the metric tensor of algebra.", 
    "synonyms" -> {}, "title" -> "MetricTensor", "titlemodifier" -> "", 
    "windowtitle" -> "MetricTensor", "type" -> "Symbol", "uri" -> 
    "LieART/ref/MetricTensor"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"9.0 for Linux x86 (64-bit) (February 7, 2013)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "9.0 for Linux x86 (64-bit) (February 7, 2013)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[7167, 233, 489, 14, 29, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->42001010]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 22538, 754}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[605, 21, 2674, 62, 49, "AnchorBarGrid",
 CellID->1],
Cell[3282, 85, 55, 1, 42, "ObjectName",
 CellID->1224892054],
Cell[CellGroupData[{
Cell[3362, 90, 476, 15, 86, "Usage",
 CellID->982511436],
Cell[CellGroupData[{
Cell[3863, 109, 609, 18, 42, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->956674854],
Cell[4475, 129, 2449, 92, 70, "Notes",
 CellID->147230154],
Cell[6927, 223, 191, 4, 70, "Notes",
 CellID->1067943069]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7167, 233, 489, 14, 29, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->42001010],
Cell[CellGroupData[{
Cell[7681, 251, 196, 6, 25, "ExampleSection",
 CellID->1011987723],
Cell[7880, 259, 116, 3, 28, "Input",
 CellID->2055110077],
Cell[CellGroupData[{
Cell[8021, 266, 148, 2, 34, "ExampleText",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->432688663],
Cell[8172, 270, 163, 4, 28, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->1503630565],
Cell[8338, 276, 1212, 40, 130, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->870628912],
Cell[9553, 318, 163, 4, 28, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->1000317780],
Cell[9719, 324, 913, 28, 121, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->1003762492],
Cell[10635, 354, 163, 4, 28, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->1089582623],
Cell[10801, 360, 1063, 34, 130, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->1192682335],
Cell[11867, 396, 162, 4, 44, "Input",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->326623444],
Cell[12032, 402, 963, 30, 121, "Output",
 CellGroupingRules->{GroupTogetherGrouping, 10000.},
 CellID->1432622501]
}, Open  ]],
Cell[CellGroupData[{
Cell[13032, 437, 124, 3, 7, "ExampleDelimiter",
 CellID->71220346],
Cell[13159, 442, 92, 1, 109, "ExampleText",
 CellID->1687553946],
Cell[CellGroupData[{
Cell[13276, 447, 110, 3, 44, "Input",
 CellID->1519463992],
Cell[13389, 452, 1277, 41, 168, "Output",
 CellID->1009599976]
}, Open  ]],
Cell[CellGroupData[{
Cell[14703, 498, 110, 3, 44, "Input",
 CellID->1034770548],
Cell[14816, 503, 1172, 35, 178, "Output",
 CellID->37822032]
}, Open  ]],
Cell[CellGroupData[{
Cell[16025, 543, 110, 3, 44, "Input",
 CellID->2111439842],
Cell[16138, 548, 1056, 27, 170, "Output",
 CellID->472246187]
}, Open  ]],
Cell[CellGroupData[{
Cell[17231, 580, 110, 3, 44, "Input",
 CellID->1130387038],
Cell[17344, 585, 807, 25, 112, "Output",
 CellID->16934771]
}, Open  ]],
Cell[CellGroupData[{
Cell[18188, 615, 109, 3, 44, "Input",
 CellID->667380572],
Cell[18300, 620, 709, 22, 66, "Output",
 CellID->681306039]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[19082, 650, 446, 13, 29, "SeeAlsoSection",
 CellID->1255426704],
Cell[19531, 665, 510, 18, 88, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[20078, 688, 448, 13, 45, "MoreAboutSection",
 CellID->38303248],
Cell[20529, 703, 171, 3, 78, "MoreAbout",
 CellID->495028952]
}, Open  ]],
Cell[20715, 709, 23, 0, 44, "FooterCell"]
}
]
*)

(* End of internal cache information *)

