(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     61306,       1537]
NotebookOptionsPosition[     55298,       1361]
NotebookOutlinePosition[     57324,       1416]
CellTagsIndexPosition[     57238,       1411]
WindowTitle->RootSystem - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["LIE A R T PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"RootLevel\"\>":>Documentation`HelpLookup[
       "paclet:LieART/ref/RootLevel"], "\<\"WeightSystem\"\>":>
       Documentation`HelpLookup["paclet:LieART/ref/WeightSystem"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"LieART: Lie Algebras and Representation Theory\"\>":>
       Documentation`HelpLookup["paclet:LieART/guide/LieART"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"LieART/ref/RootSystem\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["LieART/ref/RootSystem"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/LieART/ref/\
RootSystem.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "LieART/ref/RootSystem", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell["RootSystem", "ObjectName",
 CellID->1224892054],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"RootSystem", "[", 
       StyleBox["algebra", "TI"], "]"}]], "InlineFormula"],
     " \[LineSeparator]generates the complete root system of ",
     Cell[BoxData[
      StyleBox["algebra", "TI"]], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->294176452],

Cell[TextData[{
 "Options for ",
 Cell[BoxData[
  RowBox[{"RootSystem", "[", 
   StyleBox["irrep", "TI"], "]"}]], "InlineFormula"],
 ":\n",
 Cell[BoxData[GridBox[{
    {Cell["      ", "TableRowIcon"], 
     ButtonBox["SpindleShape",
      BaseStyle->"Link",
      ButtonData->"paclet:LieART/ref/SpindleShape"], 
     ButtonBox["False",
      BaseStyle->"Link",
      ButtonData->"paclet:ref/False"], Cell["\<\
whether to displays the root system in a spindle shape with rows for equal \
root height\
\>", "TableText"]}
   }]], "3ColumnTableMod",
  GridBoxOptions->{
  GridBoxBackground->{
   "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
    "RowsIndexed" -> {}},
  GridBoxDividers->{"Rows" -> {{True, True}}}}]
}], "Notes",
 CellID->25488050]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->2011128355],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(3)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1070467778],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<LieART`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->808202143],

Cell[TextData[{
 "The roots are computed in the so called \[Omega]-basis, also known as the \
basis of fundmental weights, indicated by the head ",
 Cell[BoxData[
  ButtonBox["RootOmega",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/RootOmega"]], "InlineFormula"],
 ":"
}], "ExampleText",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellID->286767578],

Cell[BoxData[
 RowBox[{
  RowBox[{"RootSystem", "[", "SU5", "]"}], "//", "InputForm"}]], "Input",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellLabel->"In[2]:=",
 CellID->595436105],

Cell["\<\
{RootOmega[A][1, 0, 0, 1], 
 RootOmega[A][-1, 1, 0, 1], 
 RootOmega[A][1, 0, 1, -1], 
 RootOmega[A][-1, 1, 1, -1], 
 RootOmega[A][0, -1, 1, 1], 
 RootOmega[A][1, 1, -1, 0], 
 RootOmega[A][-1, 2, -1, 0], 
 RootOmega[A][0, -1, 2, -1], 
 RootOmega[A][0, 0, -1, 2], 
 RootOmega[A][2, -1, 0, 0], 
 RootOmega[A][0, 0, 0, 0], 
 RootOmega[A][0, 0, 0, 0], 
 RootOmega[A][0, 0, 0, 0], 
 RootOmega[A][0, 0, 0, 0], 
 RootOmega[A][-2, 1, 0, 0], 
 RootOmega[A][0, 0, 1, -2], 
 RootOmega[A][0, 1, -2, 1], 
 RootOmega[A][1, -2, 1, 0], 
 RootOmega[A][-1, -1, 1, 0], 
 RootOmega[A][0, 1, -1, -1], 
 RootOmega[A][1, -1, -1, 1], 
 RootOmega[A][-1, 0, -1, 1], 
 RootOmega[A][1, -1, 0, -1], 
 RootOmega[A][-1, 0, 0, -1]}\
\>", "Output",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 ImageSize->{183, 359},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]//InputForm=",
 CellID->762984660],

Cell[TextData[{
 "Roots are sorted by root level. (Roots are displayed in ",
 Cell[BoxData[
  ButtonBox["StandardForm",
   BaseStyle->"Link",
   ButtonData->"paclet:ref/StandardForm"]], "InlineFormula"],
 " similar to Dynkin labels but with the entries separated by commas since \
they can be negative.)"
}], "ExampleText",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10001.},
 CellID->1780311060],

Cell[BoxData[
 RowBox[{
  RowBox[{"RootSystem", "[", "SU5", "]"}], "//", "StandardForm"}]], "Input",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10001.},
 CellLabel->"In[4]:=",
 CellID->72060683],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"(1, 0, 0, 1)\"\>", ",", "\<\"(-1, 1, 0, 1)\"\>", 
   ",", "\<\"(1, 0, 1, -1)\"\>", ",", "\<\"(-1, 1, 1, -1)\"\>", 
   ",", "\<\"(0, -1, 1, 1)\"\>", ",", "\<\"(1, 1, -1, 0)\"\>", 
   ",", "\<\"(-1, 2, -1, 0)\"\>", ",", "\<\"(0, -1, 2, -1)\"\>", 
   ",", "\<\"(0, 0, -1, 2)\"\>", ",", "\<\"(2, -1, 0, 0)\"\>", 
   ",", "\<\"(0, 0, 0, 0)\"\>", ",", "\<\"(0, 0, 0, 0)\"\>", 
   ",", "\<\"(0, 0, 0, 0)\"\>", ",", "\<\"(0, 0, 0, 0)\"\>", 
   ",", "\<\"(-2, 1, 0, 0)\"\>", ",", "\<\"(0, 0, 1, -2)\"\>", 
   ",", "\<\"(0, 1, -2, 1)\"\>", ",", "\<\"(1, -2, 1, 0)\"\>", 
   ",", "\<\"(-1, -1, 1, 0)\"\>", ",", "\<\"(0, 1, -1, -1)\"\>", 
   ",", "\<\"(1, -1, -1, 1)\"\>", ",", "\<\"(-1, 0, -1, 1)\"\>", 
   ",", "\<\"(1, -1, 0, -1)\"\>", ",", "\<\"(-1, 0, 0, -1)\"\>"}], 
  "}"}]], "Output",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10001.},
 ImageSize->{495, 84},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]//StandardForm=",
 CellID->1070985490],

Cell[TextData[{
 "Textbook formatting of roots as boxes in ",
 Cell[BoxData[
  ButtonBox["TraditionalForm",
   BaseStyle->"Link",
   ButtonData->"paclet:ref/TraditionalForm"]], "InlineFormula"],
 ":"
}], "ExampleText",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellID->1705940864],

Cell[BoxData[
 RowBox[{"%", "//", "TraditionalForm"}]], "Input",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellLabel->"In[6]:=",
 CellID->724947500],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    FormBox[
     TagBox[GridBox[{
        {"1", "0", "0", "1"}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {
         RowBox[{"-", "1"}], "1", "0", "1"}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {"1", "0", "1", 
         RowBox[{"-", "1"}]}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {
         RowBox[{"-", "1"}], "1", "1", 
         RowBox[{"-", "1"}]}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {"0", 
         RowBox[{"-", "1"}], "1", "1"}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {"1", "1", 
         RowBox[{"-", "1"}], "0"}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {
         RowBox[{"-", "1"}], "2", 
         RowBox[{"-", "1"}], "0"}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {"0", 
         RowBox[{"-", "1"}], "2", 
         RowBox[{"-", "1"}]}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {"0", "0", 
         RowBox[{"-", "1"}], "2"}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {"2", 
         RowBox[{"-", "1"}], "0", "0"}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {"0", "0", "0", "0"}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {"0", "0", "0", "0"}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {"0", "0", "0", "0"}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {"0", "0", "0", "0"}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {
         RowBox[{"-", "2"}], "1", "0", "0"}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {"0", "0", "1", 
         RowBox[{"-", "2"}]}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {"0", "1", 
         RowBox[{"-", "2"}], "1"}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {"1", 
         RowBox[{"-", "2"}], "1", "0"}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {
         RowBox[{"-", "1"}], 
         RowBox[{"-", "1"}], "1", "0"}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {"0", "1", 
         RowBox[{"-", "1"}], 
         RowBox[{"-", "1"}]}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {"1", 
         RowBox[{"-", "1"}], 
         RowBox[{"-", "1"}], "1"}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {
         RowBox[{"-", "1"}], "0", 
         RowBox[{"-", "1"}], "1"}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {"1", 
         RowBox[{"-", "1"}], "0", 
         RowBox[{"-", "1"}]}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {
         RowBox[{"-", "1"}], "0", "0", 
         RowBox[{"-", "1"}]}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm]}], "}"}], TraditionalForm]], "Output",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 DataCompression->False,
 ImageSize->{481, 131},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]//TraditionalForm=",
 CellID->997410006],

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["RootLevel",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/RootLevel"]], "InlineFormula"],
 " computes the level of a root, which is also used to sort the roots:"
}], "ExampleText",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10001.},
 CellID->758759793],

Cell[BoxData[
 RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"#", ",", 
       RowBox[{"RootLevel", "[", "#", "]"}]}], "}"}], "&"}], "/@", 
    RowBox[{"RootSystem", "[", "SU5", "]"}]}], ",", 
   RowBox[{"TableHeadings", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"None", ",", 
      RowBox[{"{", 
       RowBox[{"\"\<Root\>\"", ",", "\"\<Level\>\""}], "}"}]}], "}"}]}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"TableAlignments", "\[Rule]", "Center"}]}], "\[IndentingNewLine]", 
  "]"}]], "Input",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10001.},
 CellLabel->"In[8]:=",
 CellID->457052194],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnX+QldV5x5dEQLbWoEyKmRFc1rKsLjNSbBEksPyQrBSSMjY1Y0arUhqF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    "], {{0, 641}, {146, 0}}, {0, 
    255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{146, 641},
  PlotRange->{{0, 146}, {0, 641}}]], "Output",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10001.},
 ImageSize->{150, 641},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[9]//TableForm=",
 CellID->1702949654],

Cell[TextData[{
 "Spindle shape formatting with the option ",
 Cell[BoxData[
  ButtonBox["SpindleShape",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/SpindleShape"]], "InlineFormula"],
 ":"
}], "ExampleText",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10002.},
 CellID->559045901],

Cell[BoxData[
 RowBox[{"RootSystem", "[", 
  RowBox[{"SU5", ",", 
   RowBox[{"SpindleShape", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10002.},
 CellLabel->"In[10]:=",
 CellID->1949327032],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3U2IHVUWwPE3H+iYhcQRd5JJIiYRN64CmYgdzYQeyM4R3SjG4Mw24Axo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    "], {{0, 231}, {352, 
    0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{352, 231},
  PlotRange->{{0, 352}, {0, 231}}]], "Output",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10002.},
 ImageSize->{356, 231},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[11]=",
 CellID->1048241866],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->1554176470],

Cell[TextData[{
 "The command ",
 Cell[BoxData[
  ButtonBox["AlphaBasis",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/AlphaBasis"]], "InlineFormula"],
 " transforms the roots to the so called \[Alpha]-basis with the head ",
 Cell[BoxData[
  ButtonBox["RootAlpha",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/RootAlpha"]], "InlineFormula"],
 ", where the roots are expressed in terms of their components along the \
simple roots. The \[Alpha]-basis exhibits the definition of the positive \
roots as those roots with only positive entries:"
}], "ExampleText",
 CellID->1390652962],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"AlphaBasis", "[", 
   RowBox[{"RootSystem", "[", "SU5", "]"}], "]"}], "//", 
  "InputForm"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->176702185],

Cell["\<\
{RootAlpha[A][1, 1, 1, 1], 
 RootAlpha[A][0, 1, 1, 1], 
 RootAlpha[A][1, 1, 1, 0], 
 RootAlpha[A][0, 1, 1, 0], 
 RootAlpha[A][0, 0, 1, 1], 
 RootAlpha[A][1, 1, 0, 0], 
 RootAlpha[A][0, 1, 0, 0], 
 RootAlpha[A][0, 0, 1, 0], 
 RootAlpha[A][0, 0, 0, 1], 
 RootAlpha[A][1, 0, 0, 0], 
 RootAlpha[A][0, 0, 0, 0], 
 RootAlpha[A][0, 0, 0, 0], 
 RootAlpha[A][0, 0, 0, 0], 
 RootAlpha[A][0, 0, 0, 0], 
 RootAlpha[A][-1, 0, 0, 0], 
 RootAlpha[A][0, 0, 0, -1], 
 RootAlpha[A][0, 0, -1, 0], 
 RootAlpha[A][0, -1, 0, 0], 
 RootAlpha[A][-1, -1, 0, 0], 
 RootAlpha[A][0, 0, -1, -1], 
 RootAlpha[A][0, -1, -1, 0], 
 RootAlpha[A][-1, -1, -1, 0], 
 RootAlpha[A][0, -1, -1, -1], 
 RootAlpha[A][-1, -1, -1, -1]}\
\>", "Output",
 ImageSize->{182, 359},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]//InputForm=",
 CellID->1513720310]
}, Open  ]],

Cell[TextData[{
 "The command ",
 Cell[BoxData[
  ButtonBox["OrthogonalBasis",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/OrthogonalBasis"]], "InlineFormula"],
 " transforms the roots into the orthogonal basis \[LineSeparator]with the \
head ",
 Cell[BoxData[
  ButtonBox["RootOrthogonal",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/RootOrthogonal"]], "InlineFormula"],
 ", where the basis is orthogonal. The orthogonal basis is useful for the \
construction of Weyl orbits."
}], "ExampleText",
 CellID->236626885],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"OrthogonalBasis", "[", 
   RowBox[{"RootSystem", "[", "SU5", "]"}], "]"}], "//", 
  "InputForm"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1494432602],

Cell["\<\
{RootOrthogonal[A][1, 0, 0, 0, -1], 
 RootOrthogonal[A][0, 1, 0, 0, -1], 
 RootOrthogonal[A][1, 0, 0, -1, 0], 
 RootOrthogonal[A][0, 1, 0, -1, 0], 
 RootOrthogonal[A][0, 0, 1, 0, -1], 
 RootOrthogonal[A][1, 0, -1, 0, 0], 
 RootOrthogonal[A][0, 1, -1, 0, 0], 
 RootOrthogonal[A][0, 0, 1, -1, 0], 
 RootOrthogonal[A][0, 0, 0, 1, -1], 
 RootOrthogonal[A][1, -1, 0, 0, 0], 
 RootOrthogonal[A][0, 0, 0, 0, 0], 
 RootOrthogonal[A][0, 0, 0, 0, 0], 
 RootOrthogonal[A][0, 0, 0, 0, 0], 
 RootOrthogonal[A][0, 0, 0, 0, 0], 
 RootOrthogonal[A][-1, 1, 0, 0, 0], 
 RootOrthogonal[A][0, 0, 0, -1, 1], 
 RootOrthogonal[A][0, 0, -1, 1, 0], 
 RootOrthogonal[A][0, -1, 1, 0, 0], 
 RootOrthogonal[A][-1, 0, 1, 0, 0], 
 RootOrthogonal[A][0, 0, -1, 0, 1], 
 RootOrthogonal[A][0, -1, 0, 1, 0], 
 RootOrthogonal[A][-1, 0, 0, 1, 0], 
 RootOrthogonal[A][0, -1, 0, 0, 1], 
 RootOrthogonal[A][-1, 0, 0, 0, 1]}\
\>", "Output",
 ImageSize->{222, 359},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]//InputForm=",
 CellID->1299703567]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->390710272],

Cell["Root system of SO(10) in spidle shape:", "ExampleText",
 CellID->2006216530],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RootSystem", "[", 
  RowBox[{"SO10", ",", 
   RowBox[{"SpindleShape", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->2021921499],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3U9oI+mZx/HeP8TrOYRxm9zCrOxgySGXnARqh2hit1HD3LIhviTEGbJ7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    "], {{0, 387}, {526, 
    0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{526, 387},
  PlotRange->{{0, 526}, {0, 387}}]], "Output",
 ImageSize->{530, 387},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->631214785]
}, Open  ]],

Cell[TextData[{
 "Root system of the exceptional Lie algebra ",
 Cell[BoxData[
  SubscriptBox["G", "2"]], "InlineFormula"],
 ":"
}], "ExampleText",
 CellID->1218963535],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RootSystem", "[", 
  RowBox[{"G2", ",", 
   RowBox[{"SpindleShape", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->904124925],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnUtsFVUcxi+KYIkxPGJYaLDU0GJc6AqtKOUhqQQXBo3GRCIQdGFiMGiE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    "], {{0, 283}, {100, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{100, 283},
  PlotRange->{{0, 100}, {0, 283}}]], "Output",
 ImageSize->{104, 283},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->648887833]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  StyleBox[
   ButtonBox["RootLevel",
    BaseStyle->"Link",
    ButtonData->"paclet:LieART/ref/RootLevel"],
   FontFamily->"Verdana"]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["WeightSystem",
    BaseStyle->"Link",
    ButtonData->"paclet:LieART/ref/WeightSystem"],
   FontFamily->"Verdana"]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["LieART: Lie Algebras and Representation Theory",
 BaseStyle->"Link",
 ButtonData->"paclet:LieART/guide/LieART"]], "MoreAbout",
 CellID->1225539323]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"RootSystem - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "LieART: Lie Algebras and Representation Theory", ButtonData -> 
         "paclet:LieART/guide/LieART", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "Metadata" -> {
   "built" -> "{2014, 8, 6, 10, 24, 0.689578}", 
    "history" -> {"0.9", "", "", ""}, "context" -> "LieART`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Lie A R T Package Symbol", "language" -> "en", "paclet" -> 
    "LieART Package", "status" -> "None", "summary" -> 
    "RootSystem[algebra] generates the complete root system of algebra.", 
    "synonyms" -> {}, "title" -> "RootSystem", "titlemodifier" -> "", 
    "windowtitle" -> "RootSystem", "type" -> "Symbol", "uri" -> 
    "LieART/ref/RootSystem"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"9.0 for Linux x86 (64-bit) (February 7, 2013)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "9.0 for Linux x86 (64-bit) (February 7, 2013)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5282, 158, 491, 14, 29, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->2011128355]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 57094, 1404}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[603, 21, 2662, 61, 49, "AnchorBarGrid",
 CellID->1],
Cell[3268, 84, 53, 1, 42, "ObjectName",
 CellID->1224892054],
Cell[CellGroupData[{
Cell[3346, 89, 485, 15, 86, "Usage",
 CellID->982511436],
Cell[CellGroupData[{
Cell[3856, 108, 609, 18, 42, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->294176452],
Cell[4468, 128, 765, 24, 70, "Notes",
 CellID->25488050]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5282, 158, 491, 14, 29, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->2011128355],
Cell[CellGroupData[{
Cell[5798, 176, 196, 6, 25, "ExampleSection",
 CellID->1070467778],
Cell[5997, 184, 115, 3, 28, "Input",
 CellID->808202143],
Cell[6115, 189, 385, 10, 50, "ExampleText",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellID->286767578],
Cell[6503, 201, 206, 5, 28, "Input",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellID->595436105],
Cell[6712, 208, 933, 31, 393, "Output",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellID->762984660],
Cell[7648, 241, 410, 10, 50, "ExampleText",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10001.},
 CellID->1780311060],
Cell[8061, 253, 208, 5, 28, "Input",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10001.},
 CellID->72060683],
Cell[8272, 260, 1036, 20, 118, "Output",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10001.},
 CellID->1070985490],
Cell[9311, 282, 305, 9, 35, "ExampleText",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellID->1705940864],
Cell[9619, 293, 173, 4, 26, "Input",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellID->724947500],
Cell[9795, 299, 8151, 254, 165, "Output",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10000.},
 CellID->997410006],
Cell[17949, 555, 320, 8, 35, "ExampleText",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10001.},
 CellID->758759793],
Cell[18272, 565, 683, 19, 96, "Input",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10001.},
 CellID->457052194],
Cell[18958, 586, 8850, 153, 675, "Output",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10001.},
 CellID->1702949654],
Cell[27811, 741, 305, 9, 35, "ExampleText",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10002.},
 CellID->559045901],
Cell[28119, 752, 243, 6, 28, "Input",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10002.},
 CellID->1949327032],
Cell[28365, 760, 5310, 95, 252, "Output",
 CellGroupingRules->{$CellContext`GroupTogetherGrouping, 10002.},
 CellID->1048241866],
Cell[CellGroupData[{
Cell[33700, 859, 126, 3, 7, "ExampleDelimiter",
 CellID->1554176470],
Cell[33829, 864, 603, 15, 81, "ExampleText",
 CellID->1390652962],
Cell[CellGroupData[{
Cell[34457, 883, 181, 6, 28, "Input",
 CellID->176702185],
Cell[34641, 891, 860, 30, 393, "Output",
 CellID->1513720310]
}, Open  ]],
Cell[35516, 924, 540, 15, 66, "ExampleText",
 CellID->236626885],
Cell[CellGroupData[{
Cell[36081, 943, 187, 6, 28, "Input",
 CellID->1494432602],
Cell[36271, 951, 1052, 30, 393, "Output",
 CellID->1299703567]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[37372, 987, 125, 3, 7, "ExampleDelimiter",
 CellID->390710272],
Cell[37500, 992, 82, 1, 34, "ExampleText",
 CellID->2006216530],
Cell[CellGroupData[{
Cell[37607, 997, 177, 5, 28, "Input",
 CellID->2021921499],
Cell[37787, 1004, 12017, 205, 395, "Output",
 CellID->631214785]
}, Open  ]],
Cell[49819, 1212, 168, 6, 35, "ExampleText",
 CellID->1218963535],
Cell[CellGroupData[{
Cell[50012, 1222, 174, 5, 28, "Input",
 CellID->904124925],
Cell[50189, 1229, 3371, 63, 304, "Output",
 CellID->648887833]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[53633, 1300, 446, 13, 29, "SeeAlsoSection",
 CellID->1255426704],
Cell[54082, 1315, 514, 18, 56, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[54633, 1338, 448, 13, 29, "MoreAboutSection",
 CellID->38303248],
Cell[55084, 1353, 172, 3, 18, "MoreAbout",
 CellID->1225539323]
}, Open  ]],
Cell[55271, 1359, 23, 0, 44, "FooterCell"]
}
]
*)

(* End of internal cache information *)

