(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     44691,       1301]
NotebookOptionsPosition[     39432,       1126]
NotebookOutlinePosition[     41458,       1181]
CellTagsIndexPosition[     41372,       1176]
WindowTitle->WeightSystem - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["LIE A R T PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"RootSystem\"\>":>Documentation`HelpLookup[
       "paclet:LieART/ref/RootSystem"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"LieART: Lie Algebras and Representation Theory\"\>":>
       Documentation`HelpLookup["paclet:LieART/guide/LieART"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"LieART/ref/WeightSystem\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["LieART/ref/WeightSystem"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/LieART/ref/\
WeightSystem.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "LieART/ref/WeightSystem", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell["WeightSystem", "ObjectName",
 CellID->1224892054],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"WeightSystem", "[", 
       StyleBox["irrep", "TI"], "]"}]], "InlineFormula"],
     " \[LineSeparator]constructs the weight system of ",
     Cell[BoxData[
      StyleBox["irrep", "TI"]], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->216695227],

Cell[TextData[{
 Cell[BoxData[
  RowBox[{"WeightSystem", "[", 
   StyleBox["irrep", "TI"], "]"}]], "InlineFormula"],
 " also takes account for weight multiplicities."
}], "Notes",
 CellID->1067943069],

Cell["The weights are sorted by their weight level.", "Notes",
 CellID->571247868],

Cell[TextData[{
 "Options for ",
 Cell[BoxData[
  RowBox[{"WeightSystem", "[", 
   StyleBox["irrep", "TI"], "]"}]], "InlineFormula"],
 ":"
}], "Notes",
 CellID->946817991],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["SpindleShape",
     BaseStyle->"Link",
     ButtonData->"paclet:LieART/ref/SpindleShape"], 
    ButtonBox["False",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/False"], Cell["\<\
whether to displays the weight system in a spindle shape with rows for equal \
weight level\
\>", "TableText"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True}}}},
 CellID->129601386]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->1603934658],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(4)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->406570814],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<LieART`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->605671683],

Cell[TextData[{
 "Weight system of the ",
 StyleBox["8",
  FontWeight->"Bold"],
 " of SU(3):"
}], "ExampleText",
 CellID->1364839271],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"WeightSystem", "[", 
   RowBox[{
    RowBox[{"Irrep", "[", "SU3", "]"}], "[", "8", "]"}], "]"}], "//", 
  "InputForm"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1377632638],

Cell["\<\
{Weight[A][1, 1], Weight[A][-1, 2], 
 Weight[A][2, -1], Weight[A][0, 0], 
 Weight[A][0, 0], Weight[A][-2, 1], 
 Weight[A][1, -2], Weight[A][-1, -1]}\
\>", "Output",
 ImageSize->{227, 59},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]//InputForm=",
 CellID->1045326633]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", "StandardForm"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1457796020],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"(1, 1)\"\>", ",", "\<\"(-1, 2)\"\>", ",", "\<\"(2, -1)\"\>", 
   ",", "\<\"(0, 0)\"\>", ",", "\<\"(0, 0)\"\>", ",", "\<\"(-2, 1)\"\>", 
   ",", "\<\"(1, -2)\"\>", ",", "\<\"(-1, -1)\"\>"}], "}"}]], "Output",
 ImageSize->{416, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]//StandardForm=",
 CellID->474462950]
}, Open  ]],

Cell[TextData[{
 "Textbook formatting of weights as boxes in ",
 Cell[BoxData[
  ButtonBox["TraditionalForm",
   BaseStyle->"Link",
   ButtonData->"paclet:ref/TraditionalForm"]], "InlineFormula"],
 ":"
}], "ExampleText",
 CellID->1705940864],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"%", "//", "TraditionalForm"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->724947500],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    FormBox[
     TagBox[GridBox[{
        {"1", "1"}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {
         RowBox[{"-", "1"}], "2"}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {"2", 
         RowBox[{"-", "1"}]}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {"0", "0"}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {"0", "0"}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {
         RowBox[{"-", "2"}], "1"}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {"1", 
         RowBox[{"-", "2"}]}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {
         RowBox[{"-", "1"}], 
         RowBox[{"-", "1"}]}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm]}], "}"}], TraditionalForm]], "Output",
 ImageSize->{444, 23},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]//TraditionalForm=",
 CellID->1891305729]
}, Open  ]],

Cell[TextData[{
 "Spindle shape formatting with the option ",
 Cell[BoxData[
  ButtonBox["SpindleShape",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/SpindleShape"]], "InlineFormula"],
 ":"
}], "ExampleText",
 CellID->559045901],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"WeightSystem", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Irrep", "[", "SU3", "]"}], "[", "8", "]"}], ",", 
   RowBox[{"SpindleShape", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->1949327032],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnU1IVFEUx4eKLBehRbuoNNSiTSvBjEatmKCdRW6KUqytYIEKQbYKkjZB
KH3tXLQJKnCVohAoEdWmRRuptIY+kHHQDGusKS10fHfu/9735r4z+v+BMnO9
nHPuz+fcx1zOWNLUUn9+TSQSubAh/a2+sa22tbWx4/i69JO6jovnmtamH1xO
fzWnv/48/kUkEXFF2AsNADeroCtpWXINXeHQFQ5d4XisIjFYU/R36yqqGUwA
IYD5K9bVPGkDOzFXwHy6wufTFT6frvD5dIXPpyt8Pl3h81esq//3SxHsLguY
v2Jd5W2WXENXOHSFQ1c4dIUTxFvpEGEvlBBCSL7ibKvSIr+2iIwN17MMabVJ
q0c76B66wqErHLrC8eXK6Ox47ttoX1fzod1bC9cXbtlVffrawOcfWerRDGLR
zNAtJ4DrCnzPfHLkzMmWm32vPiS/T8Vf9rbs2xa9/X5WWY9mEItmg3o57lwt
Ze7zwwOlx55OKuvRDiLRbBDnKvWl79Se6K131tcVFs0GWa5SyRddsfLYjTcz
WerRDiLRbLBzlXHMFFG87pm5+vm1/9LBkuiV4UTK68eGrjTRMuv0txy319XM
aG/T3u1Hrj6bVC3NxJU+mg0SXKUmn18/tr30RM/r6Tn1LNQVFs2GHLkyOjte
/iewqerBp8wrAnWFRQt2Obxvx6ErHLrCoSscusJZ7EoInkUKwe0vhxBCiCBC
3GtCTG3tKqhQpllCTB16KNMsdIVnoSs8C13hWVaIq9n44/ZY+eaNG7dUHO14
HNeeOunmG7hyktoOr1Cz7+/W7qjq7B+bmhrr76zaeejeWNaTcv182JWj1HZ4
hJp9211ZcXY4Of8sOXx2d2VPtgNNYD7qylVqOzxCJUcayqvvxxdOBFLx+/vL
G0aS6hDAfNSVq9R2eIRKDB0uiT6Z+Pd04km09MhQtqMc/XzUlavUdvC6wkFe
NCoqu9+avGgsn2/9epWj1HZ4b0Z3/mwuA+PT0+MD6c2lTrsZ6eYb7INOUtuh
uMn5+KgtVlZcUFBcFmtHbnI0803ur1yktoP37aGEMs1CV3gWusKz0BWeJR9d
uUFUakIIIasEZ3uNFvm1RWTsmJ5lSKtNWj3aQffQFQ5d4dAVjr0ru45juKdY
O2j8Sd1ZMOzFNnblp+MY6KXSDmpDGWDYi+3zOjfrOJbmainaXmx/rgw7jkW7
0vdi+3Bl3nEs1xXUi+1RD9QgbNJxvDiyY1dBrMXfdWXbcSzxujLoxTZ25afj
WJorw15sY1d2HcdwT7F20PiTun2vhfftOHSFQ1c4dIVDVziLXQnBs0ghuP3l
EEIIyRvC3qAgwpa0gJxKVMipUE4lKuRUKKcSFXIqlFOJCjkVyqlEhZwKjSsJ
8NQYi5bHruYJ9sQqT/7rJV3h0BUOXeFkVhLsZ3QHEU2uKxBeVzh0hRDgqTEW
LY9dOUdOhXIqUSGnQjmVqJBToZxKVMipUE4lKuRUiL3hHTJhS1pd/AbzvPGZ

    "], {{0, 127}, {100, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{100, 127},
  PlotRange->{{0, 100}, {0, 127}}]], "Output",
 ImageSize->{104, 127},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->706010335]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->80628226],

Cell[TextData[{
 "Weight system of the ",
 StyleBox["10",
  FontWeight->"Bold"],
 " of SU(5):"
}], "ExampleText",
 CellID->7463236],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"WeightSystem", "[", 
  RowBox[{
   RowBox[{"Irrep", "[", "SU5", "]"}], "[", "10", "]"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1539279198],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    FormBox[
     TagBox[GridBox[{
        {"0", "1", "0", "0"}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {"1", 
         RowBox[{"-", "1"}], "1", "0"}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {
         RowBox[{"-", "1"}], "0", "1", "0"}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {"1", "0", 
         RowBox[{"-", "1"}], "1"}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {
         RowBox[{"-", "1"}], "1", 
         RowBox[{"-", "1"}], "1"}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {"1", "0", "0", 
         RowBox[{"-", "1"}]}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {
         RowBox[{"-", "1"}], "1", "0", 
         RowBox[{"-", "1"}]}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {"0", 
         RowBox[{"-", "1"}], "0", "1"}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {"0", 
         RowBox[{"-", "1"}], "1", 
         RowBox[{"-", "1"}]}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm], ",", 
    FormBox[
     TagBox[GridBox[{
        {"0", "0", 
         RowBox[{"-", "1"}], "0"}
       },
       AutoDelete->False,
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Grid"],
     TraditionalForm]}], "}"}], TraditionalForm]], "Output",
 ImageSize->{351, 77},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->1807912391]
}, Open  ]],

Cell["Weight levels for each weight:", "ExampleText",
 CellID->1137533090],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TableForm", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"#", ",", 
       RowBox[{"WeightLevel", "[", 
        RowBox[{"#", ",", 
         RowBox[{
          RowBox[{"Irrep", "[", "SU5", "]"}], "[", "10", "]"}]}], "]"}]}], 
      "}"}], "&"}], "/@", 
    RowBox[{"WeightSystem", "[", 
     RowBox[{
      RowBox[{"Irrep", "[", "SU5", "]"}], "[", "10", "]"}], "]"}]}], ",", 
   RowBox[{"TableHeadings", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"None", ",", 
      RowBox[{"{", 
       RowBox[{"\"\<Weight\>\"", ",", "\"\<Level\>\""}], "}"}]}], "}"}]}], 
   ",", 
   RowBox[{"TableAlignments", "\[Rule]", "Center"}]}], "\[IndentingNewLine]", 
  "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->462162330],

Cell[BoxData[
 FormBox[
  TagBox[
   TagBox[GridBox[{
      {
       TagBox["\<\"Weight\"\>",
        HoldForm], 
       TagBox["\<\"Level\"\>",
        HoldForm]},
      {
       FormBox[
        TagBox[GridBox[{
           {"0", "1", "0", "0"}
          },
          AutoDelete->False,
          GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
          
          GridBoxItemSize->{
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
         "Grid"],
        TraditionalForm], "0"},
      {
       FormBox[
        TagBox[GridBox[{
           {"1", 
            RowBox[{"-", "1"}], "1", "0"}
          },
          AutoDelete->False,
          GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
          
          GridBoxItemSize->{
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
         "Grid"],
        TraditionalForm], "1"},
      {
       FormBox[
        TagBox[GridBox[{
           {
            RowBox[{"-", "1"}], "0", "1", "0"}
          },
          AutoDelete->False,
          GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
          
          GridBoxItemSize->{
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
         "Grid"],
        TraditionalForm], "2"},
      {
       FormBox[
        TagBox[GridBox[{
           {"1", "0", 
            RowBox[{"-", "1"}], "1"}
          },
          AutoDelete->False,
          GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
          
          GridBoxItemSize->{
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
         "Grid"],
        TraditionalForm], "2"},
      {
       FormBox[
        TagBox[GridBox[{
           {
            RowBox[{"-", "1"}], "1", 
            RowBox[{"-", "1"}], "1"}
          },
          AutoDelete->False,
          GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
          
          GridBoxItemSize->{
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
         "Grid"],
        TraditionalForm], "3"},
      {
       FormBox[
        TagBox[GridBox[{
           {"1", "0", "0", 
            RowBox[{"-", "1"}]}
          },
          AutoDelete->False,
          GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
          
          GridBoxItemSize->{
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
         "Grid"],
        TraditionalForm], "3"},
      {
       FormBox[
        TagBox[GridBox[{
           {
            RowBox[{"-", "1"}], "1", "0", 
            RowBox[{"-", "1"}]}
          },
          AutoDelete->False,
          GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
          
          GridBoxItemSize->{
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
         "Grid"],
        TraditionalForm], "4"},
      {
       FormBox[
        TagBox[GridBox[{
           {"0", 
            RowBox[{"-", "1"}], "0", "1"}
          },
          AutoDelete->False,
          GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
          
          GridBoxItemSize->{
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
         "Grid"],
        TraditionalForm], "4"},
      {
       FormBox[
        TagBox[GridBox[{
           {"0", 
            RowBox[{"-", "1"}], "1", 
            RowBox[{"-", "1"}]}
          },
          AutoDelete->False,
          GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
          
          GridBoxItemSize->{
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
         "Grid"],
        TraditionalForm], "5"},
      {
       FormBox[
        TagBox[GridBox[{
           {"0", "0", 
            RowBox[{"-", "1"}], "0"}
          },
          AutoDelete->False,
          GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
          
          GridBoxItemSize->{
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
         "Grid"],
        TraditionalForm], "6"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Center}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {{False}}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[2.0999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {None, OutputFormsDump`HeadedColumns}],
   Function[BoxForm`e$, 
    TableForm[
    BoxForm`e$, TableHeadings -> {None, {"Weight", "Level"}}, TableAlignments -> 
     Center]]], TraditionalForm]], "Output",
 ImageSize->{149, 277},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]//TableForm=",
 CellID->66977421]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"WeightSystem", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Irrep", "[", "SU5", "]"}], "[", "10", "]"}], ",", 
   RowBox[{"SpindleShape", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->305068684],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnc2OVUUUhW/UBJmBPoBgQrdP0Ak64EdNO8YBUyDRqQmaQM94CxyocxJH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    "], {{0, 179}, {172, 
    0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{172, 179},
  PlotRange->{{0, 172}, {0, 179}}]], "Output",
 ImageSize->{176, 179},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->804852301]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->198078021],

Cell[TextData[{
 "Weight system of the ",
 StyleBox["16",
  FontWeight->"Bold"],
 " of SO(10):"
}], "ExampleText",
 CellID->1866494923],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"WeightSystem", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Irrep", "[", "D", "]"}], "[", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1"}], "]"}], ",", 
   RowBox[{"SpindleShape", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->238433849],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3buOHUUQxvHlIhkyLiEBBgmbJ7AEBJibTGwCpxgJUiRAAme8BQRATopT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    "], {{0, 283}, {204, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{204, 283},
  PlotRange->{{0, 204}, {0, 283}}]], "Output",
 ImageSize->{208, 283},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->1768852645]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->2107259517],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"WeightSystem", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Irrep", "[", "E6", "]"}], "[", "27", "]"}], ",", 
   RowBox[{"SpindleShape", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1794988287],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3c2uLGd1BuCTH4kwg+QCYiJh5wosORnwk0TOGAYMA0jJNBKJBJ75Lsgg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    "], {{0, 439}, {
    351, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{351, 439},
  PlotRange->{{0, 351}, {0, 439}}]], "Output",
 ImageSize->{355, 439},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->1106183695]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[Cell[BoxData[
 StyleBox[
  ButtonBox["RootSystem",
   BaseStyle->"Link",
   ButtonData->"paclet:LieART/ref/RootSystem"],
  FontFamily->"Verdana"]], "InlineFormula"]], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["LieART: Lie Algebras and Representation Theory",
 BaseStyle->"Link",
 ButtonData->"paclet:LieART/guide/LieART"]], "MoreAbout",
 CellID->1445339120]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"WeightSystem - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "LieART: Lie Algebras and Representation Theory", ButtonData -> 
         "paclet:LieART/guide/LieART", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "Metadata" -> {
   "built" -> "{2014, 8, 6, 10, 24, 5.473120}", 
    "history" -> {"0.9", "", "", ""}, "context" -> "LieART`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Lie A R T Package Symbol", "language" -> "en", "paclet" -> 
    "LieART Package", "status" -> "None", "summary" -> 
    "WeightSystem[irrep] constructs the weight system of irrep.", 
    "synonyms" -> {}, "title" -> "WeightSystem", "titlemodifier" -> "", 
    "windowtitle" -> "WeightSystem", "type" -> "Symbol", "uri" -> 
    "LieART/ref/WeightSystem"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"9.0 for Linux x86 (64-bit) (February 7, 2013)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "9.0 for Linux x86 (64-bit) (February 7, 2013)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5495, 170, 491, 14, 29, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->1603934658]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 41228, 1169}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[605, 21, 2580, 60, 49, "AnchorBarGrid",
 CellID->1],
Cell[3188, 83, 55, 1, 42, "ObjectName",
 CellID->1224892054],
Cell[CellGroupData[{
Cell[3268, 88, 477, 15, 86, "Usage",
 CellID->982511436],
Cell[CellGroupData[{
Cell[3770, 107, 609, 18, 42, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->216695227],
Cell[4382, 127, 200, 6, 70, "Notes",
 CellID->1067943069],
Cell[4585, 135, 82, 1, 70, "Notes",
 CellID->571247868],
Cell[4670, 138, 171, 7, 70, "Notes",
 CellID->946817991],
Cell[4844, 147, 602, 17, 70, "3ColumnTableMod",
 CellID->129601386]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5495, 170, 491, 14, 29, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->1603934658],
Cell[CellGroupData[{
Cell[6011, 188, 195, 6, 25, "ExampleSection",
 CellID->406570814],
Cell[6209, 196, 115, 3, 28, "Input",
 CellID->605671683],
Cell[6327, 201, 133, 6, 34, "ExampleText",
 CellID->1364839271],
Cell[CellGroupData[{
Cell[6485, 211, 209, 7, 28, "Input",
 CellID->1377632638],
Cell[6697, 220, 317, 10, 93, "Output",
 CellID->1045326633]
}, Open  ]],
Cell[CellGroupData[{
Cell[7051, 235, 105, 3, 26, "Input",
 CellID->1457796020],
Cell[7159, 240, 396, 9, 50, "Output",
 CellID->474462950]
}, Open  ]],
Cell[7570, 252, 241, 8, 35, "ExampleText",
 CellID->1705940864],
Cell[CellGroupData[{
Cell[7836, 264, 107, 3, 26, "Input",
 CellID->724947500],
Cell[7946, 269, 2678, 86, 57, "Output",
 CellID->1891305729]
}, Open  ]],
Cell[10639, 358, 239, 8, 35, "ExampleText",
 CellID->559045901],
Cell[CellGroupData[{
Cell[10903, 370, 241, 7, 28, "Input",
 CellID->1949327032],
Cell[11147, 379, 2017, 41, 148, "Output",
 CellID->706010335]
}, Open  ]],
Cell[CellGroupData[{
Cell[13201, 425, 124, 3, 7, "ExampleDelimiter",
 CellID->80628226],
Cell[13328, 430, 131, 6, 34, "ExampleText",
 CellID->7463236],
Cell[CellGroupData[{
Cell[13484, 440, 173, 5, 28, "Input",
 CellID->1539279198],
Cell[13660, 447, 3485, 110, 98, "Output",
 CellID->1807912391]
}, Open  ]],
Cell[17160, 560, 74, 1, 34, "ExampleText",
 CellID->1137533090],
Cell[CellGroupData[{
Cell[17259, 565, 782, 24, 113, "Input",
 CellID->462162330],
Cell[18044, 591, 4982, 164, 311, "Output",
 CellID->66977421]
}, Open  ]],
Cell[CellGroupData[{
Cell[23063, 760, 241, 7, 28, "Input",
 CellID->305068684],
Cell[23307, 769, 2684, 52, 200, "Output",
 CellID->804852301]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[26040, 827, 125, 3, 7, "ExampleDelimiter",
 CellID->198078021],
Cell[26168, 832, 135, 6, 34, "ExampleText",
 CellID->1866494923],
Cell[CellGroupData[{
Cell[26328, 842, 293, 8, 45, "Input",
 CellID->238433849],
Cell[26624, 852, 3970, 73, 304, "Output",
 CellID->1768852645]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[30643, 931, 126, 3, 7, "ExampleDelimiter",
 CellID->2107259517],
Cell[CellGroupData[{
Cell[30794, 938, 241, 7, 28, "Input",
 CellID->1794988287],
Cell[31038, 947, 6959, 122, 460, "Output",
 CellID->1106183695]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[38070, 1077, 446, 13, 29, "SeeAlsoSection",
 CellID->1255426704],
Cell[38519, 1092, 211, 6, 56, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[38767, 1103, 448, 13, 29, "MoreAboutSection",
 CellID->38303248],
Cell[39218, 1118, 172, 3, 18, "MoreAbout",
 CellID->1445339120]
}, Open  ]],
Cell[39405, 1124, 23, 0, 44, "FooterCell"]
}
]
*)

(* End of internal cache information *)

