(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     20929,        666]
NotebookOptionsPosition[     16677,        528]
NotebookOutlinePosition[     18697,        583]
CellTagsIndexPosition[     18612,        578]
WindowTitle->YoungTableau - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["LIE A R T SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Irrep\"\>":>Documentation`HelpLookup[
       "paclet:ref/Irrep"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"LieART: Lie Algebras and Representation Theory\"\>":>
       Documentation`HelpLookup["paclet:LieART/guide/LieART"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"LieART/ref/YoungTableau\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["LieART/ref/YoungTableau"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/LieART/ref/\
YoungTableau.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "LieART/ref/YoungTableau", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell["YoungTableau", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"YoungTableau", "[", 
       StyleBox["irrep", "TI"], "]"}]], "InlineFormula"],
     " \[LineSeparator]displays the Young tableau associated with ",
     Cell[BoxData[
      StyleBox["irrep", "TI"]], "InlineFormula"],
     ". "
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->168689819],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->398668960],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<LieART`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1675109142],

Cell["Young tableau of the fundamental representation of SU(3):", \
"ExampleText",
 CellID->1162652582],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"YoungTableau", "[", 
  RowBox[{
   RowBox[{"Irrep", "[", "SU3", "]"}], "[", "3", "]"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->111580144],

Cell[BoxData[
 FormBox[
  TagBox[GridBox[{
     {
      ItemBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{},
          BaselinePosition->(Scaled[0.] -> Baseline),
          ImageSize->{10, 10}],
         CacheGraphics->False],
        Spacer[{10, 10}]],
       Frame->GrayLevel[0],
       StripOnInput->False]},
     {""}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"], TraditionalForm]], "Output",
 ImageSize->{25, 40},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1875087903]
}, Open  ]],

Cell[TextData[{
 "Young tableau of the ",
 StyleBox["8",
  FontWeight->"Bold"],
 " of SU(3):"
}], "ExampleText",
 CellID->1432395328],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"YoungTableau", "[", 
  RowBox[{
   RowBox[{"Irrep", "[", "SU3", "]"}], "[", "8", "]"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->307878838],

Cell[BoxData[
 FormBox[
  TagBox[GridBox[{
     {
      ItemBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{},
          BaselinePosition->(Scaled[0.] -> Baseline),
          ImageSize->{10, 10}],
         CacheGraphics->False],
        Spacer[{10, 10}]],
       Frame->GrayLevel[0],
       StripOnInput->False], 
      ItemBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{},
          BaselinePosition->(Scaled[0.] -> Baseline),
          ImageSize->{10, 10}],
         CacheGraphics->False],
        Spacer[{10, 10}]],
       Frame->GrayLevel[0],
       StripOnInput->False]},
     {
      ItemBox[
       InterpretationBox[
        StyleBox[
         GraphicsBox[{},
          BaselinePosition->(Scaled[0.] -> Baseline),
          ImageSize->{10, 10}],
         CacheGraphics->False],
        Spacer[{10, 10}]],
       Frame->GrayLevel[0],
       StripOnInput->False], ""}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"], TraditionalForm]], "Output",
 ImageSize->{44, 43},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->639502317]
}, Open  ]],

Cell[TextData[{
 "Young tableau of the ",
 StyleBox["27",
  FontWeight->"Bold"],
 " of SU(3):"
}], "ExampleText",
 CellID->1432051384],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"YoungTableau", "[", 
  RowBox[{
   RowBox[{"Irrep", "[", "SU3", "]"}], "[", "27", "]"}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->215628636],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztkMEJwkAUBRfNwTY8W4UpwEOsIAG9ClGQVK9rCxvmB/kzsGFzGB6zx+kx
3HellOehfobxfZ7ncbl29adfXrdpXy+nei71/O6fNJRMrHmlPxItpXfjRUvp
3XjRUno3XrSU3o0XLaV340VL6d140VJ6N160lN6NFy2ld+PFVKV5aHullS/c
PNqMpahrKYqlqGspiqWoaymKpahrKYqlqGspiqWou1XpJsSX5uELDLka9g==

    "], {{0, 43}, {78, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{78, 43},
  PlotRange->{{0, 78}, {0, 43}}]], "Output",
 ImageSize->{82, 43},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->1039935237]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->1080960655],

Cell[TextData[{
 "Young tableau of the ",
 StyleBox["720",
  FontWeight->"Bold"],
 " of SU(5):"
}], "ExampleText",
 CellID->381847914],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"YoungTableau", "[", 
  RowBox[{
   RowBox[{"Irrep", "[", "A", "]"}], "[", 
   RowBox[{"1", ",", "2", ",", "0", ",", "1"}], "]"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1550153586],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztmUFKQzEUAD+1i17Do9gjtCdoQbdCLZRuvPo3ihtB3IVxYAbyyd8MZJLd
ezy/Hl42y7K87cbncLo9XS6n+3E7fvb36/P5YWyOY72P9blfA2IJjtk3m/xX
eeUpeeUpeeUpeeUpeeUpeeUpeeUpeeUpeeUpeeUpeeUpeeUpeeUpeeUpeeUp
eeUpeeUpeeUpeeUpeYDMu9lV/iznye1+r9zu98rtfq/c7vfK7X6v3O73yu1+
r9zu98rtfq/c7vfK7X6v3O73yu1+r9zu98rtfq/c7vfK7X6v3O73ytdGsX8y
u7za76XyFJWnqDxF5SkqT1F5ispTVJ6i8hSVp6g8ReUpKk9ReYrKU1SeovIU
laeYOcb8hj7iP6U3T1F5ispTVJ6i8hSVp6g8ReUpKk9ReYrKU1SeovIUlaeo
PEXlKSpPUXmKuYPAL+gjRvzgAwEOZVo=
    "], {{0, 83}, {126, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{126, 83},
  PlotRange->{{0, 126}, {0, 83}}]], "Output",
 ImageSize->{130, 83},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->2078310027]
}, Open  ]],

Cell["Young tableau of the of the SU(5) singlet:", "ExampleText",
 CellID->1738899181],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"YoungTableau", "[", 
  RowBox[{
   RowBox[{"Irrep", "[", "A", "]"}], "[", 
   RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "]"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1556612880],

Cell[BoxData[
 FormBox[
  TemplateBox[{"\"\[FilledSmallCircle]\""},
   "Row",
   DisplayFunction->(#& ),
   InterpretationFunction->(RowBox[{"Row", "[", 
      RowBox[{"{", #, "}"}], "]"}]& )], TraditionalForm]], "Output",
 ImageSize->{12, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1381324172]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Applications",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->258228157],

Cell["\<\
Display Young tableaux of SU(4) irreps with a maximum of one column per box \
count:\
\>", "ExampleText",
 CellID->1293870584],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Row", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Row", "[", 
      RowBox[{"{", 
       RowBox[{"#", ",", "\"\<: \>\"", ",", 
        RowBox[{"YoungTableau", "[", "#", "]"}]}], "}"}], "]"}], "&"}], "/@", 
    
    RowBox[{"SortBy", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Irrep", "[", "A", "]"}], "@@@", 
       RowBox[{"Tuples", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}], ",", "3"}], "]"}]}], ",", "Dim"}], 
     "]"}]}], ",", "\"\<, \>\""}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->794726788],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztm2tsU2UYx9utazs2xmAwQRgDxwZOgZiIyHVIBvJBETHoAsgYcjPACBdF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    "], {{0, 63}, {555, 
    0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{555, 63},
  PlotRange->{{0, 555}, {0, 63}}]], "Output",
 ImageSize->{559, 63},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->105812741]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[Cell[BoxData[
 StyleBox[
  ButtonBox["Irrep",
   BaseStyle->"Link",
   ButtonData->"paclet:ref/Irrep"],
  FontFamily->"Verdana"]], "InlineFormula"]], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["LieART: Lie Algebras and Representation Theory",
 BaseStyle->"Link",
 ButtonData->"paclet:LieART/guide/LieART"]], "MoreAbout",
 CellID->1267104300]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"YoungTableau - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "LieART: Lie Algebras and Representation Theory", ButtonData -> 
         "paclet:LieART/guide/LieART", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "Metadata" -> {
   "built" -> "{2014, 8, 6, 10, 24, 8.290936}", 
    "history" -> {"0.9", "", "", ""}, "context" -> "LieART`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Lie A R T Symbol", "language" -> "en", "paclet" -> "LieART", "status" -> 
    "None", "summary" -> 
    "YoungTableau[irrep] displays the Young tableau associated with irrep. ", 
    "synonyms" -> {}, "title" -> "YoungTableau", "titlemodifier" -> "", 
    "windowtitle" -> "YoungTableau", "type" -> "Symbol", "uri" -> 
    "LieART/ref/YoungTableau"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"9.0 for Linux x86 (64-bit) (February 7, 2013)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "9.0 for Linux x86 (64-bit) (February 7, 2013)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[3735, 105, 490, 14, 29, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->168689819]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 18469, 571}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[605, 21, 2555, 60, 49, "AnchorBarGrid",
 CellID->1],
Cell[3163, 83, 55, 1, 42, "ObjectName",
 CellID->1224892054],
Cell[3221, 86, 489, 15, 86, "Usage",
 CellID->982511436],
Cell[CellGroupData[{
Cell[3735, 105, 490, 14, 29, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->168689819],
Cell[CellGroupData[{
Cell[4250, 123, 195, 6, 25, "ExampleSection",
 CellID->398668960],
Cell[4448, 131, 116, 3, 28, "Input",
 CellID->1675109142],
Cell[4567, 136, 103, 2, 34, "ExampleText",
 CellID->1162652582],
Cell[CellGroupData[{
Cell[4695, 142, 171, 5, 28, "Input",
 CellID->111580144],
Cell[4869, 149, 673, 24, 61, "Output",
 CellID->1875087903]
}, Open  ]],
Cell[5557, 176, 133, 6, 34, "ExampleText",
 CellID->1432395328],
Cell[CellGroupData[{
Cell[5715, 186, 171, 5, 28, "Input",
 CellID->307878838],
Cell[5889, 193, 1246, 44, 64, "Output",
 CellID->639502317]
}, Open  ]],
Cell[7150, 240, 134, 6, 34, "ExampleText",
 CellID->1432051384],
Cell[CellGroupData[{
Cell[7309, 250, 172, 5, 28, "Input",
 CellID->215628636],
Cell[7484, 257, 729, 20, 64, "Output",
 CellID->1039935237]
}, Open  ]],
Cell[CellGroupData[{
Cell[8250, 282, 126, 3, 7, "ExampleDelimiter",
 CellID->1080960655],
Cell[8379, 287, 134, 6, 34, "ExampleText",
 CellID->381847914],
Cell[CellGroupData[{
Cell[8538, 297, 214, 6, 256, "Input",
 CellID->1550153586],
Cell[8755, 305, 948, 23, 104, "Output",
 CellID->2078310027]
}, Open  ]],
Cell[9718, 331, 86, 1, 154, "ExampleText",
 CellID->1738899181],
Cell[CellGroupData[{
Cell[9829, 336, 214, 6, 256, "Input",
 CellID->1556612880],
Cell[10046, 344, 353, 11, 35, "Output",
 CellID->1381324172]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10460, 362, 274, 8, 57, "ExampleSection",
 CellID->258228157],
Cell[10737, 372, 136, 4, 70, "ExampleText",
 CellID->1293870584],
Cell[CellGroupData[{
Cell[10898, 380, 596, 20, 70, "Input",
 CellID->794726788],
Cell[11497, 402, 3774, 70, 70, "Output",
 CellID->105812741]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[15332, 479, 446, 13, 45, "SeeAlsoSection",
 CellID->1255426704],
Cell[15781, 494, 194, 6, 56, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[16012, 505, 448, 13, 77, "MoreAboutSection",
 CellID->38303248],
Cell[16463, 520, 172, 3, 153, "MoreAbout",
 CellID->1267104300]
}, Open  ]],
Cell[16650, 526, 23, 0, 44, "FooterCell"]
}
]
*)

(* End of internal cache information *)

